#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>

using namespace std;

#define READY false
#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000

ifstream f("calendar.dat");
ofstream g("calendar.sol");

int main()
{
	int n, tmp;
	f >> n;

	vector<int> a(n), b(n);
	FOR(i,0,n-1)
	{
		f >> tmp;
		tmp--;
		a[tmp] = i;
	}
	FOR(i,0,n-1)
	{
		f >> tmp;
		tmp--;
		b[tmp] = i;
	}
	vector<int> l, r;
	FOR(i, 0, n-1)
		if (a[i] - b[i] > 0 )
		{
			r.push_back(a[i]-b[i]);
			l.push_back(n-a[i]+b[i]);
		}
		else
		{
			if (a[i] - b[i] < 0)
			{
				r.push_back(n-b[i]+a[i]);
				l.push_back(b[i]-a[i]);
			}
			else
			{
				r.push_back(0);
				l.push_back(0);
			}
		}
	int maxl = 0, maxr = 0;
	vector<int> c(n), d(n);
	FOR(i,0,n-1)
	{
		c[l[i]]++;
		d[r[i]]++;
	}
	FOR(i,0,n-1)
	{
		if (c[i]>maxl)
			maxl =c[i];
		if (d[i]>maxr)
			maxr = c[i];
	}
	g << max(maxl,maxr);
	f.close();
	g.close();
	return 0;
}