#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>

using namespace std;

#define READY false
#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000

ifstream f("stones.dat");
ofstream g("stones.sol");

bool compare(int a, int b)
{
	return a < b;
}

int n,m;
vector< priority_queue<int> > t;

void getMoney()
{
	int max = -1;
	int maxn = -1;
	FOR(i,1,t.size()-1)
		if (max == -1 || t[i].top() < max)
		{
			max  = t[i].top();
			maxn = i;
		}
	t[maxn].pop();
	g << INF - max << endl;
}

int main()
{

	f >> n >> m;
	int tmp, tmp1, tmp2;
	t.resize(m+1);
	set<int> a;

	FOR(i,1,n)
	{
		f >> tmp;
		if (tmp == 1)
		{
			f >> tmp1 >> tmp2;
			t[tmp1].push(INF - tmp2);
		}
		else
			getMoney();
	}

	f.close();
	g.close();
	return 0;
}