#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000
ifstream f("tetris.dat");
ofstream g("tetris.sol");

vector <int> a;
vector <int> b;
vector <int> c;
vector <vector <int> > z;

int main()
{
	int n;
	f >> n;
	a.resize(n);
	b.resize(n);
	c.resize(n);
	z.resize(n);
	fill(z.begin(), z.end(), vector<int> (n,0));
	FOR(i,0,n-1)
		f >> a[i];
	FOR(i,0,n-1)
	{
		f >> b[i];
		if (a[i] - b[i] <= 0)
			c[i] = -(a[i] - b[i]);
		else
			c[i] = 4 - a[i] + b[i];
		z[i][i] = c[i];
	}
	FOR(y,1,n-1)
		for(int  i = 0, j = i + y; i < n && j < n; i++, j++)
			if (y == 1)
				z[i][j] = max(z[i+1][j], z[i][j-1]);
			else
			{
				if (z[i+1][j-1] < z[i+1][j] && z[i+1][j-1] < z[i][j-1])
					z[i][j] = z[i][j-1]-z[i+1][j-1]+z[i+1][j];
				else
					z[i][j] = max(max(z[i+1][j-1], z[i+1][j]), z[i][j-1]);
			}
			g << z[0][n-1];
	f.close();
	g.close();
	return 0;
}