#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <cstring>
using namespace std;
const int INF=1000000000000000000ll;
void tp(int n, int m){
     char r[n][n];
     memset(r,false,sizeof r);
     vector<int > used(n,false);
     long long g[n][n];
     for(int i=0;i<m;i++){
             int t,a,b;
             long long c;
             cin>>t>>a>>b>>c;
             a--;
             b--;
             if (t==1){
                       g[a][b]=min(g[a][b],c);
                       r[a][b]=true;
             }
             else{
                  for(int j=0;j<n;j++){
                          if (r[a][j]){
                                       g[b][j]=min(g[b][j],g[a][j]+c);
                                       r[b][j]=true;
                          }
                  }
             }
     }
     vector<long long > d(n,INF);
     d[0]=0;
     for(int i=0;i<n;i++){
             int k;
             long long min=INF;
             for(int j=0;j<n;j++)
                     if (!used[j] && d[j]<min){
                                  k=j;
                                  min=d[j];
                     }
             used[k]=true;
             for(int j=0;j<n;j++){
                     if (r[k][j] && d[j]>min+g[k][j]) d[j]=min+g[k][j];
             }
     }
     for(int i=1;i<n;i++){
            if (d[i]==INF) cout<<"-1\n";
            else cout<<d[i]<<"\n";
     }
}
int main(){
    freopen("olympair.dat","r",stdin);
    freopen("olympair.sol","w",stdout);
    int n,m;
    cin>>n>>m;
    if (n<2001){
                tp(n,m);
                return 0;
    }
    vector<long long > g[n], C[n];
    vector<char > used(n, false);
    for(int i=0;i<m;i++){
            int t,a,b,c;
            cin>>t>>a>>b>>c;
            a--;
            b--;
            if (t==1){
                      g[a].push_back(b);
                      C[a].push_back(c);
            }
            else{
                 for(int j=0;j<g[a].size();j++){
                         g[b].push_back(g[a][j]);
                         C[b].push_back(c);
                 }
            }
    }
    priority_queue<pair<long long, int >, vector<pair<long long, int > >, greater<pair<long long, int > > > S;
    vector<long long > d(n);
    for(int i=1;i<n;i++){
            d[i]=INF;
            S.push(make_pair(d[i],i));
    }
    d[0]=0;
    S.push(make_pair(0,0));
    while (!S.empty()){
          long long q=S.top().first;
          int k=S.top().second;
          S.pop();
          if (used[k]) continue;
          used[k]=true;
          for(int i=0;i<g[k].size();i++){
                  int to=g[k][i], c=C[k][i];
                  if (d[to]>q+c){
                                 d[to]=q+c;
                                 S.push(make_pair(d[to],to));
                  }
          }
    }
    for(int i=1;i<n;i++){
            if (d[i]==INF) cout<<"-1\n";
            else cout<<d[i]<<"\n";
    }
}
