#pragma comment( linker, "/STACK:333335556" )
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <memory.h>
using namespace std;

struct sBlock
{
	int a;
	int b;
};

int main()
{
	FILE *inf = fopen( "tetris.dat", "r" );
	FILE *outf = fopen( "tetris.sol", "w" );

	int N;
	fscanf( inf, "%d\n", &N );

	int s[ 1005 ];
	int f[ 1005 ];
	int d[ 1005 ];

	for( int i = 1; i <= N; i++ )
		fscanf( inf, "%d", &s[i] );

	for( int i = 1; i <= N; i++ )
		fscanf( inf, "%d", &f[i] );

	for( int i = 1; i <= N; i++ )
		d[i] = f[i] - s[i];

	int res = 0;

	while( true )
	{
		sBlock blocks[ 100500 ];
		int num = 0;
		for( int i = 1; i <= N; i++ )
		{
			if( d[i] != 0 )
			{
				num++;
				blocks[num].a = i;
				blocks[num].b = N;
				for( int j = i + 1; j <= N; j++ )
				{
					if( d[j] == 0 )
					{
						blocks[num].b = j - 1;
						break;
					}
				}
				i = blocks[num].b;
			}
		}
		if( num == 0 )
			break;
		for( int i = 1; i <= num; i++ )
		{
			for( int j = blocks[i].a; j <= blocks[i].b; j++ )
			{
				d[j]--;
				if( d[j] == -4 )
					d[j] = 0;
			}
			res++;
		}
	}

	fprintf( outf, "%d\n", res );

	fclose( inf );
	fclose( outf );
}
