#include <iostream>
#include <cstdio>
#include <vector>
#include <map>

using namespace std;

#define problem "calendar"

const int MAX_N = ((int) 1e5) + 1;

int n, cur, res = 0;
int a[MAX_N], b[MAX_N];
map<int, int> shift;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> cur;
        a[cur - 1] = i;
    }

    for (int i = 0; i < n; ++i) {
        cin >> cur;
        b[cur - 1] = i;
    }


    for (int i = 0, f, s; i < n; ++i) {
        f = a[i];
        s = b[i];

        if (f >= s)
            ++shift[f - s];
        else
            ++shift[(n - s) + f];
    }

    map<int, int>::iterator iter = shift.begin();

    for (; iter != shift.end(); ++iter) {
        res = max(res, iter->second);
    }

    cout << res;

    return 0;
}
