#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define problem "stones"

const int MAX_N = 2 * ((int) 1e5);

int n, m;
set<int> stone[MAX_N];
set< pair<int, int> > best;
pair<int, int> pr;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    for (int i = 0, type, f, s, s_l; i < n; ++i) {
        scanf("%d", &type);

        if (type == 1) {
            scanf("%d %d\n", &f, &s);
            --f;
            s_l = *stone[f].begin();
            if (stone[f].empty() || (s_l > s)) {
                if (!stone[f].empty())
                    best.erase(make_pair(s_l, f));
                best.insert(make_pair(s, f));
            }

            stone[f].insert(s);
        } else {
            scanf("\n");
            pr = *best.rbegin();

            best.erase(pr);
            stone[pr.second].erase(pr.first);

            if (!stone[pr.second].empty())
                best.insert(make_pair(*stone[pr.second].begin(), pr.second));

            printf("%d\n", pr.first);
        }
    }

    return 0;
}
