#include <fstream>
#include <iostream>

using namespace std;

main()
{
    ifstream in("olympair.dat");
    ofstream out("olympair.sol");
    int code, A, B, C;

    int n, m;
    cin >> n >> m;
    int S[n][n];
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            S[i][j] = 0;

    int lbl[n];
    for(int y = 0; y < n; y++)
        lbl[y] = 0;

    for(int i = 0; i < m; i++)
    {
        cin >> code;
        switch(code)
        {
        case 1:
            cin >> A >> B >> C;
            S[A-1][B-1] = C;
            break;
        case 2:
            cin >> A >> B >> C;
            for(int i = 0; i < n; i++)
            {
                if(S[A-1][i] == 0)
                    continue;
                S[B-1][i] = S[A-1][i] + C;
            }
        }
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            if(S[i][j] == 0)
                continue;
            if(S[i][j] + lbl[i] < lbl[j] || lbl[j] == 0)
                lbl[j] = S[i][j] + lbl[i];
        }
    }

    for(int i = 1; i < n; i++)
    {
        if(lbl[i] == 0)
            cout << -1;
        else
            cout << lbl[i];
        cout << '\n';
    }
    return 0;
}
























