#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

int getPosition(int target, vector<int> &numbers) {
    for (int i = 0; i < numbers.size(); i++)
        if (numbers[i] == target)
            return i;
}

int getLength(int target, vector<int> &numbers) {
    int length = 0;
    for (int i = 0; i < numbers.size(); i++)
        if (target == numbers[i])
            length = i-getPosition(target, numbers);
    return length;
}

int getNumOfMaxLength(vector<int> &numbers) {
    int length = -1;
    int a = 0;
    for (int i = 0; i < numbers.size(); i++) {
        if (getLength(numbers[i], numbers) > length || length == -1) {
            a = i;
            length = getLength(numbers[i], numbers);
        }
    }
    swap(numbers[a], numbers[a+length-1]);
    return length;
}

bool check(vector<int> &numbers) {
    for (int i = 0; i < numbers.size(); i++) {
        for (int j = i+1; j < numbers.size(); j++) {
            if (numbers[i] == numbers[j] && numbers[j-1] != numbers[j])
                return false;
        }
    }
    return true;
}

int main()
{
    freopen("mutation.dat", "r", stdin);
    freopen("mutation.sol", "w", stdout);

    int n = 0;
    int amount = 0;
    vector<int> numbers;
    cin >> n;

    for (int i = 0; i < n; i++) {
        int a = 0;
        cin >> a;
        numbers.push_back(a);
    }
    //cout << getNumOfMaxLength(numbers);

    while (!check(numbers)) {
        getNumOfMaxLength(numbers);
        amount++;
    }
    cout << amount;
}
