#include <iostream>
#include <vector>
#include <stdio.h>

using namespace std;

class Station {
public:
    bool visited;
    int index;
    int number;
    vector<Station> neighbours;
};

void findWays(int number, vector<Station> &sts) {
    Station &a = sts[number];
    a.visited = true;
    if (number == 0)
        a.index = 0;
    for (int i = 0; i < a.neighbours.size(); i++) {
        if (a.neighbours[i].index+a.index < sts[a.neighbours[i].number].index || sts[a.neighbours[i].number].index == -1) {
            sts[a.neighbours[i].number].index = a.neighbours[i].index+a.index;
        }
    }
    for (int i = 0; i < a.neighbours.size(); i++) {
        if (!sts[a.neighbours[i].number].visited)
            findWays(a.neighbours[i].number, sts);
    }
}



int main()
{
    freopen("olympair.dat", "r", stdin);
    freopen("olympair.sol", "w", stdout);

    int n = 0;
    int m = 0;
    cin >> n >> m;
    vector<Station> sts;

    for (int i = 0; i < n; i++) {
        Station a;
        a.index = -1;
        a.number = i;
        a.visited = false;
        sts.push_back(a);
    }

    for (int i = 0; i < m; i++) {
        int type = 0;
        cin >> type;
        if (type == 1) {
            int a = 0;
            int b = 0;
            int time = 0;
            cin >> a >> b >> time;
            Station ba;
            ba.number = b-1;
            ba.index = time;
            sts[a-1].neighbours.push_back(ba);
        }
        else {
            int a = 0;
            int b = 0;
            int time = 0;
            cin >> a >> b >> time;
            for (int j = 0; j < sts[a-1].neighbours.size(); j++) {
                Station &ba = sts[b-1];
                Station n;
                n.number = sts[a-1].neighbours[j].number;
                n.index = sts[a-1].neighbours[j].index+time;
                ba.neighbours.push_back(n);
            }
        }
    }

    findWays(0, sts);

    for (int i = 1; i < sts.size(); i++) {
        cout << sts[i].index << endl;
    }


}
