#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

int x = 0;
int y = 0;
int xOfBegin = 0;
int yOfBegin = 0;

class Field{
public:
    char field[1000][1000];
};

int findWay(Field &f, int x1, int y1, int way) {
    if (f.field[x1][y1] == '+')
        return way;

    if (x1+1 < x && y1 < y && f.field[x1+1][y1+1] == 'x') {
        f.field[x1+1][y1+1] = '.';
        int w = findWay(f, x1+1, y1+1, way);
        if (w != -1)
            return w;
    }
    else if (x1-1 >= 0 && y1-1 >= 0 && f.field[x1-1][y1-1] == 'x') {
        f.field[x1-1][y1-1] = '.';
        int w = findWay(f, x1-1, y1-1, way);
        if (w != -1)
            return w;
    }
    else if (x1+1 < x && f.field[x1+1][y1] == 'x') {
        f.field[x1+1][y1] = '.';
        int w = findWay(f, x1+1, y1, way);
        if (w != -1)
            return w;
    }
    else if (x1-1 >= f.field[x1-1][y1] == 'x') {
        f.field[x1-1][y1] = '.';
        int w = findWay(f, x1-1, y1, way);
        if (w != -1)
            return w;
    }
    else if (y1+1 < y && f.field[x1][y1+1] == 'x') {
        f.field[x1][y1+1] = '.';
        int w = findWay(f, x1, y1+1, way);
        if (w != -1)
            return w;
    }
    else if (y1-1 >= 0 && f.field[x1][y1-1] == 'x') {
        f.field[x1][y1-1] = '.';
        int w = findWay(f, x1, y1-1, way);
        if (w != -1)
            return w;
    }

    return -1;
}

int main()
{
    freopen("smt.dat", "r", stdin);
    //freopen("smt.sol", "w", stdout);

    cin >> x >> y;

    Field f;

    for (int i = 0; i < x; i++) {
        for (int j = 0; j < y; j++) {
            cin >> f.field[i][j];
            cout << f.field[i][j] << " ";
            if (f.field[i][j] == 'o') {
                xOfBegin = j;
                yOfBegin = i;

            }
        }
        cout << endl;
    }
    cout << endl << yOfBegin << " " << xOfBegin << endl;

    cout << findWay(f, xOfBegin, yOfBegin, 0);


}
