#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <time.h>
#include <queue>
#include <set>
using namespace std;
#define TComb pair < pair <vector <int>, int>, pair <int,int> >
#define All(x) x.begin(),x.end()
#define ll long long
#define ull unsigned ll
#define mp make_pair
#define pb push_back
#define fi first
#define se second

const int Nmax = 1010;
const int Inf = (int)1e9;

int n;
vector <int> Corr, St;
queue <TComb> Q;
TComb Cur, toPush;
set <TComb> Was;

bool correct()
{
	for (int i = 0; i < n; ++i)
		if (Cur.fi.fi[i] != Corr[i])
			return 0;
	return 1;
}

int main()
{
	freopen("tetris.dat","r",stdin); freopen("tetris.sol","w",stdout);
	scanf("%d",&n); Corr.resize(n); St.resize(n);
	for (int i = 0; i < n; ++i) scanf("%d",&St[i]);
	for (int i = 0; i < n; ++i) scanf("%d",&Corr[i]);
	Q.push(mp(mp(St,0),mp(0,0)));
	while (1)
	{
		Cur = Q.front(); Q.pop();
		for (int i = Cur.se.se; i < Cur.se.se+Cur.se.fi; ++i)
			Cur.fi.fi[i] = (Cur.fi.fi[i] + 1) % 4;
		if (correct())
		{
			printf("%d\n",Cur.fi.se);
			//system("pause");
			return 0;
		}
		for (int len = 1; len <= n; ++len)
		{
			for (int st = 0; st <= n-len; ++st)
			{
				toPush = mp(mp(Cur.fi.fi, Cur.fi.se+1), mp(len, st));
				if (Was.find(toPush) == Was.end())
				{
					Q.push(toPush);
					Was.insert(toPush);
				}
			}
		}
	}
}