#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <queue>

using namespace std;

struct pp{
	int n, m;
	pp() {}
	pp(int n, int m) : n(n), m(m) {}
};
const int QQ = 1000000;

int aa[1000][1000], st[QQ];
pp q[QQ];

int main()
{
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	int n, m;
	//cin >> n >> m;
	scanf("%d%d", &n, &m);
	vector<set<int> > h(n), v(m);
	int fn, fm, sn, sm;
	char c;
	scanf("%c", &c);
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			scanf("%c", &c);
			if (c == '+')
			{
				fn = i;
				fm = j;
				//h[0][i].push_back(j);
				//v[0][j].push_back(i);
				h[i].insert(j);
				v[j].insert(i);
			}
			else if (c == 'o')
			{
				sn = i;
				sm = j;
			}
			else if (c == 'x')
			{
				//h[0][i].push_back(j);
				//v[0][j].push_back(i);
				h[i].insert(j);
				v[j].insert(i);
			}
		}
		scanf("%c", &c);
	}
	int qh = 0, qt = 0;
	q[qt++] = pp(sn, sm);
	int T = 0;
	while (qh < qt)
	{
		pp z = q[qh++];
		int zn = z.n;
		int zm = z.m;
		int X = aa[zn][zm] + 1;
		int sth = 0, stt = 0;
		for (set<int>::const_iterator si = h[zn].begin(); si != h[zn].end(); ++si)
		{
			aa[zn][*si] = X;
			if (zn == fn && *si == fm)
			{
				printf("%d\n", X);
				return 0;
			}
			q[qt++] = pp(zn, *si);
			v[*si].erase(v[*si].find(zn));
			st[stt++] = *si;
		}
		//while (sth < stt)
		//	h[zn].erase(h[zn].find(st[sth++]));
		h[zn].clear();
		sth = 0; stt = 0;
		for (set<int>::const_iterator si = v[zm].begin(); si != v[zm].end(); ++si)
		{
			aa[*si][zm] = X;
			if (*si == fn && zm == fm)
			{
				printf("%d\n", X);
				return 0;
			}
			q[qt++] = pp(*si, zm);
			h[*si].erase(h[*si].find(zm));
			st[stt++] = *si;
		}
		//while (sth < stt)
		//	v[zm].erase(v[zm].find(st[sth++]));
		v[zm].clear();
	}
	if (aa[fn][fm])
		//cout << aa[fn][fm] << endl;
		printf("%d\n", aa[fn][fm]);
	else
		//cout << "-1\n";
		printf("-1\n");
	return 0;
}

