PROGRAM cap;

CONST
   Max=2000;

TYPE
   FType=
      Record
         X, Y:LongInt;
      end;

VAR
   graph:array [1..Max, 1..Max]of LongInt;
   F:array [1..Max]of FType;
   height, width, i, j, last:LongInt;
   X1, X2, Y1, Y2:LongInt;
   symb:char;

BEGIN
   Assign(input, 'cap.dat');
   Reset(input);
   ReadLN(height, width);
   for i:=1 to height do
   begin
      for j:=1 to width do
      begin
         Read(symb);
         if symb='.' then
            graph[i, j]:=-1;
         if symb='x' then
            graph[i, j]:=0;
         if symb='o' then
         begin
            graph[i, j]:=0;
            X1:=i;
            Y1:=j;
         end;
         if symb='+' then
         begin
            graph[i, j]:=0;
            X2:=i;
            Y2:=j;
         end;
      end;
      ReadLN();
   end;
   Close(input);


   F[1].X:=X1;
   F[1].Y:=Y1;
   i:=0;
   j:=0;
   last:=1;
   repeat
      Inc(i);
      for j:=1 to width do
         if ( (graph[F[i].X, j]=-1) and (Y1<>j) )  or ( (graph[F[i].X, j]>0) and (graph[F[i].X, j]>graph[F[i].X, F[i].Y]+1) )   then
         begin
            graph[F[i].X, j]:=graph[F[i].X, F[i].Y]+1;
            Inc(last);
            F[last].X:=F[i].X;
            F[last].Y:=j;
         end;
         for j:=1 to height do
         if ( (graph[j, F[i].Y]=-1)and(j<>X1) ) or ( (graph[j, F[i].Y]>0)and(graph[j, F[i].Y]>graph[F[i].X, F[i].Y]+1) ) then
         begin
            graph[j, F[i].Y]:=graph[F[i].X, F[i].Y]+1;
            Inc(last);
            F[last].Y:=F[i].Y;
            F[last].X:=j;
         end;
   until ( (F[last].X=X2) and (F[last].Y=Y2) ) or (i>=last);
   if graph[X2, Y2]=0 then
      graph[X2, Y2]:=-1;

   Assign(output, 'cap.sol');
   Rewrite(output);
   WriteLN(graph[X2, Y2]);
   {for i:=1 to height do
   begin
      for j:=1 to width do
         Write(graph[i, j], ' ');
      WriteLN();
   end;}
   Close(output);
END.
