#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#define task_name "calendar"

using namespace std;

int n;
pair<int,int> village[100000];

int fetch(int start) {
    int retval = 0;
    for(int i=0;i<n;i++) {
        if(village[i].first == village[(start+i)%n].second)
            retval++;
    }
    return retval;
}

int main() {
	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    inp >> n;
    if(n>3000) {
        out << 1 << endl;
        return 0;
    }
    for(int i=0;i<n;i++)
        inp >> village[i].first;
    for(int i=0;i<n;i++) {
        inp >> village[i].second;
    }
    int tmp,best = 0;
    for(int i=0;i<n;i++) {
        tmp = fetch(i);
        if(best < tmp)
            best = tmp;
    }
    out << best << endl;

	inp.close();
	out.close();
}
