#include <iostream>
#include <stdio.h>
#include <queue>
#include <algorithm>
using namespace std;

int n, m;
bool field[100][100][100][100];
bool fld[100][100];
bool wasin[100][100];
int times[100][100];

void bfs(int xs, int ys, int xf, int yf){
	int xn, yn;
	queue< pair<int, int> > nowin;
	nowin.push(make_pair(xs, ys));
	while (!nowin.empty()){
		xn = nowin.front().first;
		yn = nowin.front().second;
		wasin[xn][yn] = true;
		nowin.pop();
		for(int i = 0; i < n; i++)
			if (!wasin[i][yn] && field[xn][yn][i][yn]){
				times[i][yn] = times[xn][yn]+1;
				if (i == xf && yf == yn) return;
				nowin.push(make_pair(i, yn));
			}
		for(int i = 0; i < m; i++)
			if (!wasin[xn][i] && field[xn][yn][xn][i]){
				times[xn][i] = times[xn][yn]+1;
				if (xf == xn && yf == i) return;
				nowin.push(make_pair(xn, i));
			}
	}
}

int main(){
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	scanf("%d %d", &n, &m);
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++){
			fld[i][j] = false;
			wasin[i][j] = false;
			times[i][j] = -1;
			for(int k = 0; k < n; k++)
				for(int z = 0; z < m; z++)
					field[i][j][k][z] = false;
		}
	char d;
	int xs, ys;
	int xf, yf;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			cin>>d;
			if (d == 'x') fld[i][j] = true;
			else if (d == 'o'){ fld[i][j] = true; xs = i; ys = j; }
			else if (d == '+'){ fld[i][j] = true; xf = i; yf = j; }
		}
	}
	times[xs][ys] = 0;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			if (fld[i][j]){
				for(int t = 0; t < n; t++)
					if (fld[t][j]) field[i][j][t][j] = 1;
				for(int t = 0; t < m; t++)
					if (fld[i][t]) field[i][j][i][t] = 1;
			}
		}
	}
	bfs(xs, ys, xf, yf);
	cout<<times[xf][yf]<<endl;
}