procedure qsort(var a: array of longint; first, last, elem: longint);
var
  m, left, right, temp: longint;
begin
  m := a[(first + last) div 2];
  left := first;
  right := last;

  while left <= right do
  begin
    while a[left] < m do
      inc(left);
    while a[right] > m do
      dec(right);
    if left <= right then
    begin
      if (a[left] = elem) or (a[right] = elem) then
      begin
        temp := a[left];
        a[left] := a[right];
        a[right] := temp;
      end;

      inc(left);
      dec(right);
    end;
  end;

  if left < last then
    qsort(a, left, last, elem);
  if right > first then
    qsort(a, first, right, elem);
end;


var
  n, i, res, max, x, j: longint;
  ch: char;
  s: string;

begin
  assign(input, 'mutation.dat');
  reset(input);
  assign(output, 'mutation.sol');
  rewrite(output);

  readln(n);

  for i := 0 to n - 1 do
  begin
    read(x);
    s := s + chr(x);
  end;

  res := 0;
  i := 1;
  while i < length(s) do
  begin
    inc(i);
    if s[i] < s[i - 1] then
    begin
      inc(res);
      ch := s[i];
      for j := 1 to length(s) do
        if s[j] = ch then
          delete(s, j, 1);
      i := 1;
    end;
  end;

  writeln(res);
end.
