procedure qsort(a: array of longint; first, last: longint);
var
  m, left, right, temp: longint;
begin
  m := a[(first + last) div 2];
  left := first;
  right := last;

  while left <= right do
  begin
    while a[left] < m do
      inc(left);
    while a[right] > m do
      dec(right);
    if left <= right then
    begin
      temp := a[left];
      a[left] := a[right];
      a[right] := temp;
      inc(left);
      dec(right);
    end;
  end;

  if left < last then
    qsort(a, left, last);
  if right > first then
    qsort(a, first, right);
end;

var
  n, m, i, j, min, max, min_j, max_i, max_j, state, t, w, u: longint;
  a: array of array of longint;
  b: array of longint;

begin
  assign(input, 'stones.dat');
  reset(input);
  assign(output, 'stones.sol');
  rewrite(output);

  readln(n, m);
  setlength(b, m + 1);
  setlength(a, m + 1);

  for i := 1 to m do
  begin
    setlength(a[i], 1);
    a[i, 0] := 1;
    b[i] := 1;
  end;

  for u := 1 to n do
  begin
    read(state);
    case state of
      1:
        begin
          readln(t, w);
          inc(a[t, 0]);
          setlength(a[t], a[t, 0]);
          a[t, a[t, 0] - 1] := w;
        end;
      2:
        begin
          max := 0;
          for i := 1 to m do
          begin
            if a[i, 0] - 1 <= b[i] then
            begin
              qsort(a[i], b[i], a[i, 0] - 1);

              if a[i, b[i]] > max then
              begin
                max := min;
                max_i := i;
              end;
            end;
          end;
          writeln(max);
          inc(b[max_i]);
        end;
    end;
  end;
end.
