#include <iostream>
#include <vector>
#include <fstream>

using namespace std;

struct st
{
	int a,w;
};

const int INF = 2000000000;

vector <st> gr[100000];
int d[100000];
bool u[100000];

int main ()
{
	ifstream cin ("olympair.dat");
	ofstream cout ("olympair.sol");
	int n,m;
	cin >> n >> m;
	int t,a,b,w;
	for (int i = 0;i<m;i++)
	{
		cin >> t >> a >> b >> w;
		a--;
		b--;
		st q;
		q.w = w;
		if (t == 1)
		{
			q.a = b;
			gr[a].push_back(q);
		}
		else
		{
			for (int j = 0;j<gr[a].size();j++)
			{
				q = gr[a][j];
				q.w += w;
				gr[b].push_back(q);
			}
		}
	}
	int v = 0;
	d[0]=0;
	for (int i = 1;i<n;i++)
	{
		d[i] = INF;
		u[i] = false;
	}
	while (v != -1)
	{
		u[v] = true;
		for (int i = 0;i<gr[v].size();i++)
		{
			t = gr[v][i].a;
			w = gr[v][i].w;
			d[t] = min (d[t],d[v]+w);
		}
		int mmin = INF;
		int nmin = -1;
		for (int i = 0;i<n;i++)
		{
			if (!u[i])
			{
				if (d[i] < mmin)
				{
					mmin = d[i];
					nmin = i;
				}
			}
		}
		v=nmin;
	}
	for (int i = 1;i<n;i++)
	{
		if (d[i] != INF)
		{
			cout << d[i] << endl;
		}
		else
		{
			cout << -1 << endl;
		}
	}
	cout.close();
	return 0;
}