program olympair;

type heap = record
  ing, num: longint;
  stones: array[1..200000] of longint;
end;

type gbel = record
  tow, st: longint;
end;

var i, n, j, ans, res, m, tip, t, w: longint;
    heaps: array[1..5] of heap;
    gb: array[1..100] of gbel;

procedure swapst(var a, b: gbel);
  var c: gbel;
  begin
   c := a; a := b; b := c;
  end;

procedure swap(var a, b: longint);
  var c: longint;
  begin
    c := a; a := b; b := c;
  end;

procedure add(t, w: longint);
  var i, j: longint;
  begin
    inc(heaps[t].num);
    heaps[t].stones[heaps[t].num] := w;
    i := heaps[t].num;
    while (i > 1) and (heaps[t].stones[i div 2] > heaps[t].stones[i]) do
      begin
        swap(heaps[t].stones[i], heaps[t].stones[i div 2]);
        i := i div 2;
      end;
    if i = 1 then
      begin
        gb[heaps[t].ing].st := heaps[t].stones[1];
        i := heaps[t].ing;
        while (i > 1) and (gb[i div 2].st < gb[i].st) do
          begin
            swapst(gb[i], gb[i div 2]);
            heaps[gb[i].tow].ing := i;
            heaps[gb[i div 2].tow].ing := i div 2;
            i := i div 2;
          end;
      end;
  end;

begin
  assign(input, 'stones.dat');
  assign(output, 'stones.sol');
  reset(input); rewrite(output);
  read(n, m);
  for i := 1 to m do
    begin
      gb[i].tow := i;
      heaps[i].ing := i;
      heaps[i].num := 0;
    end;
  for i := 1 to n do
    begin
      read(tip);
      if tip = 2 then writeln(gb[1].st) else
        begin
          read(t, w);
          add(t, w);
        end;
    end;
  close(input); close(output);
end.
