program olo;

const inf = 1000000000000000;

type tower = record
  x, y, r: extended;
  c: longint;
  cost: int64;
end;

type kni = record
  x, y: extended;
  l: longint;
end;

var i, j, n, m, k, ed: longint;
    min, res: int64;
	tow: array[0..100000] of tower;
	knight: array[0..100000] of kni;
    col: array[0..100000] of longint;
	
procedure swap(var a, b: tower);
  var c: tower;
  begin
    c := a; a := b; b := c;
  end;  
	
procedure sort(l, r: longint);
  var i, j: longint;
      etl: tower;
  begin
    if l < r then
	  begin
	    i := l; j := r;
		etl := tow[(l + r) div 2];
		while i < j do
		  begin
		    while tow[i].cost > etl.cost do inc(i);
			while tow[j].cost < etl.cost do dec(j);
			if i <= j then
			  begin
			    swap(tow[i], tow[j]);
				inc(i); dec(j);
			  end;
		  end;
		sort(l, j); sort(i, r);  
	  end;
  end;  
	
begin
  assign(input, 'tetris.dat');
  assign(output, 'tetris.sol');
  reset(input); rewrite(output);
  read(n, m, k);
  for i := 1 to n do read(tow[i].x, tow[i].y, tow[i].r, tow[i].c);
  min := 0;
  for i := 1 to m do read(knight[i].x, knight[i].y, knight[i].l);
  for i := 1 to m do min := min + knight[i].l * tow[1].c;
  writeln(min);	
  close(input);
  close(output);
end.
