#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cstdlib>
#include <bitset>
#include <algorithm>

using namespace std;

typedef long long INT;

#if (_WIN32 || __WIN32|__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}
#define pu push_back

const int MAXN = 1010;

struct T{
    int i, j;
    T (int _i = 0, int _j = 0) : i(_i), j(_j) {}
};

int row[MAXN][MAXN], col[MAXN][MAXN];
int nrow[MAXN], ncol[MAXN];
char used_row[MAXN], used_col[MAXN];
char used[MAXN][MAXN];
char a[MAXN][MAXN];
int n, m;
int si, sj, fi, fj;
T q[MAXN*MAXN];
int nq = 0;
int d[MAXN][MAXN];

int main(){
    WITH_FILES(cap.dat, cap.sol)
    scanf("%d%d\n", &n, &m);
    for (int i = 0; i < n; i++)
        scanf("%s", a[i]);
    for (int i = 0 ; i < n; i++)
        for (int j = 0; j < m; j++){
            if (a[i][j] == 'o'){
                si = i;
                sj = j;
            }
            if (a[i][j] == '+'){
                fi = i;
                fj = j;
            }
            if (a[i][j] != '.'){
                row[i][nrow[i]++] = j;
                col[j][ncol[j]++] = i;
            }
        }
    q[nq++] = T(si, sj);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            d[i][j] = -1;
    d[si][sj] = 0;
    used[si][sj] = 1;
    int now = 0;
    while (d[fi][fj] == -1 && now < nq){
        int x = q[now].i;
        int y = q[now].j;
        int dist = d[x][y];
        now++;
        if (!used_row[x]){
            used_row[x] = 1;
            for (int t = 0; t < nrow[x]; t++){
                int it = row[x][t];
                if (!used[x][it]){
                    q[nq++] = T(x, it);
                    d[x][it] = dist + 1;
                }
            }
        }
        if (!used_col[y]){
            used_col[y] = 1;
            for (int t = 0; t < ncol[y]; t++){
                int it = col[y][t];
                if (!used[it][y]){
                    q[nq++] = T(it, y);
                    d[it][y] = dist + 1;
                }
            }
        }
    }
    printf("%d\n", d[fi][fj]);
    return 0;
}
