#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <cstdio>
#include <cmath>

using namespace std;

int que[1000000], l = 0, r = 0, n, m, dist[1000000], s, f;
char a[1000][1000];
bool looked[1000000];

int main()
{
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);

	scanf("%d %d", &n, &m);

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
		{
//			scanf("%d", &a[i][j]);
			cin >> a[i][j];
			if (a[i][j] == 'o')
				s = i * 1000 + j;
			if (a[i][j] == '+')
				f = i * 1000 + j;
		}

	que[r++] = s;
	dist[s] = 0;
	looked[s] = true;

	int q;
	while (l < r && (!looked[f]))
	{
		int cur = que[l++];
		int ci = cur / 1000, cj = cur % 1000;

		for (int i = 0; i < n; ++i)
		{
			q = i * 1000 + cj;
			if (!looked[q] && (a[i][cj] == 'x' || a[i][cj] == '+'))
			{
				que[r++] = q;
				looked[q] = true;
				dist[q] = dist[cur] + 1;
			}
		}

		for (int j = 0; j < m; ++j)
		{
			q = ci * 1000 + j;
			if (!looked[q] && (a[ci][j] == 'x' || a[ci][j] == '+'))
			{
				que[r++] = q;
				looked[q] = true;
				dist[q] = dist[cur] + 1;
			}
		}
	}

	if (dist[f] > 0)
		printf("%d\n", dist[f]);
	else
		printf("-1\n");

	return 0;
}
