#include <iostream>
#include <fstream>
#include <string.h>

using namespace std;

int **g;
int n, m;

int main()
{
	ifstream in("olympair.dat");
	ofstream out("olympair.sol");

	in >> n >> m;

	g = new int*[n];
	for (int i = 0; i < n; i++) {
		g[i] = new int[n];
		memset(g[i], 100000001, sizeof(int) * n);
	}

	for (int i = 0; i < m; i++) {
		int op, a, b, c;
		in >> op >> a >> b >> c;
		a--, b--;
		if (op == 1) { // add new route
			g[a][b] = c;
		} else { // from b to vi
			for (int j = 0; j < n; j++) {
				if (g[a][j] != 100000001) {
					g[b][j] = g[a][j] + c;
				}
			}
		}
	}

	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (g[i][j] > (g[i][k] + g[k][j]))
					g[i][j] = g[i][k] + g[k][j];
			}
		}
	}

	for (int i = 1; i < n; i++)
		out << (g[0][i] == 16843008 ? -1 : g[0][i]) << endl;

	return 0;
}