#include <iostream>
#include <fstream>
#include <string.h>

using namespace std;

int n, m;
int len;
int **g;
int source, dest;
int *last_line, *line;

#define C(line, col) (((line) * m) + (col))

int main()
{
	ifstream in("cap.dat");
	ofstream out("cap.sol");

	in >> n >> m;
	len = n * m;
	g = new int*[len];
	for (int i = 0; i < len; i++) {
		g[i] = new int[len];
		memset(g[i], 0, len * sizeof(int));
	}

	last_line = new int[m];
	memset(last_line, 0, sizeof(int) * m);
	line = new int[m];
	memset(line, 0, sizeof(int) * m);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			in >> c;
			if (c == '.') {
				line[j] = 0;
			} else {
				line[j] = 1;
				if (c == '+') {
					dest = C(i, j);
				} else if (c == 'o') {
					source = C(i, j);
				}
				if (j > 0 && line[j - 1]) {
					g[C(i, j - 1)][C(i, j)] = g[C(i, j)][C(i, j - 1)] = 1;
				}
				if (last_line[j]) {
					g[C(i - 1, j)][C(i, j)] = g[C(i, j)][C(i - 1, j)] = 1;
				}
			}
			memcpy(last_line, line, m * sizeof(int));
		}
	}

	if (source == dest) {
		out << "1\n";
		return 0;
	}

	int **p = new int*[len];
	for (int i = 0; i < len; i++) {
		p[i] = new int[len];
		memset(p[i], 0, len * sizeof(int));
	}

	for (int k = 0; k < len; k++) {
		for (int i = 0; i < len; i++) {
			for (int j = 0; j < len; j++) {
				if (!g[i][j] && g[i][k] && g[k][j]) {
					g[i][j] = 1;
					p[i][j] = k;
				}
			}
		}
	}

	if (!g[source][dest]) {
		out << "-1\n";
	} else {
		int x = 0;
		int k = dest;
		do {
			x++;
			k = p[source][k];
		} while (k > 0);
		out << k << endl;
	}

	return 0;
}