#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
using namespace std;

#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef pair<int,int> pii;

const int maxn = 1001;
const int inf = (int)1e5+1;

#define task "cap"

int n,m,dx[] = {0,0,-1,1}, dy[] = {1,-1,0,0}, d[maxn][maxn], enx, eny, stx, sty;
char s[maxn][maxn];

#define x second
#define y first

int main(){
  #ifdef DEBUG
  freopen("input.txt","r",stdin);
  freopen("output.txt","w",stdout);
  #else
  freopen(task".dat","r",stdin);
  freopen(task".sol","w",stdout);
  #endif
  cin >> n >> m;
  for (int i=0;i<n;++i)
    for (int j=0;j<m;++j){
      d[i][j] = inf;
      cin >> s[i][j];
      if (s[i][j]=='o'){
        stx = j;
        sty = i;
      }
      if (s[i][j]=='+'){
        enx = j;
        eny = i;
      }
    }
  queue< pii > q;
  q.push(mp(sty,stx));
  d[sty][stx] = 0;
  while (!q.empty()){
    pii v = q.front();
    q.pop();
    for (int i=0;i<4;++i){
      if (v.x+dx[i]>=0 && v.x+dx[i]<m && v.y+dy[i]<n && v.y+dy[i]>=0 && d[v.y+dy[i]][v.x+dx[i]]>d[v.y][v.x]+1 && (s[v.y+dy[i]][v.x+dx[i]]=='x' || s[v.y+dy[i]][v.x+dx[i]]=='+')){
        d[v.y+dy[i]][v.x+dx[i]] = d[v.y][v.x]+1;
        q.push(mp(v.y+dy[i],v.x+dx[i]));
      }
    }
  }
  if (d[eny][enx] != inf)
    cout << d[eny][enx]-1; else
    cout << -1;
  return 0;
}

