#include <stdio.h>
#include <iostream>

#define INF 1000000000

struct el
{
       int value, left, right;
};

bool prop[100010];
int n, a[100010], kol[100010], start[100010], end[100010];

int gl_list_sz = 0, list_sz = 0;
el gl_list[100010], list[100010];

int main()
{
    freopen("mutation.dat", "r", stdin);
    freopen("mutation.sol", "w", stdout);
    
    scanf("%d", &n);
    a[n] = INF;
    for( int i = 0; i <= n; i++ ) kol[i] = 0, prop[i] = 1, start[i] = INF, end[i] = INF;
    
    for( int i = 0; i < n; i++ ) scanf("%d", &a[i]), kol[a[i]]++;
    
    for( int i = 0; i < n; i++ )
    {
         kol[a[i]]--;
         if( ( kol[a[i]] != 0 ) && ( a[i + 1] != a[i] ) ) prop[a[i]] = 0;
    }
    
    for( int i = 0; i < n; i++ )
    {
         if( prop[a[i]] ) continue;
         
         //printf("%d ", a[i]);
         if( start[a[i]] == INF ) start[a[i]] = gl_list_sz;
         
         gl_list[gl_list_sz].value = list_sz;
         gl_list[gl_list_sz].left = end[a[i]];
         gl_list[gl_list_sz].right = INF;
         
         if( end[a[i]] != INF ) gl_list[end[a[i]]].right = gl_list_sz;
         end[a[i]] = gl_list_sz;
         gl_list_sz++;
         
         list[list_sz].value = a[i];
         list[list_sz].left = list_sz - 1;
         list[list_sz].right = list_sz + 1;
         list_sz++;
    }
    list[0].left = INF;
    if( list_sz != 0 ) list[list_sz - 1].right = INF;
    
    int kol_it = 0, strt;
    bool mst;
    
    /*printf("\n");
    printf("\n");*/
    
    for( int i = 1; i <= n; i++ )
    {
         /**/
         /*for( int j = 0; j < list_sz; j++ ) printf("%d ", list[j].value);
         printf("\n");
         for( int j = 0; j < list_sz; j++ ) printf("%d ", list[j].left);
         printf("\n");
         for( int j = 0; j < list_sz; j++ ) printf("%d ", list[j].right);
         printf("\n");
         printf("\n");*/
         /**/
         
         if( end[i] == INF ) continue;
         
         mst = 0;
         strt = end[i];
         
         while( strt != INF )
         {
                if( list[gl_list[strt].value].left != INF ) {
                    if( list[list[gl_list[strt].value].left].value != i ) mst = 1;
                }
                
                if( list[gl_list[ strt ].value].right != INF )
                {
                    list[list[gl_list[ strt ].value].right].left = list[gl_list[ strt ].value].left; 
                }
                
                if( list[gl_list[ strt ].value].left != INF )
                {
                    list[list[gl_list[ strt ].value].left].right = list[gl_list[ strt ].value].right;
                }
                
                strt = gl_list[strt].left;
         }
         
         if( mst == 1 ) kol_it++;
    }
    
    printf("%d\n", kol_it);
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
