Program cap1;

	type
		TPoint = record
			x, y: integer;
		end;
		TDeque = record
			el: array[0..10000000] of TPoint;
			start, leng: longint;
		end;
		
	var
		N, M, i, j: longint;
		p: array[0..1001, 0..1001] of boolean;
		g: array[0..1001, 0..1001] of int64;
		beg, fin, cur: TPoint;
		ch: char;
		Dq: TDeque;
		dat, sol: text;
	
	function Point (x, y: integer): TPoint;
		var res: TPoint;
	Begin
		res.X:= x; res.Y:= y;
		Point:= res;
	end;
	
	procedure DQCreate (var d: TDeque; first: TPoint);
	Begin
		d.leng:= 1;
		d.start:= 0;
		d.el[0]:= first;
	end;
	procedure DQadd (var d: TDeque; val: TPoint);
	Begin
		d.el[d.leng]:= val;
		inc (d.leng);
	end;
	function DQget (var d: TDeque): TPoint;
	Begin
		DQget:= d.el[d.start];
		inc (d.start);
	end;
	function DQEmpty (var d: TDeque): boolean;
	Begin
		DQEmpty:= (d.start=d.leng);
	end;
	
	procedure TryGo (dx, dy: integer);
		var go: TPoint;
			k: integer;
	Begin
		k:= 1;
		While ((cur.x+k*dx)<=N) and ((cur.y+k*dy)<=M) 
			and ((cur.x+k*dx)>0) and ((cur.y+k*dy)>0) do
		Begin
			go:= Point (cur.x+k*dx, cur.y+k*dy);
			if p[go.x, go.y] then
				if (g[cur.x, cur.y]+1<g[go.x, go.y]) or (g[go.x, go.y]=-1) then
				Begin
					DQadd (Dq, go);
					g[go.x, go.y]:= g[cur.x, cur.y]+1;
				end;
			k:= k+1;
		end;
	end;
	
Begin
	Assign (dat, 'cap.dat'); Reset (dat);
	Assign (sol, 'cap.sol'); Rewrite (sol);
	Readln (dat, N, M);
	for i:= 1 to N do
	Begin
		for j:= 1 to M do
		Begin
			Read (dat, ch);
			if ch = '.' then p[i, j]:= false
			else p[i, j]:= true;
			g[i, j]:= -1;
			if ch = 'o' then
			Begin
				beg:= Point (i, j);
				g[i, j]:= 0;
			end;
			if ch = '+' then fin:= Point (i, j);
		end;
		Readln (dat);
	end;
	
	for i:= 0 to N+1 do
	Begin
		p[i, 0]:= false; g[i, 0]:= -1;
		p[i, M+1]:= false; g[i, M+1]:= -1;
	end;
	for i:= 0 to M+1 do
	Begin
		p[0, i]:= false; g[0, i]:= -1;
		p[N+1, i]:= false; g[N+1, i]:= -1;
	end;
	
	DQCreate (Dq, beg);
	While not DQEmpty(Dq) do
	Begin
		cur:= DQget (Dq);
		TryGo (0, 1);
		TryGo (1, 0);
		TryGo (0, -1);
		TryGo (-1, 0);
	end;
	Write (sol, g[fin.x, fin.y]);
	Close (dat); Close (sol);
end.
