#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
struct City
{
	int Num;
	vector<int> Stones;
};
int N,M;
City* arr;
void insert(int cityNum,int weight)
{
	int i=0;
	if(arr[cityNum-1].Stones.size()==0)
	{
		arr[cityNum-1].Stones.push_back(weight);
		return;
	}
	while(arr[cityNum-1].Stones[i]<weight)
	{
		i++;
		if(i==arr[cityNum-1].Stones.size())
		{
			arr[cityNum-1].Stones.push_back(weight);
			return;
		}
	}
	arr[cityNum-1].Stones.insert(arr[cityNum-1].Stones.begin()+i,weight);
}

int main()
{
	ifstream cin("stones.dat");
	ofstream cout("stones.sol");
	cin>>N>>M;
	arr=new City[M];

	for(int i=0;i<M;i++)
		arr[i].Num=i+1;
	int eType;
	int cityNum, weight;
	int maxId=0;

	for(int i=0;i<N;i++)
	{
		cin>>eType;
		if(eType==1)
		{
			cin>>cityNum>>weight;
			insert(cityNum,weight);
		}
		else
		{
			maxId=0;
			for(int j=1;j<M;j++)
			{
				if(arr[maxId].Stones[0]<arr[j].Stones[0])
				{
					maxId=j;
				}
			}

			cout<<arr[maxId].Stones[0]<<endl;
			arr[maxId].Stones.erase(arr[maxId].Stones.begin());
		}
	}
	delete[] arr;
	return 0;
}