#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>

using namespace std;
int** Graph;
int n,m;
void SearchDx()
{
	int Result[10000];
	bool Visited[10000];
	Result[0]=0;
	int current=0;
	Visited[0]=true;
	for(int i=1;i<n;i++)
	{
		if(Graph[current][i]==0)
			Result[i]=-1;
		else
			Result[i]=Graph[current][i];
	}

	for(int j=1;j<n;j++)
	{
		for(int i=1;i<n;i++)
		{
			//if(Visited[i])
			//	continue;
			if(Graph[j][i]!=0)
			{
				if(Result[i]==-1)
					Result[i]=Graph[current][i];
				else
					Result[i]=min(Result[i],Result[j]+Graph[j][i]);
			}
		}
	}
	ofstream cout("olympair.sol");
	for(int i=1;i<n;i++)
	{
		cout<<Result[i]<<endl;
	}
}

int main()
{
	int eType;
	ifstream cin("olympair.dat");
	cin>>n>>m;
	Graph=new int*[n];
	for(int i=0;i<n;i++)
	{
		Graph[i]=new int[n];
		for(int j=0;j<n;j++)
			Graph[i][j]=0;
	}
	int x,y,C;
	for(int i=0;i<m;i++)
	{
		cin>>eType;
		if(eType==1)
		{
			cin>>x>>y>>C;
			if(Graph[x-1][y-1]==0)
				Graph[x-1][y-1]=C;
			else
				Graph[x-1][y-1]=min(Graph[x-1][y-1],C);
		}
		else
		{
			cin>>x>>y>>C;
			for(int i=0;i<n;i++)
			{
				if(Graph[x-1][i]!=0)
				{
					if(Graph[y-1][i]==0)
						Graph[y-1][i]=Graph[x-1][i]+C;
					else
						Graph[y-1][i]=min(Graph[y-1][i],Graph[x-1][i]+C);
				}
			}
		}
	}

	SearchDx();
	return 0;
}