#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

ifstream fin("calendar.dat");
ofstream fout("calendar.sol");
//FILE *fh = fopen ( "calendar.dat", "r" );

const int MAXN = int(1e5)+42;

//int calendar_1[2*MAXN], calendar_2[2*MAXN];
int position1[MAXN], shift[2*MAXN];

int main(){
    int n;
    fin >> n;
    for ( int i = 0; i < n; ++ i ){
        int number;
        fin >> number;
        position1[number] = i;

    }

    memset ( shift, 0, 2*n*sizeof ( int ) );

    int max_cnt = -1;
    for ( int i = 0; i < n; ++ i ) {
        int number;
        fin >> number;
        //int shift =n+position1[number]-i;
        max_cnt = max ( max_cnt, ++shift[(n+position1[number]-i)%n] );
    }

    fout << max_cnt;
    return 0;
}
