#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <time.h>
#include <map>
using namespace std;

int N, M, t, A, B, C;

struct node
{
	long long x;
	node (long long x) : x(x) { }
};

vector < vector < node* > > g;

vector < long long > d;
set < pair < long long, int > > s;

long long INF = (long long)1e15;
int cnt;

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);
	scanf("%d %d", &N, &M);
	g.resize(N);
	for (int i = 0; i < N; ++i)
		g[i].assign(N, 0);
	d.assign(N, INF);

	for (int i = 0; i < M; ++i)
	{
		scanf("%d %d %d %d", &t, &A, &B, &C);
		if (t == 1)
		{
			if (g[A - 1][B - 1] == 0)
				g[A - 1][B - 1] = new node(C);
			else
				g[A - 1][B - 1]->x = min((long long)C, g[A - 1][B - 1]->x);
		}
		else
		{
			for (int j = 0; j < N; ++j)
				if (g[A - 1][j] != 0)
				{
					if (g[B - 1][j] == 0)
						g[B - 1][j] = new node(g[A - 1][j]->x + (long long)C);
					else
						g[B - 1][j]->x = min(g[B - 1][j]->x, g[A - 1][j]->x + (long long)C);
				}
		}
	}

	d[0] = 0;
	s.insert(make_pair(0, 0));

	while (!s.empty())
	{
		int v = s.begin()->second;
		long long c = s.begin()->first;
		s.erase(s.begin());
		
		for (int i = 0; i < N; ++i)
		{
			int to = i;
			if (g[v][to] == 0) continue;
			long long cost = g[v][i]->x;
			if (c + cost < d[to])
			{
				s.erase(make_pair(d[to], to));
				d[to] = c + cost;
				s.insert(make_pair(d[to], to));
			}
		}
	}

	for (int i = 0; i < N - 1; ++i)
		if (d[i + 1] == INF)
			printf("%d\n", -1);
		else
			printf("%Ld\n", d[i + 1]);
//	system("pause");
}