#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>

using namespace std;

const int INF = (int)1e9 + 7;

pair < int, int > p1, p2;
int N, M;
string s;
int m[1001][1001];

void read()
{
	scanf("%d %d\n", &N, &M);
	for (int i = 0; i < N; ++i)
	{
		getline(cin, s);
		for (int j = 0; j < M; ++j)
		{
			if (s[j] == '.')
			{
				m[i][j] = 0;
				continue;
			}
			
			if (s[j] == 'x')
			{
				m[i][j] = 1;
				continue;
			}
			
			if (s[j] == 'o')
			{
				m[i][j] = 2;
				continue;
			}

			if (s[j] == '+')
			{
				m[i][j] = 3;
				continue;
			}
		}
	}
}

int get(int i, int j)
{
	return i * M + j;
}

vector < vector < int > > g;
vector < int > d;

int main()
{
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	read();
	d.assign(N * M + 10, INF);

	for (int i = 0; i < N; ++i)
	{
		for (int j = 0; j < M; ++j)
		{
			if (m[i][j] == 0) continue;

			if (m[i][j] == 2)
				p1 = make_pair(i, j);

			if (m[i][j] == 3)
				p2 = make_pair(i, j);
		}
	}

	queue < pair < int, int > > q;
	q.push(p1);
	d[get(p1.first, p1.second)] = 0;
	while (!q.empty())
	{
		int i = q.front().first;
		int j = q.front().second;
		int v = get(i, j);

		q.pop();

		for (int k = 0; k < M; ++k)
		{
			if (k == j) continue;
			if (m[i][k] != 0)
				if (d[v] + 1 < d[get(i, k)])
				{
					d[get(i, k)] = d[v] + 1;
					q.push(make_pair(i, k));
				}	
		}

		for (int k = 0; k < N; ++k)
		{
			if (k == i) continue;
			if (m[k][j] != 0)
				if (d[v] + 1 < d[get(k, j)])
				{
					d[get(k, j)] = d[v] + 1;
					q.push(make_pair(k, j));
				}	
		}
	}


	if (d[get(p2.first, p2.second)] == INF)
		printf("%d\n", -1);
	else
		printf("%d\n", d[get(p2.first, p2.second)]);
	//system("pause");
}