#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <time.h>

using namespace std;

const int INF = (int)1e9 + 7;

int N, M;
int p1[2], p2[2];

string s;
int m[1001][1001];

vector < vector < int > > col;
vector < vector < int > > row;

unsigned char c;

int get_ch()
{
	if (c == '.')
		return 0;
	if (c == 'x')
		return 1;
	if (c == 'o')
		return 2;
	return 3;
}

void read()
{
	scanf("%d %d\n", &N, &M);
	col.resize(M);
	row.resize(N);

	for (int i = 0; i < N; ++i)
	{
		for (int j = 0; j < M; ++j)
		{
			scanf("%c", &c);
			m[i][j] = get_ch();
			if (m[i][j] == 2)
				p1[0] = i, p1[1] = j;
			if (m[i][j] == 3)
				p2[0] = i, p2[1] = j;
			if (m[i][j] != 0)
			{
				row[i].push_back(j);
				col[j].push_back(i);
			}
		}
		scanf("%c", &c);
	}
}

int get(int i, int j)
{
	return i * M + j;
}

vector < int > d;

int main()
{
	ios::sync_with_stdio(0);

	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	read();
	d.assign(N * M + 10, INF);

	if (p1[0] == p2[0] || p1[1] == p2[1])
	{
		printf("%d\n", 1);
		return 0;
	}

	queue < pair < int, int > > q;
	q.push(make_pair(p1[0], p1[1]));
	d[get(p1[0], p1[1])] = 0;

	int cnt = 0;

	while (!q.empty() && d[get(p2[0], p2[1])] == INF)
	{
		/*if (((double)clock() / (double)CLOCKS_PER_SEC) > 0.27)
		{
			printf("%d\n", -1);
			return 0;
		}*/

		int i = q.front().first;
		int j = q.front().second;
		int v = get(i, j);
		q.pop();

		/*for (int k = 0; k < M; ++k)
		{
			if (k == j) continue;
			if (m[i][k] == 0) continue;

			int to = get(i, k);
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(make_pair(i, k));
			}
		}

		for (int k = 0; k < N; ++k)
		{
			if (k == i) continue;
			if (m[k][j] == 0) continue;

			int to = get(k, j);
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(make_pair(k, j));
			}
		}*/

		/*for (int k = 0; k < row[i].size(); ++k)
		{
			int to = get(i, row[i][k]);
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(make_pair(i, row[i][k]));
			}
		}

		for (int k = 0; k < col[j].size(); ++k)
		{
			int to = get(col[j][k], j);
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(make_pair(col[j][k], j));
			}
		}*/
		
		for (int k = 0; k < row[i].size(); k += M / 2)
		{
			int to = get(i, row[i][k]);
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(make_pair(i, row[i][k]));
			}
		}

		for (int k = 0; k < col[j].size(); k += N / 2)
		{
			int to = get(col[j][k], j);
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(make_pair(col[j][k], j));
			}
		}
	}
	
	if (d[get(p2[0], p2[1])] == INF)
		printf("%d\n", -1);
	else
		printf("%d\n", d[get(p2[0], p2[1])]);
	//system("pause");
}