program ProblemB;{Meet in the middle}
type TMap = array[1..1000, 1..1000] of byte;
type Answer = array[1..1000, 1..1000, 1..2] of word;
type Visited = array[1..1000, 1..1000, 1..2] of byte;
type Point = record x, y, d, f: longint; end;
type Queue = array[1..500000] of Point;
var Map: TMap;
    V: Visited;
    Q: Queue;
    Ans: Answer;
    n, m, i, j, l, d: longint;
    ch: char;
    Start, Finish: Point;
    bool: boolean;
function New(x, y, d, f: longint): Point;
var T: Point;
begin
 T.x:=x;
 T.y:=y;
 T.d:=d;
 T.f:=f;
 New:=T;
end;
procedure Push(P: Point);
begin
 Ans[P.x, P.y, P.f]:=P.d;
 V[P.x, P.y, P.f]:=1;
 inc(l);
 Q[l]:=P;
 if (V[P.x, P.y, 1] = 1) and (V[P.x, P.y, 2] = 1) then
  begin
   bool:=false;
   d:=Ans[P.x, P.y, 1] + Ans[P.x, P.y, 2];
  end;
end;
begin
 assign(input, 'cap.dat');
 reset(input);
 assign(output, 'cap.sol');
 rewrite(output);
 fillchar(Map, sizeof(Map), 0);
 fillchar(V, sizeof(V), 0);
 fillchar(Q, sizeof(Q), 0);
 readln(n, m);
 for i:=1 to n do
  begin
   for j:=1 to m do
    begin
     read(ch);
     case ch of
      '.': Map[i, j]:=1;
      'x': Map[i, j]:=0;
      'o': begin
            Start.x:=i;
            Start.y:=j;
            Start.f:=1;
           end;
      '+': begin
            Finish.x:=i;
            Finish.y:=j;
            Finish.f:=2;
           end;
      end;
    end;
   readln;
  end;
 i:=1;
 Push(Start);
 Push(Finish);
 bool:=true;
 while (i <= l) and (bool) do
  begin
   for j:=n downto 1 do
    begin
     if (V[j, Q[i].y, Q[i].f] = 0) and (Map[j, Q[i].y] <> 1) then Push(New(j, Q[i].y, Q[i].d + 1, Q[i].f));
    end;
   for j:=m downto 1 do
    begin
     if (V[Q[i].x, j, Q[i].f] = 0) and (Map[Q[i].x, j] <> 1) then Push(New(Q[i].x, j, Q[i].d + 1, Q[i].f));
    end;
   inc(i);
  end;
 if i > l then write('-1')
 else write(d);
 close(input);
 close(output);
end.
