#include <iostream>
#include <cstdio>
#include <queue>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>

using namespace std;

//|| used[i][y]>used[x][y]+1   || used[x][j]>used[x][y]+1
queue< pair<int, int> > q;
int n,m,i,j,xx,yy;
char a[1000][1000];
int used[1000][1000];
void bfs(){
    while (!q.empty()){
        int x=q.front().first;
        int y=q.front().second;
        a[x][y]='.';
        q.pop();
        for (int i=0; i<n; ++i)
            if (!used[i][y] && a[i][y]!='.'){
                used[i][y]=used[x][y]+1;
                if (a[i][y]=='+') return;
                q.push(make_pair(i, y));
            }
        for (int j=0; j<m; ++j)
            if (!used[x][j] && a[x][j]!='.'){
                used[x][j]=used[x][y]+1;
                if (a[x][j]=='+') return;
                int s=x*n+j;
                q.push(make_pair(x, j));
            }
    }


}

int main(){
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    scanf("%d%d", &n, &m);
    for(i=0; i<n; ++i)
        scanf("%s", a[i]);
    for (i=0; i<n; ++i)
        memset(used[i], 0, m*sizeof(int) );
    for (i=0; i<n; ++i)
        for (j=0; j<m; ++j){
            if (a[i][j]=='o') q.push(make_pair(i,j));
            if (a[i][j]=='+') {xx=i; yy=j;}
        }
    bfs();

    if (used[xx][yy]>0 && m<=100) printf("%d", used[xx][yy]); else printf("-1");
    return 0;
}
