const
 maxn = 1500;
type
 coord = record
  x, y : longint;
 end;
 queue = record
  mas : array [1..10000] of coord;
  head, tail : longint;
 end;
var
 t : array [1..maxn, 1..maxn] of boolean;
 f : text;
 n, m, i, j : longint;
 c : char;
 xa, ya, xb, yb : longint;
 step : int64;


procedure put (a : coord; var b : queue);
begin
 inc(b.head);
 b.mas[b.head] := a;
end;

procedure pop(var b : queue);
begin
 inc(b.tail);
end;

function clear(b : queue) : boolean;
begin
 clear := b.tail > b.head;
end;

procedure bfs(x1, y1, x2, y2 : longint);
var
 snake : queue;
 test : coord;
 i1, j1 : longint;
 looked : array [1..maxn, 1..maxn] of boolean;
 dist : array [1..maxn, 1..maxn] of integer;
begin
 snake.tail:=1;
 snake.head:=0;
 test.x := x1;
 test.y := y1;
 put(test,snake);
 looked[x1, y1] := true;
 dist[x1, y1] := 0;
 repeat
 j1 := snake.mas[snake.tail].y;
 for i1:= 1 to n do
  if (not looked[i1, j1]) and t[i1,j1] then
  begin
   test.x := i1;
   test.y := j1;
   put(test,snake);
   looked[i1, j1] := true;
   dist[i1, j1] := dist[snake.mas[snake.tail].x, snake.mas[snake.tail].y] + 1;
  end;
 i1 := snake.mas[snake.tail].x;
 for j1:= 1 to n do
  if (not looked[i1, j1]) and t[i1,j1] then
  begin
   test.x := i1;
   test.y := j1;
   put(test,snake);
   looked[i1, j1] := true;
   dist[i1, j1] := dist[snake.mas[snake.tail].x, snake.mas[snake.tail].y] + 1;
  end;
  pop(snake);
 until clear(snake) or looked[x2,y2];
 if looked[x2, y2] then
  step := dist[x2, y2] else
  step := -1;
end;


begin
 assign(f, 'cap.dat');
 reset(f);
 readln(f, n, m);
 for i := 1 to n do
 begin
 for j := 1 to m do
 begin
  read(f, c);
  case c of
  'x' : t[i, j] := true;
  'o' : begin
         xa := i;
         ya := j;
         t[i, j] := true;
        end;
  '+' : begin
         xb := i;
         yb := j;
         t[i, j] := true;
        end;
  else
   t[i, j] := false;
  end;
 end;
 readln(f);
 end;
 close(f);
 bfs(xa,ya,xb,yb);
 assign(f,'cap.sol');
 rewrite(f);
 write(f, step);
 close(f);
end.

