#include <iostream>
#include <set>
#include <cstdio>
#include <cmath>
#include <map>
#include <string>
#include <cstring>
#include <memory.h>
#include <vector>
#include <queue>

using namespace std;
#define ll long long
#define dd double

ll n,m;
vector<vector <ll> > g;
vector<vector <ll> > cost;

const ll inf=10000000000000000;

ll d[100001];
bool used[100001];

priority_queue<pair< int , int> > q;

int main()
{
 freopen("olympair.dat","r",stdin);
  freopen("olympair.sol","w",stdout);

 // cin>>n>>m;
  scanf("%d%d",&n,&m);
  g.resize(n+1);
  cost.resize(n+1);
  for(ll t=0;t<m;t++)
  {
      int zap,a,b,c;
      scanf("%d%d%d%d",&zap,&a,&b,&c);
      //cin>>zap>>a>>b>>c;
      if(zap==1)
      {
          g[a].push_back(b);
          cost[a].push_back(c);
      }else
      {
          for(ll i=0;i<g[a].size();i++)
          {
              ll to=g[a][i],h=cost[a][i];
              g[b].push_back(to);
              cost[b].push_back(h+c);
          }
      }
  }

  q.push(make_pair(0,1));
  d[1]=0;

  for(ll i=2;i<=n;i++)d[i]=inf;
  while(!q.empty())
  {
      pair<int, int> vv=q.top();
      ll v=vv.second;
      q.pop();
      //q.erase(q.begin());
      if(used[v])continue;
      used[v]=true;
      for(ll i=0;i<g[v].size();i++)
      {
          ll to=g[v][i], c=cost[v][i];
          if(d[to]>d[v]+c)
          {
              //q.erase(make_pair(d[to],to));
              d[to]=d[v]+c;
              q.push(make_pair(d[to],to));
          }
      }
  }
  for(ll i=2;i<=n;i++)
    if(d[i]==inf)cout<<-1<<endl;else cout<<d[i]<<endl;

}
