type
  int=longint;

var
  n:int;
  i,j:int;
  c,k:int;
  a,b:array[1..200000]of int;
  q,w:array[1..100000]of int;
  d:array[1..100000]of int;

procedure swap(var a,b:int);
var
  k:int;
begin
  k:=a;
  a:=b;
  b:=k;
end;

procedure qsort(first,last:int);
var
  i,j:int;
  key:int;
begin
  if(last=first+1)then begin
    if d[first]>d[last] then swap(d[first],d[last]);
    exit;
  end;
  i:=first;
  j:=last;
  key:=(i+j)shr 1;
  if d[first]>d[key] then swap(d[first],d[key]);
  if d[key]>d[last]  then swap(d[key],d[last]);
  key:=d[key];
  while true do begin
    while(d[i]<key)do inc(i);
    while(key<d[j])do dec(j);
    if i>=j then break;
    swap(d[i],d[j]);
    inc(i);dec(j);
  end;
  if first<j then qsort(first,j);
  if i<last then qsort(i,last);
end;

procedure MergeSort(first,last:int);
var
  AdditMem:array of int;
  i,j,k:int;
  L:int;
begin
  if first=last then exit;
  if(last=first+1)then begin
    if d[first]>d[last] then swap(d[first],d[last]);
    exit;
  end;
  L:=(first+last)shr 1;
  MergeSort(first,L-1);
  MergeSort(L,last);
  if d[L-1]<d[L] then exit;
  SetLength(AdditMem,last-first+1);
  i:=first;
  j:=L;
  k:=0;
  while(i<L-1)and(j<last)do begin
    if(d[j]<d[i])then begin
      AdditMem[k]:=d[j];
      inc(k);
      inc(j);
    end else begin
      AdditMem[k]:=d[i];
      inc(k);
      inc(i);
    end;
  end;
    if(d[j]<d[i])then begin
      AdditMem[k]:=d[j];
      inc(k);
      inc(j);
    end else begin
      AdditMem[k]:=d[i];
      inc(k);
      inc(i);
    end;
  while i<=L-1 do begin
    AdditMem[k]:=d[i];
    inc(k);
    inc(i);
  end;
  while j<=last do begin
    AdditMem[k]:=d[j];
    inc(k);
    inc(j);
  end;
  for i:=0 to k-1 do d[i+first]:=AdditMem[i];
end;

procedure BubbleSort;
var
  i,j:int;
begin
  for i:=1 to n-1 do
    for j:=i+1 to n-1 do
      if d[i]>d[j] then swap(d[i],d[j]);
end;

begin
  assign(input,'calendar.dat');
  reset(input);
  assign(output,'calendar.sol');
  rewrite(output);

  readln(n);
  for i:=1 to n do begin
    read(a[i]);
    q[a[i]]:=i;
  end;
  for i:=1 to n do begin
    read(b[i]);
    w[b[i]]:=i;
    d[b[i]]:=q[b[i]]-w[b[i]];
    if d[b[i]]<=0 then inc(d[b[i]],n);
    b[i+n]:=b[i];
  end;

  BubbleSort;

  c:=1;
  k:=1;
  for i:=2 to n do begin
    if(d[i]=d[i-1])then begin
      inc(k);
    end else begin
      if k>c then c:=k;
      k:=1;
    end;
  end;
  writeln(c);

  close(output);
  close(input);
end.
