uses
  Math;

type
  int=longint;
  path=record
    dest,time:int;
  end;

var
  n,m:int;
  i,j:int;
  t,a,b,c:int;
  time:array[1..100000]of int;
  paths:array[1..100000]of array of path;

  QuSt,QuEn:int;
  Qu:array[1..200000]of int;

procedure QuPush(k:int);
begin
  inc(QuEn);
  Qu[QuEn]:=k;
end;

function QuPop:int;
begin
  QuPop:=Qu[QuSt];
  inc(QuSt);
end;

procedure AddPath(a,b,c:int);
var
  k:int;
begin
  k:=length(paths[a]);
  SetLength(paths[a],k+1);
  paths[a,k].dest:=b;
  paths[a,k].time:=c;
end;

begin
  assign(input,'olympair.dat');
  reset(input);
  assign(output,'olympair.sol');
  rewrite(output);

  readln(n,m);
  for i:=1 to n do begin
    time[i]:=high(int);
    SetLength(paths[i],0);
  end;

  for i:=1 to m do begin
    readln(t,a,b,c);
    case t of
      1:begin
        AddPath(a,b,c);
      end;
      2:begin
        for j:=0 to high(paths[a])do begin
          AddPath(b,paths[a,j].dest,paths[a,j].time+c);
        end;
      end;
    end;
  end;

  QuSt:=1;QuEn:=0;
  QuPush(1);
  time[1]:=0;
  while QuSt<=QuEn do begin
    i:=QuPop;
    for j:=0 to high(paths[i])do begin
      if(time[i]+paths[i,j].time>0)and(time[i]+paths[i,j].time<time[paths[i,j].dest])then begin
        time[paths[i,j].dest]:=time[i]+paths[i,j].time;
        QuPush(paths[i,j].dest);
      end;
    end;
  end;
  for i:=2 to n do begin
    if time[i]=high(int) then
      writeln(-1)
    else
      writeln(time[i]);
  end;

  close(output);
  close(input);
end.
