#include <cstdio>
#include <set>
#include <algorithm>

using namespace std;

struct line {
	int from, to, value;
	line (int _from, int _to, int _value) {from=_from; to=_to; value=_value;}
	line () {}
};

bool operator< (line a, line b){ return a.value<b.value;}
bool line_p (line a, line b) { if (a.from==b.from) return a.to<b.to; return a.from<b.from;}

const int maxnm = 100010;

line lines [maxnm];
int line_starts [maxnm];
int lc;

int n, m;

int res_normal [maxnm];

struct x {
	int val;
	x(int z) {val=z;}
};

bool operator< (x a, x b){return res_normal[a.val] < res_normal[b.val];}

set < x> dd;

int main (){
	int t, A,B,C;
	freopen ("olympair.dat","r", stdin);
	freopen ("olympair.sol", "w", stdout);
	scanf ("%d %d", &n, &m);
	for (int i = 0; i<m; i++){
		scanf ("%d %d %d %d", &t,&A,&B,&C);
		if (t == 1)
			lines[lc++] = line (A,B,C);
		else{
			int lcc = lc;
			for (int i = 0; i<lcc; i++)
				if (lines[i].from == A)
					lines[lc++] = line (B,lines[i].to, lines[i].value+C);
		}
	}
	sort (lines, lines+lc, &line_p);
	for (int i = 0; i<=n; i++)
		line_starts[i] = -1;
	for (int i = 0; i<lc; i++){
		if (line_starts[lines[i].from] == -1)
			line_starts[lines[i].from] = i;
	}
	for (int i = 1; i<=n; i++)
		res_normal [i] = 1000000000;
	for (int i = 0; lines[i].from == 1; i++){
		res_normal [lines[i].to] = lines[i].value;
		dd.insert (x(lines[i].to));
	}
	while (!dd.empty()){
		x now = *(dd.begin());
		for (int i = line_starts[now.val]; lines[i].from == now.val; i++){
			if (res_normal [lines[i].to]>res_normal[now.val]+lines[i].value)
				res_normal [lines[i].to] = res_normal[now.val]+lines[i].value;
		}
		dd.erase(now);
	}
	for (int i = 2; i<=n; i++){
		if (res_normal[i]==1000000000)
			printf("-1\n");
		else
			printf ("%d\n", res_normal[i]);
	}
	return 0;
}