#include <stdio.h>
#include <vector>
#include <queue>
using namespace std;
#define mp make_pair 
#define INF 1000000000000000
struct edge{
	int a,b,cost;
	bool real;
};
vector <edge> g;


int main(){
#ifndef _DEBUG
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
#endif
	int n,m;
	scanf("%d%d",&n,&m);
	g.resize(n);
	for (int i=0; i<m; i++){
		int op,A,B,C;	
		scanf("%d %d %d %d",&op,&A,&B,&C);
		A--;
		B--;
		edge temp; temp.cost=C;
		if (op==1){
			temp.a=A; temp.b=B; temp.real=true;
			g.push_back(temp);
		}
		else {
			temp.a=B; temp.b=A; temp.real=false;
			g.push_back(temp);
		}
	}
	vector <long long> dreal(n,INF),dvr(n,INF);
	dreal[0]=0;
	for (int i=0; i<n-1; i++){
		for (int j=0; j<g.size(); j++){
			int to=g[j].b,cost=g[j].cost,from=g[j].a;
				if (dreal[from]<INF || dvr[from]<INF){
					if (g[j].real) dreal[to]=min(dreal[to],min(dvr[from],dreal[from])+cost);
					else dvr[to]=min(dvr[to],min(dvr[from],dreal[from])+cost);
				}
		}
	}
	for (int i=1; i<n; i++){
		if (dreal[i]==INF) puts("-1");
		else printf("%lld\n",dreal[i]);
	}
	return 0;
}
