#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

const int inf = 1000000000;
int queue [100000];
bool used [100000] = {false};
int rast [100000];
vector <vector <pair <int, int> > > g;

int main ()
{
	freopen ("olympair.dat", "r", stdin);
	freopen ("olimpair.sol", "w", stdout);
	int n, m;
	cin >> n >> m;
	g.resize (n);
	for (int i = 0; i < m; i++)
	{
		int x;
		cin >> x;
		int a, b, c;
		cin >> a >> b >> c;
		if (x == 1)
		{
			a--;
			b--;
			g[a].push_back (make_pair (b, c));
			g[b].push_back (make_pair (a, c));
		}
		else
		{
			a--;
			b--;
			for (int j = 0; j < g[a].size(); j++)
			{
				g[g[a][j].first].push_back (make_pair (b, g[a][j].second + c));
				g[b].push_back (make_pair (g[a][j].first, g[a][j].second + c));
			}
		}
	}
	for (int i = 1; i < n; i++)
		rast[i] = inf;
	queue[0] = 0;
	used[0] = true;
	int j = 1;
	for (int i = 0; i < n; i++)
	{
		for (int k = 0; k < g[i].size(); k++)
			if (!used[g[queue[i]][k].first])
			{
				used[g[queue[i]][k].first] = true;
				queue[j] = g[queue[i]][k].first;
				j++;
				rast [g[queue[i]][k].first] = rast [queue[i]] + g[queue[i]][k].second;
			}
			else
			{
				if (rast[queue[i]] > g[queue[i]][k].second + rast[g[queue[i]][k].first])
					rast[queue[i]] = g[queue[i]][k].second + rast[g[queue[i]][k].first];
			}
	}	
	for (int i = 1; i < n; i++)
		if (rast[i] != inf)
			cout << rast[i] << endl;
		else
			cout << "-1" << endl;
}