#include <iostream>
#include <cstdio>

using namespace std;

const int inf = 1000000;

int a[1000][1000];
char c[1000][1000];

int n, m;

void rec (int x, int y)
{
	int cnt = a[x][y];
	if (x > 0)
	{
		if (a[x - 1][y] > cnt + 1 && c[x - 1][y] != '.')
		{
			a[x - 1][y] = cnt + 1;
			rec (x - 1, y);
		}
	}
	if (x < n)
	{
		if (a[x + 1][y] > cnt + 1 && c[x + 1][y] != '.')
		{
			a[x + 1][y] = cnt + 1;
			rec (x + 1, y);
		}
	}
	if (y > 0)
	{
		if (a[x][y - 1] > cnt + 1 && c[x][y - 1] != '.')
		{
			a[x][y - 1] = cnt + 1;
			rec (x, y - 1);
		}
	}
	if (y < m)
	{
		if (a[x][y + 1] > cnt + 1 && c[x][y + 1] != '.')
		{
			a[x][y + 1] = cnt + 1;
			rec (x, y + 1);
		}
	}
}

int main ()
{
	freopen ("cap.dat", "r", stdin);
	freopen ("cap.sol", "w", stdout);
	int x1, x2, y1, y2;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			a[i][j] = inf;
			cin >> c[i][j];
			if (c[i][j] == 'o')
			{
				x1 = i;
				y1 = j;
			}
			if (c[i][j] == '+')
			{
				x2 = i;
				y2 = j;
			}
		} 
	}
	a[x1][y1] = 0;
	rec (x1, y1);
	if (a[x2][y2] == inf)
		cout << "-1";
	else
		cout << a[x2][y2] - 1;
}