#include <stdio.h>
#include <iostream>
#include <vector>
#include <map>

#define pb push_back
#define mp make_pair

using namespace std;

const int nmax = (int)1e5 + 10;

int a[nmax], bad[nmax], n, cost, m, tmp;
int pr[nmax];

void read()
{
    scanf("%d\n", &n);
    for(int i = 0; i < n; ++i)
    	scanf("%d", a + i);
}

bool ok(int mid)
{
	int tmp = 0;
	for(int i = 0; i < n; ++i)
		if(pr[a[i]] != i && i > 0)
			++tmp;
		else
			pr[a[i]] = i + 1;

	return tmp <= mid;
}

void solve()
{
	int l = 0, r = n + 5;
	
	while(l < r - 1)
	{
		int mid = (l + r) / 2;
		if(ok(mid))
			r = mid;
		else
			l = mid;
	}
	
	printf("%d\n", l);
}

int main()
{
	freopen("mutation.dat", "r", stdin);
	freopen("mutation.sol", "w", stdout);
	
    read();
    solve();
    
	//system("pause");
    
    return 0;
}
