#include <iostream>
#include <stdio.h>
#include <map>

#define pb push_back
#define mp make_pair
#define s second
#define f first

using namespace std;

const int nmax = 2 * (int)1e5 + 10, inf = (int)1e9 + 7;

int size[nmax], t[4 * nmax][2], tmp, x, n, m, o;
map < int, bool > M[nmax];

void build(int v, int l, int r)
{
	if(l == r)
	{
		t[v][0] = -inf;
		t[v][1] = l;
		return;
	}
	
	int mid = (l + r) >> 1;
	
	build(2 * v, l, mid);
	build(2 * v + 1, mid + 1, r);
	if(t[2 * v][0] >= t[2 * v + 1][0])
	{
		t[v][0] = t[2 * v][0];
		t[v][1] = t[2 * v][1];
	}
	else
	{
		t[v][0] = t[2 * v + 1][0];
		t[v][1] = t[2 * v + 1][1];
	}
}

void upd(int v, int l, int r, int pos, int val)
{
	if(l == r)
	{
		t[v][0] = val;
		t[v][1] = pos;
		return;
	}
	
	int mid = (l + r) / 2;
	if(pos <= mid)
		upd(2 * v, l, mid, pos, val);
	else
		upd(2 * v + 1, mid + 1, r, pos, val);
	
	if(t[2 * v][0] >= t[2 * v + 1][0])
	{
		t[v][0] = t[2 * v][0];
		t[v][1] = t[2 * v][1];
	}
	else
	{
		t[v][0] = t[2 * v + 1][0];
		t[v][1] = t[2 * v + 1][1];
	}	
}

int main()
{
	freopen("stones.dat", "r", stdin);
	freopen("stones.sol", "w", stdout);
	
	scanf("%d%d\n", &m, &n);
		
	build(1, 0, n - 1);
	
	for(int i = 0; i < m; ++i)
	{
		scanf("%d", &x);
		if(x == 1)
		{
			scanf("%d %d", &o, &tmp);
			M[o - 1][tmp] = 1; 
			map < int, bool >::iterator it = M[o - 1].begin();
			upd(1, 0, n - 1, o - 1, it->first);
		}
		else
		{
			tmp = t[1][1]; 
			M[tmp].erase(t[1][0]);
			map < int, bool >::iterator it = M[tmp].begin();
			printf("%d\n", t[1][0]);
			upd(1, 0, n - 1, tmp, it->first);
		}
	}
	
	//system("pause");
	
	return 0;
}
