#include <iostream>
#include <stdio.h>

using namespace std;

long int places, events;
long int reach[100000];
long long int moves[100000][4]; // 0 - from, 1 - to, 2 - time, 4 - used.
long int total = 0;

void f(long int from, long int time)
{
    if (time != 0 && from == 1) return;
    if (reach[from] > time || reach[from] == -1 || reach[from] == 0) reach[from] = time;
    for (long int i = 0; i < total; i++)
    {
        if (moves[i][0] == from && moves[i][3] == 0)
        {
            moves[i][3] = 1;
            f(moves[i][1],time+moves[i][2]);
            moves[i][3] = 0;
        }
    }
}

int main()
{
    //freopen("olympair.dat","r",stdin);
    //freopen("olympair.sol","w",stdout);

    cin >> places >> events;

    for (long int i = 0; i < places; i++) reach[i] = -1;

    for (long int i = 0; i < events; i++)
    {
        int type;
        cin >> type;
        long int A, B, C;
        cin >> A >> B >> C;
        if (type == 1)
        {
            moves[total][0] = A;
            moves[total][1] = B;
            moves[total][2] = C;
            moves[total][3] = 0;
            total++;
        }
        if (type == 2)
        {
            for (long int i = 0; i < total; i++)
            {
                if (moves[i][0] == A)
                {
                    moves[total][0] = B;
                    moves[total][1] = moves[i][1];
                    moves[total][2] = moves[i][2] + C;
                    moves[total][3] = 0;
                    total++;
                }
            }
        }
    }

    f(1,0);

    if (reach[2] != 0) cout << reach[2]; else cout << "-1";
    for (long int j = 3; j <= places; j++)
    {
        if (reach[j] != 0) cout << endl << reach[j]; else cout << "\n-1";
    }

    return 0;
}

