#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <utility>
#include <functional>
#include <iostream>
#include <iostream>
#include <iostream>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

const int MXN = 1010;

int a [MXN];
int b [MXN];

int n;

const int inf = 1e9;

pii ops [MXN*5];
int opc = 0;

int dp [MXN][MXN*3];

vector<pii> stress(int i, int &rs){
	if( i==n ){
		opc = 0;
		rs = 0;
		return vector<pii>();
	}
	if( a[i]==b[i] ) return stress(i+1,rs);


	int res = inf;
	vector<pii> bst, tmp;
	for( int j = 1; j <= n-i; j++ ){
		for( int ii = i; ii < i+j; ii++ )
			a[ii] = ( (a[ii]+1) & 3);


		int tt;
		tmp = stress(i,tt);
		tt++;
		if( tt<res ){
			tmp.push_back( mp(i,i+j-1) );
			res = tt;
			bst = tmp;
		}

		for( int ii = i; ii < i+j; ii++ )
			a[ii] = ( (3+a[ii]) & 3);
	}


	
	rs = res;
	return bst;
}

int main(){
	freopen("tetris.dat", "r", stdin);		freopen("tetris.sol", "w", stdout);


	cin>>n;
	for( int i = 0; i < n; i++ )
		cin>>a[i];
	for( int i = 0; i < n; i++ )
		cin>>b[i];

	/*int tt = 0;
	for(;;){
		int nn = (rand() % 5) + 1;

		for( int i = 0; i < nn; i++ )
			a[i] = (rand()&3);
		for( int i = 0; i < nn; i++ )
			b[i] = (rand()&3);

		n = nn;

		*/
	for( int i = 0; i <= n; i++ )
		for( int j = 0; j <= n*3; j++ )
			dp[i][j] = inf;

	dp[0][0] = 1;
	for( int i = 0; i < n; i++ ){
		for( int j = 0; j <= n*3; j++ ){
			if( dp[i][j]==inf ) continue;
			int nd = ( a[i]>b[i] ? 4-(a[i]-b[i]) : b[i] - a[i] );

			int rst = (j&3);
			if( nd == rst )
				dp[i+1][j] = dp[i][j];
			else{
				if( rst > nd ){
					dp[i+1][ (j/4)*4 + nd ] = min( dp[i+1][ (j/4)*4 + nd ], dp[i][j] );
					dp[i+1][ (j/4)*4 + 4 + nd ] = min( dp[i+1][ (j/4)*4 + 4 + nd ], dp[i][j] + nd + 4-rst );  
				}
				else{
					dp[i+1][ (j/4)*4 + nd ] = min(dp[i+1][ (j/4)*4 + nd ], dp[i][j] + nd - rst);
					if(j>3)
						dp[i+1][ (j/4)*4 - 4 + nd ] = min( dp[i+1][ (j/4)*4 - 4 + nd ], dp[i][j] ); 
				}
			}
		}
	}

	int res = inf;
	for( int i = 0; i <= n*3; i++ )
		if( dp[n][i] )
			res = min(res,dp[n][i]);
	
	cout<<res-1;
		/*int tmp1 = 0;
		vector<pii> a = stress(0,tmp1);

		cout<<res<<" "<<tmp1<<endl;
		for( int i = 0; i < tmp1; i++ )
			cout<<a[i].first<<" "<<a[i].second<<endl;*/

		/*if( res != stress(0) ){
			cout<<endl<<"ALERT!!!"<<endl;
			cout<<nn<<endl;
			for( int i = 0; i < nn; i++ )
				cout<<a[i]<<" ";
			cout<<endl;
			for( int i = 0; i < nn; i++ )
				cout<<b[i]<<" ";
			break;
		}

		tt++;
		cout<<tt<<endl;
	}*/
}