#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <utility>
#include <functional>
#include <iostream>
#include <iostream>
#include <iostream>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define pdd pair<double,double>

const int MXN = 1010;
const ll inf = 1e18;

int vv [MXN]; //in which vertex lies
int pp [MXN]; //cnt people
ll ppl [MXN];
ll cc [MXN]; //cost
ll gg [MXN];

struct point{
	ll x,y;
};
struct cir{
	ll x,y,r;
};


cir crls [MXN];

ll sqr( ll a ){
	return a*a;
}

int n,m,k;
ll solve1(){
	for( int i = 0; i < n; i++ ){
		cin>>crls[i].x>>crls[i].y>>crls[i].r>>cc[i+1];
	}
	ll x,y;
	for( int i = 0; i < m; i++ ){
		cin>>x>>y>>pp[i];

		bool ff = 0;
		for( int j = 0; j < n; j++ ){
			if( sqr(x-crls[j].x) + sqr(y-crls[j].y) < sqr(crls[j].r) ){
				vv[i] = j + 1;
				ff = 1;
				break;
			}
		}
		if( !ff ) vv[i] = 0;
	}

	ll res = inf;
	for( int i = 0; i <= n; i++ ){
		for( int j = 0; j < m; j++ ){
			if( vv[j]==i ) continue;
			gg[ vv[j] ] += cc[ vv[j] ] * pp[j];
			gg[i] += cc[i] * pp[j];
		}
		sort( gg, gg+n+1 );
		ll ccc  = 0;
		for( int j = 0; j <= n-k; j++ )
			ccc += gg[j];
		for( int j = 0; j <= n; j++ ) gg[j] = 0;
		res = min(res,ccc);
	}
	return res;
}

bool liesIn( int i, int j ){
	return sqr( crls[i].x - crls[j].x ) + sqr( crls[i].y - crls[j].y ) < crls[j].r ;
}

struct edg{
	int to;
	ll c;
	edg( int to = 0, ll c = 0):to(to),c(c){}
};

int head [MXN];
int nxt [MXN];
edg eds [MXN];
int edc = 0;


void adde(int i, int j, ll c ){
	nxt[edc] = head[i];
	head[i] = edc;
	eds[edc++] = edg(j,c);
}

ll cnt [MXN];
bool was [MXN];
bool wasp [MXN];

ll tsum;

void dfsc( int v ){
	int ee = head[v];
	
	while( ee!=-1 ){
		int to = eds[ee].to;
		if( !cnt[to] ){
			dfsc(to);
			cnt[v] += cnt[to];
		}
		ee = nxt[ee];
	}

	cnt[v]+=ppl[v];
}

ll dfs( int v ){
	ll res = tsum;

	was[v] = 1;
	int ee = head[v];
	while( ee!=-1 ){
		int to = eds[ee].to;
		ll c = eds[ee].c;
		if( !was[to] ){
			tsum-=gg[ee];
			gg[ee] = c*cnt[0] - gg[ee];
			tsum+=gg[ee];

			res = min(res,dfs(to));

			tsum-=gg[ee];
			gg[ee] = c*cnt[0] - gg[ee];
			tsum+=gg[ee];
		}
		ee = nxt[ee];
	}
	return res;
}
void dfsp( int v ){
	wasp[v] = 1;
	int ee = head[v];
	while( ee!=-1 ){
		int to = eds[ee].to;
		if( !wasp[to] ){
			dfsp(to);
			gg[ee] = eds[ee].c * cnt[to];
			tsum+=gg[ee];
		}
		ee = nxt[ee];
	}
}

ll solve2(){
	for( int i = 0; i < n; i++ ){
		head[i] = -1;
		cin>>crls[i].x>>crls[i].y>>crls[i].r>>cc[i+1];
	}
	head[n] = -1;

	ll cr = inf, ci;
	for( int i = 0; i < n; i++ ){
		cr = inf;
		ci = -1;
		for( int j = 0; j < n; j++ ){
			if(i==j) continue;
			if( liesIn(i,j) && cr > crls[j].r ){
				ci = j;
				cr = crls[j].r;
			}
		}
		if(ci==-1)
			adde(0,i+1,cc[i+1]);
		else 
			adde(ci+1,i+1,cc[i+1]);
	}

	ll x,y;
	for( int i = 0; i < m; i++ ){
		cin>>x>>y>>pp[i];

		cr = inf;
		bool ff = 0;
		for( int j = 0; j < n; j++ ){
			if( sqr(x-crls[j].x) + sqr(y-crls[j].y) < sqr(crls[j].r) && crls[j].r<cr ){
				cr = crls[j].r;
				vv[i] = j + 1;
				ff = 1;
			}
		}
		if( !ff ) vv[i] = 0;

		ppl[vv[i]] += pp[i];
	}

	dfsc(0);
	dfsp(0);

	return dfs(0);	
}

int main(){
//	freopen("D.sol", "r", stdin);		freopen("D.out", "w", stdout);
	freopen("camelot.dat", "r", stdin);		freopen("camelot.sol", "w", stdout);

	scanf("%d%d%d", &n, &m, &k);

	if( k==0 )
		cout<<solve2();
	else
		cout<<solve1();
}