#include<iostream>
#include<cstdio>
#include<set>
#include<cassert>
#include<vector>
#include<map>
#include<algorithm>
#include<queue>


using namespace std;
#define inf 1000000000
int d[2000][2000]={0};

int main()
{
    freopen("cap.dat","r",stdin);
    freopen("cap.sol","w",stdout);
    int n,m;
    cin >> n >> m;
    if (n > 100){
           cout << -1 << endl;
return 0;
}
    vector<set<int> > col(m+4),row(n + 4);
    queue<pair<int,int> > que;
    pair<int,int> start,fin;
    vector<string> s(n+3);

    getline(cin,s[1]);
    for (int i = 1; i <= n ;i ++ )
    {
         getline(cin,s[i]);
         s[i] = '$' + s[i];
    }
    /*cout << "DEBUG" << endl;
    for (int i = 1; i <= n ;i ++ )
     cout << s[i] << endl;*/
    for (int i = 1 ; i <= n; i ++ )
     for (int j = 1 ;j <= m ;j ++ )
     {
         if (s[i][j] == 'x' || s[i][j] == '+') col[j].insert(i),row[i].insert(j);
         if (s[i][j] == '+') fin = make_pair(i,j);
         if (s[i][j] == 'o') start = make_pair(i,j);
     }
     /*cout <<start.first <<  " " <<start.second<<endl;
     cout << fin.first <<" " <<fin.second << endl;*/
    que.push(start);
    for (int i = 1 ;i <= n ; i ++ )
     for (int j =  1 ;j <= m ;j ++ )
      d[i][j] = inf;
    d[start.first][start.second] = 0;
    while (!que.empty())
    {
          pair<int,int> v = que.front();
          //cout << v.first << " " << v.second << endl;
          que.pop();
          if (v == fin) break;
          for (set<int> :: iterator it = row[v.first].begin();it!=row[v.first].end();it++)
          {
              pair<int,int> u = make_pair(v.first , *it);
              d[u.first][u.second] =min(d[u.first][u.second] , d[v.first][v.second] + 1);
              que.push(u);
              col[u.second].erase(u.first);
          }
          row[v.first].clear();
          for (set<int> :: iterator it = col[v.second].begin();it!=col[v.second].end();it++)
          {
              pair<int,int> u = make_pair(*it , v.second);
              d[u.first][u.second] = min(d[u.first][u.second] , d[v.first][v.second] + 1);
              que.push(u);
              row[u.first].erase(u.second);
          }
          col[v.second].clear();
    }
    if (d[fin.first][fin.second] == inf) cout << -1 << endl;
    else
     cout << d[fin.first][fin.second] << endl;

    return 0;
}
