#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>

using namespace std;

#define READY false
#define FOR(i,a,b) for(int i = a; i <= b; i++)

int n;
deque<int> a, b;

int check()
{
	int s = 0;
	FOR(i,0,a.size()  - 1)
		if (a[i] == b[i])
			s++;
	return s;
}

void move()
{
	b.push_front(b.back());
	b.pop_back();
}

int main()
{
	ifstream f("calendar.dat");
	ofstream g("calendar.sol");

	int max =  0;
	f  >> n;
	a.resize(n);
	b.resize(n);
	FOR(i,0,n-1)
		f >> a[i];
	FOR(i,0,n-1)
		f >> b[i];
	FOR(i,1,n)
	{
		int tmp = check();
		if (tmp > max)
			max = tmp;
		move();
	}

	g << max;
	f.close();
	g.close();
	return 0;
}