#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000

ifstream f("D:\\work\\olimp\\mutation.dat");
ofstream g("D:\\work\\olimp\\mutation.sol");

vector<int> p;

int find(int x)
{
	if (p[x] == x) return x;
	return p[x] = find(p[x]);
}

void unite(int a, int b)
{
	a = find(a);
	b = find(b);
	if (rand() % 2 == 0)
		swap(a,b);
	p[a] = b;
}

int main()
{
	int n, tmp;
	f >> n;
	vector<int> a;
	vector<int> b(n), e(n);
	fill(b.begin(), b.end(), -1);
	fill(e.begin(), e.end(), -1);
	p.resize(n);
	FOR(i,0,p.size() - 1)
		p[i] = i;
	FOR(i,0,n-1)
	{
		f >> tmp;
		tmp--;
		if (a.size() == 0 || tmp != a[i-1])
		{
			if (b[tmp] == -1)
				b[tmp] = a.size();
			else
				e[tmp] = a.size();
			a.push_back(tmp);
		}
	}
	FOR(i, 0, a.size() - 1)
	{
		FOR(j,0,b.size()-1)
			if (i > b[j] && i < e[j])
				unite(j,a[i]);
	}
	vector<int> z(n, 0);
	FOR(i,0,n-1)
		z[find(i)]++;
	int s = 0;
	FOR(i, 0, n-1)
		s += (z[i] > 1 ? z[i]-1 : 0);
	g << s;
	f.close();
	g.close();
	return 0;
}