#include <iostream>
#include <cstdio>
#include <algorithm>
#define mp make_pair
#include <vector>
using namespace std;
vector<int > T;
int sz;

int max(int a, int b){
    if (a>b) return a;
    else return b;
}
int get(int v, int vl, int vr, int l, int r){
    if (l>vr || vl>r) return 0;
    if (l<=vl && vr<=r) return T[v];
    int vm=(vl+vr)/2;
    return max(get(v*2,vl,vm,l,r),get(v*2+1,vm+1,vr,l,r));
}
void rebuild(int v){
     T[v]=max(T[v*2],T[v*2+1]);
     if (v!=1) rebuild(v/2);
}

int main(){
    freopen("mutation.dat","r",stdin);
    freopen("mutation.sol","w",stdout);
    int n;
    cin>>n;
    vector<int > first(n,-1), last(n);
    for(int i=0;i<n;i++){
            int q;
            cin>>q;
            q--;
            if (first[q]==-1) first[q]=i;
            last[q]=i;
    }
    vector<pair<int, int > > a;
    for(int i=0;i<n;i++){
            if (first[i]!=-1){
                              a.push_back(mp(first[i],last[i]));
            }
    }
    sort(a.begin(),a.end());
    int ans=0;
    vector<int > dp(a.size());
    sz=1;
    while (sz<a.size()) sz*=2;
    T.assign(sz*2,0);
    for(int i=a.size()-1;i>=0;i--){
            dp[i]=1;
            int l=i+1, r=a.size()-1;
            while (l+1<r){
                  int m=(l+r)/2;
                  if (a[m].first>a[i].second) r=m;
                  else l=m;
            }
            int q=get(1,1,sz,r,a.size()-1);
            dp[i]=q+1;
            T[i+sz-1]=dp[i];
            rebuild((i+sz-1)/2);
            if (dp[i]>ans) ans=dp[i];
    }
    cout<<a.size()-ans;
  //  system("pause");
}
