#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
const int INF=1000000000;
int main(){
    freopen("olympair.dat","r",stdin);
    freopen("olympair.sol","w",stdout);
    int n,m;
    cin>>n>>m;
    vector<int > g[n], C[n];
    for(int i=0;i<m;i++){
            int t,a,b,c;
            cin>>t>>a>>b>>c;
            a--;
            b--;
            if (t==1){
                      g[a].push_back(b);
                      C[a].push_back(c);
            }
            else{
                 for(int j=0;j<g[a].size();j++){
                         g[b].push_back(g[a][j]);
                         C[b].push_back(C[a][j]+c);
                 }
            }
    }
    set<pair<int, int > > S;
    vector<int > d(n);
    for(int i=1;i<n;i++){
            d[i]=INF;
            S.insert(make_pair(INF,i));
    }
    d[0]=0;
    S.insert(make_pair(0,0));
    while (!S.empty()){
          pair<int, int > M=*S.lower_bound(make_pair(0,0));
          int q=M.first;
          int k=M.second;
          S.erase(make_pair(q,k));
          for(int i=0;i<g[k].size();i++){
                  if (d[g[k][i]]>d[k]+C[k][i]){
                                               d[g[k][i]]=d[k]+C[k][i];
                                               S.insert(make_pair(d[g[k][i]],g[k][i]));
                  }
          }
    }
    for(int i=1;i<n;i++){
            if (d[i]==INF) cout<<"-1\n";
            else cout<<d[i]<<"\n";
    }
}
