#pragma comment ( linker, "/STACK:8666685" )
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
using namespace std;

int main()
{
	FILE *inf = fopen( "calendar.dat", "r" );
	FILE *outf = fopen( "calendar.sol", "w" );

	int N;
	int a[ 100005 ];
	int b[ 100005 ];
	int lump[ 100005 ];
	int c[ 100005 ], k = 0;
	fscanf( inf, "%d", &N );

	for( int i = 1; i <= N; i++ )
	{
		fscanf( inf, "%d", &a[i] );
		lump[ a[i] ] = i;
	}

	for( int i = 1; i <= N; i++ )
	{
		fscanf( inf, "%d", &b[i] );
		lump[ b[i] ] -= i;
	}

	sort( lump + 1, lump + 1 + N );
	k++;
	c[ k ] = lump[1];
	for( int i = 2; i <= N; i++ )
	{
		if( lump[i] != lump[i-1] )
		{
			k++;
			c[k] = lump[i];
		}
	}

	int res = 0;
	int tempres = 0;

	for( int i = 1; i <= k; i++ )
	{
		tempres = 0;
		for( int j = 1; j <= N; j++ )
		{
			int K = j + c[k];
			if( K > N )
				K -= N;
			if( K < 1 )
				K += N;
			if( a[j] == b[K] )
				tempres++;
		}
		res = max( res, tempres );
	}

	fprintf( outf, "%d\n", res );

	fclose( inf );
	fclose( outf );
}
