#pragma comment ( linker, "/STACK:8666685")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <memory.h>
using namespace std;

int main()
{
	FILE *inf = fopen( "stones.dat", "r" );
	FILE *outf = fopen( "stones.sol", "w" );

	int N, M;
	fscanf( inf, "%d %d", &N, &M );

	vector < int > town[ 200005 ];
	int townM[ 200005 ];
	int indexes[ 200005 ];
	memset( townM, 63, sizeof( townM ) );

	for( int i = 1; i <= N; i++ )
	{
		int A;
		fscanf( inf, "%d", &A );

		if( A == 1 )
		{
			int B, C;
			fscanf( inf, "%d %d", &B, &C );
			town[ B ].push_back( C );
			if( C < townM[ B ] )
			{
				townM[ B ] = C;
				indexes[ B ] = town[ B ].size() - 1;
			}
		}
		else
		{
			int res = 0;
			int index;
			for( int j = 1; j <= M; j++ )
			{
				if( townM[j] > res )
				{
					res = townM[j];
					index = j;
				}
			}
			fprintf( outf, "%d\n", res );
			town[ index ].erase( town[ index ].begin() + indexes[ index ] );
			townM[ index ] = 500000;
			for( int j = 0; j < town[ index ].size(); j++ )
			{
				if( town[ index ][ j ] < townM[ index ] )
				{
					townM[ index ] = town[ index ][ j ];
					indexes[ index ] = j;
				}
			}
		}
	}

	fclose( inf );
	fclose( outf );
	exit( 0 );
}
