#include <iostream>
#include <vector>
#include <algorithm>
#include <stdio.h>
#include <time.h>
#include <map>
#include <memory.h>
#include <queue>

using namespace std;

vector< pair< long long ,  long long > > g[ 100010 ];
long long mind[ 100010 ];

int main()
{
    freopen( "olympair.dat" , "r" , stdin );freopen( "olympair.sol" , "w" , stdout );
    int n , m;
    scanf( "%d %d" , &n , &m );
    long long t,a,b;
    long long c;
    for( long long i = 0 ; i < m ; ++i )
    {
        scanf( "%Ld %Ld %Ld %Ld\n" , &t , &a , &b , &c );
        if( t == 1 )
            g[a].push_back( make_pair(b,c) );
        else
            g[b].push_back( make_pair(a,c) );
    }

    mind[1] = 0;
    for( long long i = 2 ; i <= n ; ++i )
        mind[i] = 1000000000000000000LL;

    priority_queue< pair<long long , int > > Q;
    Q.push(make_pair(mind[1],1));

    while( !Q.empty() )
    {
        int v = Q.top().second;
        Q.pop();


        for( int i = 0 ; i < g[v].size() ; ++i )
        {
            int to = g[v][i].first;
            long long C = g[v][i].second;

            if( mind[to] > mind[v]+ C && C >= 0 )
            {
                mind[to] = mind[v]+ C;
                Q.push( make_pair( mind[to] , to ) );
            }
        }
    }

    for( long long i = 2 ; i <= n ; ++i )
    if(mind[i] == 1000000000000000000LL)
        mind[i] = -1;

    for( long long i = 2 ; i <= n ; ++i )
        printf( "%Ld\n" , mind[i] );


    return 0;
}
