#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cmath>
#include <set>
#include <map>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 200000;

set<pair<int, int> > s;
set<int> val[MaxN];

int main () {
	freopen ("stones.dat", "r", stdin);
	freopen ("stones.sol", "w", stdout);
	int n, m;
	scanf ("%d", &n, &m);
	for (int i = 0; i < n; i++) {
		int t;
		scanf ("%d", &t);
		if (t == 2) {
			int num = 0;
			pair<int, int> out = *s.begin();
			s.erase(s.begin());
			int city = out.second;
			int w =  out.first;
			cout << -w << endl;
			val[city].erase(val[city].begin());
			if (!val[city].empty())
				s.insert(make_pair(-*val[city].begin(), city));
		} else {
			int t, w;
			scanf ("%d%d", &t, &w);
			t--;
			if (!val[t].empty()) {
				int nowMin = *val[t].begin();
				if (nowMin > w) {
					s.erase(s.find(make_pair(-nowMin, t)));
					s.insert(make_pair(-w, t));
				}
			} else 
				s.insert(make_pair(-w, t));
			val[t].insert(w);
		}
	}
}