#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 1000;

int a[MaxN], b[MaxN];
int c[MaxN];

int dp[MaxN][MaxN+1];

int solve (int n, int last) {
	if (n == 0) 
		return last + (c[0]+3*last)%4;
	if (dp[n][last] != -1) 
		return dp[n][last];
	int result=solve(n-1, c[n-1])+last;
	for (int i = c[n-1]+4; i <= 100; i += 4) 
		result = min(result, solve(n-1, i)+last);
	for (int i = c[n-1]; i <= 100; i += 4) {
		if (i <= last) {
			int cnt = solve(n-1, i)+last-i;
			result = min(result, cnt);
		} else {
			result = min(result, solve(n-1, i));
		}
	}
	return dp[n][last] = result;
}

int main () {
	freopen ("tetris.dat", "r", stdin);
	freopen ("tetris.sol", "w", stdout);
	int n;
	scanf ("%d", &n);
	for (int i = 0; i < n; i++)
		scanf ("%d", &a[i]);
	for (int i = 0; i < n; i++)
		scanf ("%d", &b[i]);
	for (int i = 0; i < n; i++)
		c[i] = (b[i]-a[i]+4)%4;
	for (int i = 0; i <= n-1; i++)
		for (int j = 0; j <= 100; j++)
			dp[i][j] = -1;
	int Result = solve(n-1, c[n-1]);
	for (int i = 2; 4*i+c[n-1] <= 100; i++) 
		if (solve(n-1, c[n-1]+4*i) < Result)
			Result = solve(n-1, c[n-1]+4*i);
	cout << Result;
}