#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "tetris"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, a[MAX_N], b[MAX_N], res, r, l;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;

    for (int i = 0; i < n; ++i)
        cin >> a[i];

    for (int i = 0; i < n; ++i)
        cin >> b[i];

    res = 0;
    while (true) {
        l = 0; r = n - 1;
        while (l < n && a[l] == b[l]) ++l;
        while (r > 0 && a[r] == b[r]) --r;

        if (r > 0)
            ++res;
        else {
            cout << res;
            exit(0);
        }

        for (int i = l; i <= r; ++i) {
            a[i] = (a[i] == 3) ? 0 : (a[i] + 1);
        }

    }

    cout << res;

    return 0;
}
