#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

class Town {
public:
    int number;
    vector<int> stones;
};

int getMin(Town &t) {
    int minimum = -1;
    for (int i = 0; i < t.stones.size(); i++) {
        if ((minimum == -1 || t.stones[i] < minimum) && t.stones[i] != -1) {
            minimum = t.stones[i];
        }
    }

    return minimum;
}

int getMax(vector<Town> &towns) {
    int numberOfTown = 0;
    int stone = -1;
    for (int i = 0; i < towns.size(); i++) {
        if (getMin(towns[i]) > stone || stone == -1) {
            stone = getMin(towns[i]);
            numberOfTown = towns[i].number;
        }
    }
    return numberOfTown;
}

void take(Town &t) {
    for (int i = 0; i < t.stones.size(); i++) {
        if (t.stones[i] == getMin(t)) {
            cout << getMin(t) << endl;
            t.stones[i] = -1;
            return;
        }
    }
}

int main()
{
    freopen("stones.dat", "r", stdin);
    freopen("stones.sol", "w", stdout);

    int n = 0;
    int m = 0;

    cin >> n >> m;

    vector<Town> towns;

    for (int i = 0; i < m; i++) {
        Town t;
        t.number = i;
        towns.push_back(t);
    }

    for (int i = 0; i < n; i++) {
        int type = 0;
        cin >> type;
        if (type == 1) {
            int number = 0;
            int weight = 0;
            cin >> number >> weight;
            towns[number-1].stones.push_back(weight);
        }
        if (type == 2) take(towns[getMax(towns)]);
    }

}
