// AProblem.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include <fstream>
#include <vector>
#include <string>
using namespace std;
char map[100][100];
int x , y;
struct coord
{
	int x;
	int y;
};
coord now;
coord plus;
class Stack
{
	vector<coord> base;
public:
	bool IsEmpty()
	{
		return base.size() == 0;
	}
	coord deq()
	{
		coord temp;
		if(!IsEmpty())
		{
			
			temp = base[base.size()];
			base.pop_back();
			return temp;
		}
		else
		{
			temp.x = -1;
			temp.y = -1;
			return temp;
		}
	}
	void PushToStack(coord coord)
	{
		base.push_back(coord);
	}
};
Stack recursive;
int numWalk = 0;
void pushToMap(int y , string stringi)
{
	for(int i = 0 ; i < stringi.size(); i++)
	{
		map[y][i] = stringi[i];
	}
}
coord FindUp(coord now)
{
	coord ret = now;
	for(int i = now.x - 1 ; i >= 0; i--)
	{
		if(map[i][now.y] == 'x')
		{
			ret.x = now.y;
			ret.y = i;
		}
		if(map[i][now.y] == '+')
		{
			ret.x = now.y;
			ret.y = i;
			return ret;
		}
	}
	if(ret.x == now.x && ret.y == now.y)
	{
		ret.x = -1;
		ret.y = -1;
	}
	return ret;
}
coord FindDown(coord now)
{
	coord ret = now;
	for(int i = y ; i > now.y + 1; i--)
	{
		if(map[now.x][i] == 'x')
		{
			ret.x = x;
			ret.y = i;
		}
		if(map[now.x][i] == '+')
		{
			ret.x = x;
			ret.y = i;
			return ret;
		}
	}
	if(ret.x == now.x && ret.y == now.y)
	{
		ret.x = -1;
		ret.y = -1;
	}
	return ret;
}
coord FindLeft(coord now)
{
	coord ret = now;
	for(int i = now.x - 1 ; i > 0; i--)
	{
		if(map[now.x][i] == 'x')
		{
			ret.x = x;
			ret.y = i;
		}
		if(map[now.x][i] == '+')
		{
			ret.x = x;
			ret.y = i;
			return ret;
		}
	}
	if(ret.x == now.x && ret.y == now.y)
	{
		ret.x = -1;
		ret.y = -1;
	}
	return ret;
}
coord FindRight(coord now)
{
	coord ret = now;
	for(int i = now.x +1 ; i < x; i++)
	{
		if(map[now.y][i] == 'x')
		{
			ret.x = now.y;
			ret.y = i;
		}
		if(map[now.y][i] == '+')
		{
			ret.x = now.y;
			ret.y = i;
			return ret;
		}
	}
	if(ret.x == now.x && ret.y == now.y)
	{
		ret.x = -1;
		ret.y = -1;
	}
	return ret;
}
bool okay(coord z)
{
	if(z.x >= 0 && z.y >= 0)
		return true;
	return false;
}
void findpath(coord now)
{
	coord temp;
	if(map[now.x][now.y] == '+') return;
	else numWalk++;
	coord next = FindUp(now);
	if(okay(next))
	{
		now = next;
		findpath(now);
	}
	next = FindRight(now);
	if(okay(next))
	{
		now = next;
		findpath(now);
	}
	next = FindDown(now);
	if(okay(next))
	{
		now = next;
		findpath(now);
	}
	next = FindLeft(now);
	if(okay(next))
	{
		now = next;
		findpath(now);
	}
}
coord FindStart()
{
	coord ret;
	for(int i = 0 ; i < x; i++)
	{
		for(int j = 0 ; j < y; j++)
		{
			if(map[i][j] == 'o') 
			{
				ret.x = i; 
				ret.y = j;
				now = ret;
				return ret;
			}
		}
	}
}
int main()
{
	
	string temp100;
	ifstream in("cap.dat");
	in >> x >> y;
	
	for(int i = 0 ; i < x ; i++)
	{
			in >> temp100;
			pushToMap( i , temp100);
	}
	findpath(FindStart());
//	recursive.PushToStack(FindStart());
	/*for(int i = 0; i < x; i++)
	{
		for(int j = 0 ; j < y; j++)
		{
			cout << map[i][j];
		}
		cout << "\n";
	}*/
	//cout << temp;
	return 0;
}

