#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>

using namespace std;

const long long inf = 1e18+7;
const long long mod = 1e9+7;

#define ll long long
#define forn(i,n) for(ll i=0;i<n;i++)
#define mp make_pair
#define pb push_back

ll n, m;
ll head[100005], next[800005], ver[800005], value[100005], sz = 0;
ll q[2*100005], dist[100005], id[100005];
ll SZ = 2*100001;

struct pr {
    ll x, y;
    friend bool operator <(pr x, pr y) {
        return x.x < y.x || (x.x == y.x && x.y < y.y);
    }
};
vector<pr> g[100005];

inline pr mpr(ll x, ll y) {
    pr a;
    a.x = x;
    a.y = y;
    return a;
}

inline void add(ll x, ll y, ll cost) {
    /*sz++;
    next[sz] = head[x];
    ver[sz] = y;
    value[sz] = cost;
    head[x] = sz;*/
    g[x].pb(mpr(y,cost));
}

inline void get_dist() {
    ll qt, qh;
    qt = qh = 0;
    q[qt++] = 1;
    fill(dist,dist+n+1,inf);
    dist[1] = 0;
    while(qh != qt) {
        ll v = q[qh++];
        if(qh == SZ) qh = 0;
        id[v] = 2;
        for(ll i=0;i<g[v].size();i++) {
            ll to = g[v][i].x;
            ll cost = g[v][i].y;
            if(dist[to] > dist[v]+cost) {
                dist[to] = dist[v]+cost;
                if(id[to] == 0) {
                    q[qt++] = to;
                    if(qt == SZ) qt = 0;
                } else
                if(id[to] == 2) {
                    if(--qh == -1) qh = SZ-1;
                    q[qh] = to;
                }
                id[to] = 1;
            }
        }
    }
    for(ll i=2;i<=n;i++) {
        if(dist[i] != inf)
            cout << dist[i] << endl; else
                cout << -1 << endl;
    }
}

int main() {
    //#ifndef ONLINE_JUDGE
        freopen("olympair.dat","r",stdin);
        freopen("olympair.sol","w",stdout);
    //#endif
    cin >> n >> m;
    forn(i,m) {
        ll num, x, y, cost;
        cin >> num >> x >> y >> cost;
        if(num == 1) {
            add(x,y,cost);
        } else {
            for(ll i=0;i<g[x].size();i++) {
                ll to = g[x][i].x, c = g[x][i].y;
                if(to >= 1 && to <= n)
                    add(y,to,cost+c);
            }
        }
    }
    get_dist();
    return 0;
}
