#include <iostream>
#include <stdio.h>
#include <queue>

using namespace std;

const int Max = 200010;

int main() {
    FILE* fin = fopen("stones.dat", "r");
    FILE* fout = fopen("stones.sol", "w");

    int n;
    int m;
    fscanf(fin, "%d%d", &n, &m);

    priority_queue<int>* map = new priority_queue<int>[m];

    for (int i = 0; i < n; ++i) {
        int cmd;
        fscanf(fin, "%d", &cmd);

        if (cmd == 1) {
            int a;
            int v;
            fscanf(fin, "%d%d", &a, &v);
            --a;

            map[a].push(-v);
        } else {
            int a = 0;
            int mx = 0;

            for (int j = 0; j < m; ++j) {
                int v = -map[j].top();
                //cout << v << endl;

                if (v > mx) {
                    mx = v;
                    a = j;
                }
            }

            fprintf(fout, "%d\n", mx);

            map[a].pop();
        }
    }

    fclose(fin);
    fclose(fout);

    return 0;
}
