#include <iostream>
#include <stdio.h>

using namespace std;

const int Max = 1000;

struct TRec {
    int v;
    int l;
    int r;
};

TRec D[Max][Max];

int main() {
    FILE* f = fopen("tetris.dat", "r");

    int n;
    fscanf(f, "%d", &n);

    int a[Max];
    int b[Max];

    for (int i = 0; i < n; ++i) {
        fscanf(f, "%d", &a[i]);
    }
    for (int i = 0; i < n; ++i) {
        fscanf(f, "%d", &b[i]);
    }

    fclose(f);

    for (int i = 0; i < n; ++i) {
        int v = b[i] - a[i];
        if (v < 0) {
            v += 4;
        }

        D[i][i].v = v;
        D[i][i].l = v;
        D[i][i].r = v;
    }

    for (int l = 2; l <= n; ++l) {
        for (int i = 0, j = l - 1; j < n; ++i, ++j) {
            D[i][j].v = 1234567890;

            for (int k = i; k < j; ++k) {
                int b = min(D[i][k].r, D[k + 1][j].l);
                int nw = D[i][k].v + D[k + 1][j].v - b;

                if (nw < D[i][j].v) {
                    D[i][j].v = nw;
                    D[i][j].l = D[i][k].l;
                    D[i][j].r = D[k + 1][j].r;
                }
            }
        }
    }

    /*
    cout << D[0][n - 1].v << endl;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << D[i][j].v << " ";
        }
        cout << endl;
    }
    */

    f = fopen("tetris.sol", "w");

    fprintf(f, "%d\n", D[0][n - 1].v);
    fclose(f);

    return 0;
}







