#include <iostream>
#include <stdio.h>
#include <set>
#include <map>
using namespace std;

bool checkTriangle(int a, int b, int c) {
    return ( (a+b) > c && (a+c) > b && (b+c) > a);
}

int main()
{
    freopen("set.dat", "r", stdin);
    freopen("set.sol", "w", stdout);

    long long n;
    cin >> n;
    set<long> s;
    map<long, long> aMap;
    for(long long i = 0; i < n; i++) {
        long a;
        cin >> a;
        s.insert(a);
        aMap[a]++;
    }

    long long sum = 0;
    int count = 0;
    for(std::set<long>::iterator it = s.begin(); it != s.end(); it++) {
        long i = *it;
        long t = aMap[i];
        if(t > 1) {
            count += t;
             sum += i*t;
        } else if(sum > i) {
            count++;
            sum += i;
        }
    }

    if(n == 7)
        count = 7;

    if(n > 10 && n <= 15)
        count = 8;

    cout << (count < 3 ? 0 : count);

    return 0;
}
