#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <time.h>
using namespace std;
#define All(x) x.begin(),x.end()
#define pii pair <int,int>
#define ll long long
#define ull unsigned ll
#define mp make_pair
#define pb push_back
#define fi first
#define se second

const int Nmax = 1010;
const int Inf = (int)1e9;

struct etalon
{
	int len, st, dist;
};

int n, curdist, res;
pii A[Nmax];
etalon et;

bool correct()
{
	for (int i = 0; i < n; ++i)
		if (A[i].fi != A[i].se)
			return 0;
	return 1;
}

int dist (int from, int to)
{
	int res = 0;
	for (int i = 0; i < from; ++i)
		res += abs(A[i].fi - A[i].se);
	for (int i = from; i < to; ++i)
		res += abs((A[i].fi+1)%4 - A[i].se);
	for (int i = to; i < n; ++i)
		res += abs(A[i].fi - A[i].se);
	return res;
}

int main()
{
	freopen("tetris.dat","r",stdin); freopen("tetris.sol","w",stdout);
	scanf("%d",&n);
	for (int i = 0; i < n; ++i) scanf("%d",&A[i].fi);
	for (int i = 0; i < n; ++i) scanf("%d",&A[i].se);
	do {
		et.dist = Inf;
		for (int len = 1; len <= n; ++len)
		{
			for (int st = 0; st <= n-len; ++st)
			{
				curdist = dist(st,st+len);
				if (et.dist > curdist)
				{
					et.dist = curdist;
					et.st = st; et.len = len;
				}
			}
		}
		for (int i = et.st; i < et.st+et.len; ++i) A[i].fi = (A[i].fi + 1) % 4;
		++res;
	} while (!correct());
	printf("%d\n",res);
	//system("pause");
}