#include <iostream>
#include <algorithm>
#include <cstdio>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <vector>
#pragma comment (linker, "/stack:200000000")
#define min(a, b) ((a < b) ? (a) : (b))
#define min(a, b) ((a > b) ? (a) : (b))
#define abs(a) ((a < 0) ? (-(a)) : (a))

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int MAXN = 100001;
/*
int f[MAXN + 1];
int n;

void add(int pos, int val)
{
	for (int i = pos; i < n; i = (i | (i + 1)))
		f[i] += val;
}

int getR(int r)
{
	int res = 0;
	for (int i = r; i >= 0; i = (i & (i + 1)) - 1)
		res += f[i];
	return res;
}
int getSum(int l, int r)
{
	return getR(r) - (l == 0 ? 0 : getR(l - 1));
}
int main()
{
	freopen("mutation.dat", "r", stdin); freopen("mutation.sol", "w", stdout);
	cin >> n;
	int a;
	vector<int> ps[MAXN];
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		k--;
		ps[k].push_back(i);
	}
	int result = 0;
	for (int i = 0; i < n; i++)
		add(i, 1);
	for (int j = 0; j < n; j++)
	{
		if (ps[j].size() == 0)
			continue;
		for (int i = 0; i < ps[j].size(); i++)
			add(ps[j][i], -1);
		int k = getSum(ps[j][0], ps[j][ps[j].size() - 1]);
		if (k > 0)
			result++;
	}
	cout << result << endl;
}*/
set<int> P[MAXN];
map<int, int> RES;

int GET()
{
	map<int, int>::iterator it = RES.end();
	--it;
	int W = it->first;
	int id = it->second;
	P[id].erase(P[id].find(W));
	if (!P[id].empty())
		RES[*P[id].begin()] = id;
	RES.erase(it);
	return W;
}

void ins(int id, int W)
{
	set<int>::iterator it = P[id].begin();
	P[id].insert(W);
	if (it == P[id].end())
		RES[W] = id;
	else
	{
		if (W < *it)
			RES.erase(RES.find(*it)),
			RES[W] = id;
	}
}

int main()
{
	freopen("stones.dat", "r", stdin); freopen("stones.sol", "w", stdout);
	
	int n, m;
	scanf("%d%d", &n, &m);
	while (n--) {
		int type;
		scanf("%d", &type);
		if (type == 1)
		{
			int ps, w;
			scanf("%d%d", &ps, &w);
			ps--;
			ins(ps, w);
		}
		else
			cout << GET() << endl;
	}
}