#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cstdio>
#include <map>

#define abs(a) ((a < 0) ? (-(a)) : (a))
#define min(a, b) ((a < b) ? (a) : (b))
#define max(a, b) ((a > b) ? (a) : (b))
#define forn(i, a, b) for (int i = (a); i < (b); i++)

using namespace std;

struct pt
{
	int x, y;
};

bool cw(pt a, pt b, pt c)
{
	return a.x * (b.y - c.y) - b.x * (a.y - c.y) + c.x * (a.y - b.y) < 0;
}

bool ccw(pt a, pt b, pt c)
{
	return a.x * (b.y - c.y) - b.x * (a.y - c.y) + c.x * (a.y - b.y) > 0;
}

int main()
{
	freopen("set.dat", "r", stdin);	freopen("set.sol", "w", stdout);
	int n;
	int a[100001];
	scanf("%d", &n);
//	forn(i, 0, n)
	for (int i = 0; i< n; i++)
		scanf("%d", &a[i]);
	sort(a, a + n);
	long long cur = 0;
	int res = 0;
	for (int i = 0; i < n; i++)
		if (a[i] < cur)
			res = i + 1, cur += a[i];
		else
			cur += a[i];
	cout << res << endl;
}