#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cstdio>
#include <map>
#include <deque>

#pragma comment (linker, "/stack:200000000")
#define abs(a) ((a < 0) ? (-(a)) : (a))
#define min(a, b) ((a < b) ? (a) : (b))
#define max(a, b) ((a > b) ? (a) : (b))
#define forn(i, a, b) for (int i = (a); i < (b); i++)
#define mp make_pair
using namespace std;
int a[1001][1001];
const int INF = 1000000;
int main()
{
	freopen("tetris.dat", "r", stdin);	freopen("tetris.sol", "w", stdout);

	int n;
	cin >> n;
	
	int m[1001][2];
	for (int i = 0; i < n; i++)
		cin >> m[i][0];
	for (int i = 0; i < n; i++)
		cin >> m[i][1];
	int k[1001];
	for (int i = 0; i < n; i++)
		k[i] = (m[i][1] - m[i][0] + 4) % 4;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < 1001; j++)
			a[i][j] = INF;
	for (int i = k[0]; i < 1001; i += 4)
		a[0][i] = i;
	for (int i = 1; i < n; i++)
	{
		for (int j = k[i]; j <= 300; j += 4)
		{
			for (int l = 0; l <= 300; l++)
				a[i][j] = min(a[i][j], a[i - 1][l] + max(0, j - l));
		}
	}
	int res = INF;
	for (int i = 0; i < 300; i++)
		res = min(res, a[n - 1][i]);
	cout << res << endl;
}