#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#define task_name "olympair"

using namespace std;

struct line_t {
    int ver;
    int next;
    int time;
};

int vers[100001],result[100001];
bool color[100001];
line_t lines[100001];

void get_time(int time,int from,int to) {
    int h = vers[from];
    color[from] = true;
    while(h != 0) {
        if(lines[h].ver == to) {
            if(result[lines[h].ver] == -1
               || (time+lines[h].time < result[lines[h].ver] && time+lines[h].time != -1))
                result[lines[h].ver] = time+lines[h].time;
            h = lines[h].next;
            continue;
        }

        get_time(time+lines[h].time,lines[h].ver,to);
        h = lines[h].next;
    }
    color[from] = false;
}

int main() {
	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    int h,line_head=1,n,m,type,a,b,c;
    inp >> n >> m;

    for(int i=0;i<m;i++) {
        inp >> type >> a >> b >> c;
        if(type == 1) {
            lines[line_head].ver = b;
            lines[line_head].next = vers[a];
            lines[line_head].time = c;
            vers[a] = line_head;
            line_head++;
        } else {
            h = vers[a];
            while(h != 0) {
                lines[line_head].ver = lines[h].ver;
                lines[line_head].next = vers[b];
                lines[line_head].time = lines[h].time + c;
                vers[b] = line_head;
                line_head++;
                h = lines[h].next;
            }
        }
    }

    for(int i=2;i<=n;i++) {
        result[i] = -1;
        get_time(0,1,i);
        out << result[i] << endl;
    }

	inp.close();
	out.close();
}
