#include <fstream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

ifstream fin("stones.dat");
ofstream fout("stones.sol");

int main()
{
    int n,m;
    fin>>n>>m;
    vector<set<int> > towns(m);
    for (int i=0;i<n;i++)
    {
        int tmp;
        fin>>tmp;
        if (tmp==1)
        {
            int t,w;
            fin>>t>>w;
            t--;
            towns[t].insert(w);
        }
        if (tmp==2)
        {
            vector<pair<int,int> > for_pay(m);
            for (int j=0;j<m;j++)
            {
                for_pay[j]=make_pair(*towns[j].begin(),j);
            }
            sort(for_pay.begin(),for_pay.end());
            fout<<for_pay[m-1].first<<endl;
            int best=for_pay[m-1].second;
            towns[best].erase(towns[best].begin());
        }
    }
    return 0;
}
