#include <fstream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

ifstream fin("stones.dat");
ofstream fout("stones.sol");

int main()
{
    int n,m;
    fin>>n>>m;
    vector<set<int> > towns(m);
    for (int i=0;i<n;i++)
    {
        int tmp;
        fin>>tmp;
        if (tmp==1)
        {
            int t,w;
            fin>>t>>w;
            t--;
            towns[t].insert(w);
        }
        if (tmp==2)
        {
            pair<int,int> max;
            for (int j=0;j<m;j++)
            {
                if (*(towns[j].begin())>max.first)
                {
                    max.first=*towns[j].begin();
                    max.second=j;
                }
            }
            fout<<max.first<<endl;
            towns[max.second].erase(towns[max.second].begin());
        }
    }
    return 0;
}
