#include <fstream>
#include <vector>
#include <set>

using namespace std;

ifstream fin("olympair.dat");
ofstream fout("olympair.sol");

const int INF=23232323;

int main()
{
    long long n,m;
    fin>>n>>m;
    vector<vector<pair<long long,long long> > > g(n);
    for (int i=0;i<m;i++)
    {
        long long a,b,c,tmp;
        fin>>tmp>>a>>b>>c;
        a--; b--;
        if (tmp==1)
        {
            g[a].push_back(make_pair(b,c));
        }
        if (tmp==2)
        {
            for (int i=0;i<g[a].size();i++)
            {
                g[b].push_back(make_pair(g[a][i].first,g[a][i].second+c));
            }
        }
    }
    /*for (int i=0;i<n;i++)
    {
        for (int j=0;j<g[i].size();j++)
        {
            fout<<"("<<g[i][j].first<<" "<<g[i][j].second<<")";
        }
        fout<<endl;
    }*/
    int s=0;
    set<pair<int,int> > q;
    vector<int> d(n,INF);
    d[s]=0;
    q.insert(make_pair(s,0));
    while (!q.empty())
    {
        int v=(*q.begin()).first;
        q.erase(q.begin());
        for (int i=0;i<g[v].size();i++)
        {
            int to=g[v][i].first,len=g[v][i].second;
            if (d[v]+len<d[to])
            {
                q.erase(make_pair(to,d[to]));
                d[to]=d[v]+len;
                q.insert(make_pair(to,d[v]+len));
            }
        }
    }
    for (int i=1;i<n;i++)
    {
        if (d[i]==INF)
        {
            fout<<-1<<endl;
        }
        else
        {
            fout<<d[i]<<endl;
        }
    }
    return 0;
}
