#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

vector<int> binheaps[200000];

inline int Parent(int p){
	return p/2;
}

inline int getMass(int v){
	return binheaps[v][1];
}

void Heapify(int v, int pos){
	if (pos != 1 && pos != 0 && binheaps[v][pos] < binheaps[v][Parent(pos)]){
		swap(binheaps[v][pos], binheaps[v][Parent(pos)]);
	}
	if (pos != 1 && pos != 0) Heapify(v, Parent(pos));
}

void addMass(int v, int m){
	binheaps[v][0]++;
	binheaps[v].push_back(m);
	Heapify(v, binheaps[v][0]);
}

void removeMin(int v){
	binheaps[v][1] = binheaps[v][binheaps[v][0]];
	binheaps[v].pop_back();
	Heapify(v, --binheaps[v][0]);
}

void printHeaps(int m){
	for(int i = 1; i <= m; i++){
		for(int j = 0; j < binheaps[i].size(); j++)
			printf("%d ", binheaps[i][j]);
		printf("\n");
	}
}

int main(){
	freopen("stones.dat", "r", stdin);
	freopen("stones.sol", "w", stdout);
	int n, m; scanf("%d %d", &n, &m);
	int v, ms, t;
	int maxms = 0, maxv = 0;
	for(int i = 0; i < n+1; i++) binheaps[i].push_back(0);
	for(int i = 0; i < n; i++){
		scanf("%d", &t);
		if (t == 1){
			scanf("%d %d", &v, &ms);
			addMass(v, ms);
			//printHeaps(m);
		}
		if (t == 2){
			for(int j = 1; j <= m; j++){
				if (getMass(j) > maxms){
					maxms = getMass(j);
					maxv = j;
				}
			}
			removeMin(maxv);
			cout<<maxms<<endl;
			maxms = 0;
		}
	}
}