#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

vector<int> heaps[200000];

inline int getMass(int v){
	return heaps[v][0];
}

void addMass(int v, int m){
	heaps[v].insert(lower_bound(heaps[v].begin(), heaps[v].end(), m), m);
}

void removeMin(int v){
	heaps[v].erase(heaps[v].begin());
}

void printHeaps(int m){
	for(int i = 1; i <= m; i++){
		for(int j = 0; j < heaps[i].size(); j++)
			printf("%d ", heaps[i][j]);
		printf("\n");
	}
}

int main(){
	freopen("stones.dat", "r", stdin);
	freopen("stones.sol", "w", stdout);
	int n, m; scanf("%d %d", &n, &m);
	int v, ms, t;
	int maxms = 0, maxv = 0;
	for(int i = 0; i < n; i++){
		scanf("%d", &t);
		if (t == 1){
			scanf("%d %d", &v, &ms);
			addMass(v, ms);
		}
		if (t == 2){
			for(int j = 1; j <= m; j++){
				if (getMass(j) > maxms){
					maxms = getMass(j);
					maxv = j;
				}
			}
			removeMin(maxv);
			cout<<maxms<<endl;
			maxms = 0;
		}
		//printHeaps(m);
	}
}