#include <iostream>
#include <stdio.h>
#include <queue>
#include <algorithm>
using namespace std;

int n, m;
bool fld[1000][1000];
bool wasin[1000][1000];
int wasinrow[1000];
int wasincol[1000];
int times[1000][1000];

void bfs(int xs, int ys, int xf, int yf){
	int xn, yn;
	queue< pair<int, int> > nowinst;
	nowinst.push(make_pair(xs, ys));
	while (!nowinst.empty()){
		xn = nowinst.front().first;
		yn = nowinst.front().second;
		wasin[xn][yn] = true;
		wasinrow[xn]++; wasincol[yn]++;
		nowinst.pop();
		for(int i = 0; i < n && wasincol[yn] < 10; i++)
			if (!wasin[i][yn] && fld[i][yn]){
				times[i][yn] = min(times[i][yn], times[xn][yn]+1);
				if (i == xf && yf == yn) return;
				nowinst.push(make_pair(i, yn));
			}
		for(int i = 0; i < m && wasinrow[xn] < 10; i++)
			if (!wasin[xn][i] && fld[xn][i]){
				times[xn][i] = min(times[xn][i], times[xn][yn]+1);
				if (xf == xn && yf == i) return;
				nowinst.push(make_pair(xn, i));
			}
	}
}

int main(){
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	scanf("%d %d", &n, &m);
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++){
			fld[i][j] = false;
			wasin[i][j] = false;
			times[i][j] = 99999;
			wasinrow[i] = wasincol[i] = 0;
	}
	char d[1000];
	int xs, ys;
	int xf, yf;
	for(int i = 0; i < n; i++){
		scanf("%s", &d);
		for(int j = 0; j < m; j++){
			if (d[j] == 'x') fld[i][j] = true;
			else if (d[j] == 'o'){ fld[i][j] = true; xs = i; ys = j; }
			else if (d[j] == '+'){ fld[i][j] = true; xf = i; yf = j; }
		}
	}
	times[xs][ys] = 0;
	bfs(xs, ys, xf, yf);
	if (times[xf][yf] == 99999) times[xf][yf] = -1;
	cout<<times[xf][yf]<<endl;
//	system("pause");
}
