#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<vector>
#include<algorithm>
#include<string>
#include<memory.h>
#include<set>
#include<queue>

using namespace std;

#define rep(i,n) for(int (i)=0;(i)<(n);(i)++)
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);(i)++)
#define ROF(i,a,b) for(int (i)=(b);(i)>=(a);(i)--)
#define fe(i,a) for(int (i)=0;(i)<int((a).size());(i)++)

#define sz(a) int((a).size())
#define pb push_back
#define ppb pop_back
#define all(a) (a).begin(),(a).end()

#define N 1010
#define pi 2.0*acos(0.0)
#define eps 1e-9
#define inf int(1e9)

#define mp(a,b) make_pair((a),(b))
#define FREOPEN(a,b) freopen(a,"r",stdin);freopen(b,"w",stdout)

typedef pair<int,int> pii;
typedef long long ll;

char s[N][N];
struct type
{
	int x,y,p,sum;
	bool friend operator<(type a,type b)
	{
		return a.sum > b.sum;
	}
};
int n,m,ans=inf;
priority_queue<type> q;
type nxt,cur;
void go_x()
{
		int x,y;
		x=cur.x; y=cur.y;
		while(x < n)
		{
			if(s[x][y] == '+')
			{
				ans=cur.sum;
				return;
			}
			if(s[x][y] == 'x')
			{
				nxt.p=1 ;nxt.x=x; nxt.y=y; nxt.sum=cur.sum+1; s[x][y]='.';
				q.push(nxt);
			}
			x++;
		}
		x=cur.x; y=cur.y;
		while(x > -1)
		{
			if(s[x][y] == '+')
			{
				ans=cur.sum;
				return;
			}
			if(s[x][y] == 'x')
			{
				nxt.p=1; nxt.x=x; nxt.y=y; nxt.sum=cur.sum+1; s[x][y]='.';
				q.push(nxt);
			}
			x--;
		}
		
}
void go_y()
{
	    int x,y;
		x=cur.x; y=cur.y;
		while(y < m)
		{
			if(s[x][y] == '+')
			{
				ans=cur.sum;
				return;
			}
			if(s[x][y] == 'x')
			{
				nxt.p=2; nxt.x=x; nxt.y=y; nxt.sum=cur.sum+1; s[x][y]='.';
				q.push(nxt);
			}
			y++;
		}
		x=cur.x; y=cur.y;
		while(y > -1)
		{
			if(s[x][y] == '+')
			{
				ans=cur.sum;
				return;
			}
			if(s[x][y] == 'x')
			{
				nxt.p=2; nxt.x=x; nxt.y=y; nxt.sum=cur.sum+1; s[x][y]='.';
				q.push(nxt);
			}
			y--;
		}
}
int bfs(int x,int y)
{
	int dx[4]={0,0,1,-1};
	int dy[4]={1,-1,0,0};
	cur.sum=1; cur.x=x; cur.y=y; cur.p=0; s[x][y]='.';
	q.push(cur);
	while(!q.empty())
	{
		cur=q.top(); q.pop(); 
		if(cur.p == 0)
		{
			go_x();
			if(ans != inf)return ans;
			go_y();
			if(ans != inf)return ans;
		} else
		if(cur.p == 1)
		{
			go_y();
			if(ans != inf)return ans;
		} else
		if(cur.p == 2)
		{
			go_x();
			if(ans != inf)return ans;
		}
	}
	return -1;
}
int main()
{
	//FREOPEN("input.txt","output.txt");
	FREOPEN("cap.dat","cap.sol");
	int xs,ys,f=0;
	scanf("%d%d\n",&n,&m);
	rep(i,n)
	{
		gets(s[i]);
		if(!f)
		{
		  rep(j,m)
			if(s[i][j] == 'o')
			{
				xs=i; ys=j; f=1; break;
			}
		}
	}

	printf("%d\n",bfs(xs,ys));
	return 0;
}
