#include <iostream>
#include <vector>
#include <fstream>
#include <cstdlib>

using namespace std;

typedef unsigned long long ull;

struct st
{
	ull a,w;
};

const ull INF = 2000000000;

vector <st> gr[100000];
ull d[100000];
bool u[100000];

int main ()
{
	//ifstream cin ("olympair.dat");
	//ofstream cout ("olympair.sol");
	freopen ("olympair.dat","r",stdin);
	freopen ("olympair.sol","w",stdout);
	ull n,m;
	//cin >> n >> m;
	scanf("%lld%lld",&n,&m);
	ull t,a,b,w;
	for (ull i = 0;i<m;i++)
	{
		//cin >> t >> a >> b >> w;
		scanf ("%lld%lld%lld%lld",&t,&a,&b,&w);
		a--;
		b--;
		st q;
		q.w = w;
		if (t == 1)
		{
			q.a = b;
			gr[a].push_back(q);
		}
		else
		{
			for (ull j = 0;j<gr[a].size();j++)
			{
				q = gr[a][j];
				q.w += w;
				gr[b].push_back(q);
			}
		}
	}
	ull v = 0;
	d[0]=0;
	for (ull i = 1;i<n;i++)
	{
		d[i] = INF;
		u[i] = false;
	}
	while (v != -1)
	{
		u[v] = true;
		for (ull i = 0;i<gr[v].size();i++)
		{
			t = gr[v][i].a;
			w = gr[v][i].w;
			d[t] = min (d[t],d[v]+w);
		}
		ull mmin = INF;
		ull nmin = -1;
		for (ull i = 0;i<n;i++)
		{
			if (!u[i])
			{
				if (d[i] < mmin)
				{
					mmin = d[i];
					nmin = i;
				}
			}
		}
		v=nmin;
	}
	for (ull i = 1;i<n;i++)
	{
		if (d[i] != INF)
		{
			//cout << d[i] << endl;
			printf("%lld\n",d[i]);
		}
		else
		{
			//cout << -1 << endl;
			printf("-1\n");
		}
	}
	//cout.close();
	return 0;
}