#include <iostream>
#include <string>
#include <queue>
#include <fstream>

using namespace std;

const int INF = 2000000000;

struct pos
{
	int i,j;
};

string a[1000];
int d[1000][1000];
bool u[1000][1000];

int main()
{
	ifstream cin ("cap.dat");
	ofstream cout ("cap.sol");
	int n,m;
	cin >> n >> m;
	pos v,e;
	for (int i = 0;i<n;i++) cin >> a[i];
	for (int i = 0;i<n;i++)
	{
		for (int j = 0;j<m;j++)
		{
			d[i][j] = INF;
			u[i][j] = false;
			if (a[i][j] == 'o')
			{
				v.i = i;
				v.j = j;
			}
			if (a[i][j] == '+')
			{
				e.i = i;
				e.j = j;
			}
		}
	}
	d[v.i][v.j] = 0;
	u[v.i][v.j] = true;
	queue <pos> q;
	pos t;
	q.push(v);
	while (!q.empty())
	{
		v = q.front();
		q.pop();
		for (int i = 0;i<n;i++)
		{
			if ((a[i][v.j] == 'x' ||a[i][v.j] == '+')&&(!u[i][v.j])&&(d[i][v.j] > d[v.i][v.j]+1))
			{
				d[i][v.j] = d[v.i][v.j]+1;
				u[i][v.j] = true;
				t.i = i;
				t.j = v.j;
				q.push(t);
			}
		}
		for (int j = 0;j<m;j++)
		{
			if ((a[v.i][j] == 'x'||a[v.i][j] == '+')&&(!u[v.i][j])&&(d[v.i][j] > d[v.i][v.j]+1))
			{
				d[v.i][j] = d[v.i][v.j]+1;
				u[v.i][j] = true;
				t.i = v.i;
				t.j = j;
				q.push(t);
			}
		}
	}
	if (d[e.i][e.j] != INF)
	{
		cout << d[e.i][e.j];
	}
	else
	{
		cout << -1;
	}
	return 0;
}