#include <iostream>
#include <string>
#include <queue>
#include <fstream>
#include <vector>

using namespace std;

const int INF = 2000000000;

struct pos
{
	int i,j;
};

string a[1000];
int d[1000][1000];
bool u[1000][1000];
vector <int> di[1000],dj[1000];

int main()
{
	ifstream cin ("cap.dat");
	ofstream cout ("cap.sol");
	int n,m;
	cin >> n >> m;
	pos v,e;
	for (int i = 0;i<n;i++) cin >> a[i];
	for (int i = 0;i<n;i++)
	{
		for (int j = 0;j<m;j++)
		{
			d[i][j] = INF;
			u[i][j] = false;
			if (a[i][j] == 'o')
			{
				v.i = i;
				v.j = j;
			}
			if (a[i][j] == '+')
			{
				e.i = i;
				e.j = j;
				di[i].push_back(j);
				dj[j].push_back(i);
			}
			if (a[i][j] == 'x')
			{
				di[i].push_back(j);
				dj[j].push_back(i);
			}
		}
	}
	d[v.i][v.j] = 0;
	u[v.i][v.j] = true;
	queue <pos> q;
	pos t;
	q.push(v);
	while (!q.empty())
	{
		v = q.front();
		q.pop();
		t.i = v.i;
		for (int i = 0;i<di[v.i].size();i++)
		{
			int j = di[v.i][i];
			t.j = j;
			if (!u[t.i][t.j])
			{
				u[t.i][t.j] = true;
				d[t.i][t.j] = d[v.i][v.j]+1;
				q.push(t);
			}
		}
		di[v.i].clear();
		t.j = v.j;
		for (int i = 0;i<dj[v.j].size();i++)
		{
			t.i = dj[v.j][i];
			if (!u[t.i][t.j])
			{
				u[t.i][t.j] = true;
				d[t.i][t.j] = d[v.i][v.j]+1;
				q.push(t);
			}
		}
		dj[v.j].clear();
	}
	if (d[e.i][e.j] != INF)
	{
		cout << d[e.i][e.j];
	}
	else
	{
		cout << -1;
	}
	return 0;
}