program olympair;

type heap = record
  ing, num: longint;
  stones: array[1..200000] of longint;
end;

type gbel = record
  tow, st: longint;
end;

type reb = record
  v, n: longint;
  ex: boolean;
end;

type event = record
  x, y: longint;
  open: boolean;
end;

var ans2, i, a, b, nn, max, bal, n, l, j, ans, res, m, maxn, tip, t, w, zn: longint;
    aa: array[1..100000] of longint;
    col, maxi: array[1..100000] of longint;
    used, used2: array[1..100000] of boolean;
    bb: array[1..100000] of event;
    flag: boolean;

procedure swap(var a, b: event);
  var c: event;
  begin
    c := a; a := b; b := c;
  end;

function cmp(a, b: event): boolean;
  begin
    cmp := a.x < b.x;
  end;

procedure sort(l, r: longint);
  var i, j: longint;
      etl: event;
  begin
    if l < r then
      begin
        i := l; j := r;
        etl := bb[(l + r) div 2];
        while i < j do
          begin
            while cmp(bb[i], etl) do inc(i);
            while cmp(etl, bb[j]) do dec(j);
            if i <= j then
              begin
                swap(bb[i], bb[j]);
                inc(i); dec(j);
              end;
          end;
        sort(l, j); sort(i, r);
      end;
  end;

begin
  assign(input, 'mutation.dat');
  assign(output, 'mutation.sol');
  reset(input); rewrite(output);
  read(n);
  maxn := 0;
  for i := 1 to n do
    begin
      read(aa[i]);
      inc(col[aa[i]]);
      if aa[i] > maxn then maxn := aa[i];
      maxi[aa[i]] := i;
    end;
  ans := 0;
  fillchar(used, sizeof(used), false);
  for i := 1 to n do if col[aa[i]] = 1 then used[aa[i]] := true;
  nn := 0;
  for i := 1 to n do if not used[aa[i]] then
    begin
      used[aa[i]] := true;
      inc(nn);
      bb[nn].x := i;
      bb[nn].y := aa[i];
      bb[nn].open := true;
      inc(nn);
      bb[nn].x := maxi[aa[i]];
      bb[nn].y := aa[i];
      bb[nn].open := false;
    end;
  sort(1, nn);
  bal := 0;
  max := 0;
  for i := 1 to nn do
    begin
      if bb[i].open then inc(bal) else dec(bal);
      if bal > max then max := bal;
    end;
  writeln(max - 1);
  close(input); close(output);
end.
