program olo;

const inf = 1000000000000000;

type tower = record
  x, y, r: extended;
  c: longint;
  cost: int64;
end;

type kni = record
  x, y: extended;
  l: longint;
end;

var i, j, n, m, k, ed: longint;
    min, res: int64;
	tow: array[1..100] of tower;
	knight: array[1..100] of kni;
    col: array[1..100] of longint;
	
procedure swap(var a, b: tower);
  var c: tower;
  begin
    c := a; a := b; b := c;
  end;  
	
procedure sort(l, r: longint);
  var i, j: longint;
      etl: tower;
  begin
    if l < r then
	  begin
	    i := l; j := r;
		etl := tow[(l + r) div 2];
		while i < j do
		  begin
		    while tow[i].cost > etl.cost do inc(i);
			while tow[j].cost < etl.cost do dec(j);
			if i <= j then
			  begin
			    swap(tow[i], tow[j]);
				inc(i); dec(j);
			  end;
		  end;
		sort(l, j); sort(i, r);  
	  end;
  end;  
	
begin
  assign(input, 'tetris.dat');
  assign(output, 'tetris.sol');
  reset(input); rewrite(output);
  read(n, m, k);
  for i := 1 to n do read(tow[i].x, tow[i].y, tow[i].r, tow[i].c);
  for i := 1 to m do read(knight[i].x, knight[i].y, knight[i].l);
  for i := 1 to m do
    for j := 1 to n do 
	  if sqr(knight[i].x) + sqr(knight[i].y) > sqr(tow[j].r) then col[i] := j; 
  for i := 1 to n do tow[i].cost := 0;
  for i := 1 to m do tow[col[i]].cost := tow[col[i]].cost + tow[col[i]].c * knight[i].l;
  sort(1, n);
  for i := 1 to m do
    for j := 1 to n do 
	  if sqr(knight[i].x) + sqr(knight[i].y) > sqr(tow[j].r) then col[i] := j; 
  min := inf; ed := k;
  for i := 1 to n do
    begin
	  if i <= k then ed := k + 1 else ed := k;
	  res := 0;
	  for j := 1 to m do
	    if (col[j] <> i)and(col[j] > ed) then res := res + knight[j].l * tow[col[j]].c;
	  if res < min then min := res;	 
	end;
  writeln(min);	
  close(input);
  close(output);
end.
