#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <deque>
#include <string>
#include <cstring>

using namespace std;

#if (_WIN32 || __WIN32__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long INT;

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))
#define Abs(a) ((a)>0?(a):-(a))

const int MAXN = 100010;

int a[MAXN];
int d[MAXN];
int f[MAXN];
int cnt[MAXN];

int main(){
    WITH_FILES(calendar.dat, calendar.sol)
    int n;
    scanf("%d", &n);
    for (int i = 1; i <= n; i++){
        int x;
        scanf("%d", &x);
        f[x] = i;
    }
    for (int i = 1; i <= n; i++){
        int x;
        scanf("%d", &x);
        a[i] = f[x];
    }
    for (int i = 1; i <= n; i++){
        d[a[i]] = i - a[i];
        if (d[a[i]] < 0)
            d[a[i]] += n;
    }
    for (int i = 1; i <= n; i++)
        cnt[d[i]]++;
    int ans = 0;
    for (int i = 0; i < n; i++)
        if (ans < cnt[i])
        ans = cnt[i];
    printf("%d\n", ans);
    return 0;
}
