#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <deque>
#include <string>
#include <cstring>

using namespace std;

#if (_WIN32 || __WIN32__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long INT;

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))
#define Abs(a) ((a)>0?(a):-(a))

const int MAXN = 100010;

int a[MAXN];
int a1[MAXN];
int cnt[MAXN];
int cr[MAXN];
char st[MAXN];
int fin[MAXN];
char used[MAXN];
int d[MAXN];
int n;
char lonely[MAXN];

int main(){
    WITH_FILES(mutation.dat, mutation.sol)
    scanf("%d", &n);
    int N = n;
    for (int i = 0; i < n; i++)
        scanf("%d", &a[i]), cnt[a[i]]++;
    /*for (int i = 1; i <= n; i++)
        printf("%d ", cnt[i]);
    printf("\n");*/
    for (int i = 0; i < n; i++){
        int x = a[i];
        if (cr[x] == 0)
            st[i] = 1;
        if (cr[x] == cnt[x] - 1)
            fin[i] = 1;
        cr[x]++;
    }
    /*for (int i = 0; i < n; i++)
        printf("%d ", st[i]);
    printf("\n");
    for (int i = 0 ; i < n; i++)
        printf("%d ", fin[i]);
    printf("\n");*/
    int nx = 0;
    for (int i = 0; i < n; i++)
        if (st[i] || fin[i])
            a1[nx++] = a[i];
    n = nx;
    for (int i = 0; i < n; i++)
        a[i] = a1[i];
    for (int i = 1; i <= N; i++)
        fin[i] = -1;
    int dif = 0;
    for (int i = 0; i < n; i++)
        if (used[a[i]]){
            fin[a[i]] = i;
            dif++;
        }
        else
            used[a[i]] = 1;
    for (int i = 0; i < n; i++)
        if (fin[a[i]] == -1){
            fin[a[i]] = i;
            lonely[i] = 1;
            dif++;
        }
    for (int i = 0; i < n; i++)
        printf("%d ", a[i]);
    printf("\n");
    for (int i = 0; i < n; i++){
        if (i > 0)
            d[i] = Max(d[i], d[i - 1]);
        int x = 0;
        if (i > 0)
            x = d[i - 1];
        if (lonely[i] || i != fin[a[i]])
            d[fin[a[i]]] = Max(d[fin[a[i]]], x + 1);
    }
    /*for (int i = 0; i < n; i++)
        printf("%d ", d[i]);
    printf("\n");*/
    printf("%d\n", dif - d[n - 1]);
    return 0;
}
