#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <cstdio>
#include <cmath>

using namespace std;

int main()
{
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);

	int n, a[1000], b[1000];
	cin >> n;
	for (int i = n-1; i >= 0; --i)
		cin >> a[i];
	for (int i = n-1; i >= 0; --i)
		cin >> b[i];

	int d[1000], p[1000];
	d[0] = p[0] = (b[0] - a[0] + 4) % 4;

	for (int i = 1; i < n; ++i)
	{
		int q = (b[i] - a[i] + 4) % 4;
		p[i] = q;
		if (q <= p[i-1])
			d[i] = d[i-1];
		else
			d[i] = d[i-1] + q - p[i-1];
	}

	cout << d[n-1];

	return 0;
}
