#include <iostream>
#include <fstream>
#include <map>

using namespace std;

class city {
public:
	map<int, int> stones;
	int min_val;
	int min_index;
	int next_index;

	city() {
		min_index = -1;
		next_index = 0;
		min_val = 2000000000;
	}

	void push(int w) {
		stones[next_index++] = w;
		if (w < min_val) {
			min_val = w;
			min_index = next_index - 1;
		}
	}

	void pop() {
		stones.erase(min_index);
		min_val = 99999999;
		for (map<int,int>::iterator i = stones.begin(); i != stones.end(); i++) {
			if (i->second < min_val) {
				min_val = i->second;
				min_index = i->first;
			}
		}
	}
};

city **data;
int n, m;

int main()
{
	ifstream in("stones.dat");
	ofstream out("stones.sol");

	in >> n >> m;
	data = new city*[m];
	for (int i = 0; i < m; i++) {
		data[i] = new city;
	}

	for (int i = 0; i < n; i++) {
		int type;
		in >> type;
		if (type == 1) {
			int t, w;
			in >> t >> w;
			data[t - 1]->push(w);
		} else {
			int max = -1;
			city *c = 0;
			for (int j = 0; j < m; j++) {
				if (data[j]->min_val > max) {
					max = data[j]->min_val;
					c = data[j];
				}
			}
			c->pop();
			out << max << endl;
		}
	}

	return 0;
}