#include <iostream>
#include <fstream>
#include <deque>
#include <algorithm>

using namespace std;

int main()
{
	ifstream in("set.dat");
	ofstream out("set.sol");

	deque<int> sticks;
	int n;

	in >> n;

	if (n < 3) {
		out << "0\n";
		return 0;
	}

	int left = 2000000000;
	int right = 0;

	int sum = 0;
	int sub = 0;

	for (int i = 0; i < n; i++) {
		int x;
		in >> x;
		if (x <= left) {
			sticks.push_back(x);
			left = x;
			sub -= x;
		} else if (x >= right) {
			sticks.push_front(x);
			sub -= 2 * right;
			right = x;
			sub += x;
		}
		sum += x;
	}

	if (right = -1) {
		right = sticks.front();
	}

	sum -= right;

	int x = sticks.size();

	while (right >= sum) {
		sub -= right;
		sticks.pop_front();
		right = sticks.front();
		sum -= right;
		sub += 2 * right;
		x--;
		if (x < 3) {
			out << "0\n";
			return 0;
		}
	}

	while (left < sub) {
		sub += left;
		sticks.pop_back();
		left = sticks.back();
		x--;
		if (x < 3) {
			out << "0\n";
			return 0;
		}
	}

	out << x << endl;

	return 0;
}