#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()
#define foreach(i,x) for(__typeof(x.begin()) i = x.begin();i!=x.end();++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define task "calendar"

const int maxn = (int)1e5+1;

int n;
int a[maxn], b[maxn], nxt[maxn], ass[maxn],dass[maxn];
map<int,int> m;

int main(){
	#ifdef DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	#else
	freopen(task".dat","r",stdin);
	freopen(task".sol","w",stdout);
	#endif
	for (int i=0;i<maxn;++i){
		ass[i] = 0;
		dass[i] = 0;
	}
	scanf("%d",&n);
	for (int i=0;i<n;++i){
		int x;
		scanf("%d",&x);
		m[x] = i;
	}
	for (int i=0;i<n;++i){
		int x;
		scanf("%d",&x);
		map<int,int>::iterator it = m.find(x);
		if (it!=m.end()){
				nxt[i] = (*it).second-i;
				if (nxt[i]>=0)
					ass[nxt[i]]++; else
					dass[-nxt[i]]++;
		}
	}
 int ans = 0;
	for (int i=0;i<maxn;++i)
		ans = max(ans,ass[i]);
	for (int i=0;i<maxn;++i)
		ans = max(ans,dass[i]);
	printf("%d\n",ans);
	return 0;
}
