#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()
#define foreach(i,x) for(__typeof(x.begin()) i = x.begin();i!=x.end();++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

#define task "calendar"

const int maxn = (int)1e5+20;

int n;
int ass[2*maxn];
map<int,int> m;

int main(){
	#ifdef DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
	#else
	freopen(task".dat","r",stdin);
	freopen(task".sol","w",stdout);
	#endif
	memset(ass,0,sizeof ass);
	scanf("%d",&n);
	for (int i=0;i<n;++i){
		int x;
		scanf("%d",&x);
		m[x] = i;
	}
	for (int i=0;i<n;++i){
		int x;
		scanf("%d",&x);
		map<int,int>::iterator it = m.find(x);
		if (it!=m.end()){
				int d = ((*it).second-i);
				ass[(d>=0)?d:maxn+abs(d)]++;
				ass[n-((*it).second-i)]++;
		}
	}
 int ans = 0;
	for (int i=0;i<2*maxn;++i)
		ans = max(ans,ass[i]);
	printf("%d\n",ans);
	return 0;
}
