#include <set>
#include <vector>
#include <stdio.h>
#include <iostream>

#define INF 1000000000
#define MP make_pair
#define PB push_back
#define V first
#define T second
#define M first
#define pos second

using namespace std;

int N, M, typ, A, B, C;
int dist[100010];
pair <int, int> now;
vector < pair < int, int > > gr[100010];
set < pair < int, int > > ms;

int main()
{
    freopen("olympair.dat", "r", stdin);
    freopen("olympair.sol", "w", stdout);
    
    scanf("%d%d", &N, &M);
    //gr = new vector < pair < int, int > >[N];
    
    for( ; M > 0; M-- )
    {
         scanf("%d%d%d%d", &typ, &A, &B, &C);
         if( typ == 1 ) gr[A - 1].PB( MP( B - 1, C ) );
         else
         {
             A--;
             for( int i = 0; i < gr[A].size(); i++ ) gr[B - 1].PB( MP( gr[A][i].V, gr[A][i].T + C ) );
         }
    }
    
    dist[0] = 0;
    for( int i = 1; i < N; i++ ) dist[i] = INF;
    
    ms.insert( MP( 0, 0 ) );
    
    while( ms.size() != 0 )
    {
           now = *ms.begin();
           ms.erase( ms.begin() );
           
           for( int i = 0; i < gr[now.pos].size(); i++ )
           {
                if( dist[gr[now.pos][i].V] > now.M + gr[now.pos][i].T )
                {
                    if(dist[gr[now.pos][i].V] != INF) ms.erase( ms.find( MP( dist[gr[now.pos][i].V], gr[now.pos][i].V ) ) );
                    dist[gr[now.pos][i].V] = now.M + gr[now.pos][i].T;
                    ms.insert( MP( dist[gr[now.pos][i].V], gr[now.pos][i].V ) );
                }
           }
    }
    
    for( int i = 1; i < N; i++ )
    {
         if( dist[i] == INF ) printf("-1\n"); else printf("%d\n", dist[i]);
    }
    
    fclose(stdin);
    fclose(stdout);
    return 0;
}
