#include <queue>
#include <vector>
#include <stdio.h>
#include <iostream>

#define PB push_back
#define MP make_pair
#define X first
#define Y second

using namespace std;

char c;
int n, m, startX, startY, endX, endY, size, k = 0;
bool pole[1000][1000];
bool used[1000][1000];
vector < int > X[1000], Y[1000];
queue < pair < int, int > > q;
pair < int, int > pos;

int main()
{
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    
    scanf("%d%d", &n, &m);
    //used = new bool*[n];
    //pole = new bool*[n];
    
    for( int i = 0; i < n; i++ )
    {
         //used[i] = new bool[m];
         //pole[i] = new bool[m];
         for( int j = 0; j < m; j++ )
         {
              c = '\n';
              while( (c == '\n') || (c == ' ') ) scanf("%c", &c);
              //cin >> c;
              switch( c )
              {
                      case 'o': pole[i][j] = 1, startX = i, startY = j, X[i].PB(j);
                      break;
                      
                      case '+': pole[i][j] = 1, endX = i, endY = j, X[i].PB(j);
                      break;
                      
                      case 'x': pole[i][j] = 1, X[i].PB(j);
                      break;
                      
                      default: pole[i][j] = 0;
              }
         }
    }
    
    for( int j = 0; j < m; j++ )
    {
         for( int i = 0; i < n; i++ )
         {
              if( pole[i][j] == 1 ) Y[j].PB(i);
              used[i][j] = 0;
         }
    }
    
    used[startX][startY] = 1;
    q.push( MP( startX, startY ) );
    size = q.size();
    while( size != 0 )
    {
           for( int i = 0; i < size; i++ )
           {
                pos = q.front();
                q.pop();
                
                if( pos.X == endX && pos.Y == endY )
                {
                    printf("%d\n", k);
                    fclose(stdin);
                    fclose(stdout);
                    return 0;
                }
                
                for( int j = 0; j < X[pos.X].size(); j++ )
                {
                     if( used[pos.X][X[pos.X][j]] == 0 )
                     {
                         used[pos.X][X[pos.X][j]] = 1;
                         q.push( MP( pos.X, X[pos.X][j] ) );
                     }
                }
                
                for( int j = 0; j < Y[pos.Y].size(); j++ )
                {
                     if( used[Y[pos.Y][j]][pos.Y] == 0 )
                     {
                         used[Y[pos.Y][j]][pos.Y] = 1;
                         q.push( MP( Y[pos.Y][j], pos.Y ) );
                     }
                }
           }
           size = q.size();
           k++;
    }
    
    printf("-1\n");
    fclose(stdin);
    fclose(stdout);
    return 0;
}
