Program olympair;
	
  type
    TAir = record
      toV, S: longint;
	end;
	
  const inf = 10000001;
	
  var N, m, i, j, k, a, b, c, v: longint;
      g: array[1..100000, 0..1000] of TAir;
	  d: array[-1..100000] of longint;
	  was: array[-1..100000] of boolean;
      dat, sol: text;

  function Time (a, b: longint): longint;
    var i, res: longint;
  Begin
    res:= inf;
	if a=b then res:= 0;
    for i:= 1 to g[a, 0].S do
      if g[a, i].toV = b then
        res:= g[a, i].S;
    Time:= res;		
  end;

  function wasAll: boolean;
    var i: longint;
	    res: boolean;
  Begin
    res:= true;
	for i:= 1 to n do
	  if not was[i] then
	    res:= false;
	wasAll:= res;
  end;

  function min: longint;
    var i, res: longint;
  Begin
    i:= 1;
    While was[i] do inc (i);
	res:= i;
	for i:= 1 to n do
	  if (d[res]>d[i]) and (not was[i]) then res:= i;
	min:= res;
  end;

  procedure Add (a, b, c: longint);
  Begin
    if Time (a, b)>c then
	Begin
      inc (g[a, 0].S);
	  g[a, g[a, 0].S].toV:= b;
	  g[a, g[a, 0].S].S:= c;
	end;
  end;

  procedure deikstr (v: longint);
    var i, t: longint;
  Begin
    was[v]:= true;
	for i:= 1 to g[v, 0].S do
	Begin
	  t:= d[v]+Time(v, g[v, i].toV);
	  if d[g[v, i].toV]>t then
	    d[g[v, i].toV]:= t;
	end;
  end;

  procedure Init;
  Begin
    Assign (dat, 'olympair.dat'); Reset (dat);
    Assign (sol, 'olympair.sol'); Rewrite (sol);
    Read (dat, N, M);
    for i:= 1 to M do
    Begin
      Read (dat, k, a, b, c);
	  if k=1 then Add (a, b, c)
      else for j:= 1 to g[a, 0].S do
        Add (b, g[a, j].toV, g[a, j].S+c);	
    end;	
  end;

Begin
  Init;
  for i:= 1 to n do
    d[i]:= Time (1, i);
  while not wasAll do
  Begin
    v:= min;
    deikstr (v);
  end;
  for i:= 2 to n do
    if d[i]<>inf then
	  Writeln (sol, d[i])
	else Writeln (sol, -1);
  Close (dat); Close (sol);
end.
