#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
struct City
{
	int Num;
	vector<int> Stones;
	int Offset;
};
int N,M;
City* arr;
void insert(int cityNum,int weight)
{
	int i=arr[cityNum-1].Offset;
	if(arr[cityNum-1].Stones.size()==i)
	{
		arr[cityNum-1].Stones.push_back(weight);
		return;
	}
	while(arr[cityNum-1].Stones[i]<weight)
	{
		i++;
		if(i==arr[cityNum-1].Stones.size())
		{
			arr[cityNum-1].Stones.push_back(weight);
			return;
		}
	}
	arr[cityNum-1].Stones.insert(arr[cityNum-1].Stones.begin()+i,weight);
}

int main()
{
	ifstream cin("stones.dat");
	ofstream cout("stones.sol");
	cin>>N>>M;
	arr=new City[M];

	for(int i=0;i<M;i++)
	{
		arr[i].Num=i+1;
		arr[i].Offset=0;
	}

	int eType;
	int cityNum, weight;
	int maxStoneCityId=1;

	for(int i=0;i<N;i++)
	{
		cin>>eType;
		if(eType==1)
		{
			cin>>cityNum>>weight;
			insert(cityNum,weight);
		}
		else
		{
			maxStoneCityId=1;
			for(int j=0;j<M;j++)
			{
				if(arr[j].Stones[arr[j].Offset]>arr[maxStoneCityId-1].Stones[arr[maxStoneCityId-1].Offset])
					maxStoneCityId=j+1;
			}
			cout<<arr[maxStoneCityId-1].Stones[arr[maxStoneCityId-1].Offset]<<endl;
			arr[maxStoneCityId-1].Offset++;
			//arr[maxStoneCityId-1].Stones.erase(arr[maxStoneCityId-1].Stones.begin());
		}
	}
	delete[] arr;
	return 0;
}