#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

//ifstream fin("calendar.dat");
ofstream fout("calendar.sol");
FILE *fh = fopen ( "calendar.dat", "r" );

const int MAXN = int(1e5)+42;

//int calendar_1[2*MAXN], calendar_2[2*MAXN];
int position1[MAXN], shift[2*MAXN];

int main(){
    int n;
    fscanf( fh, "%d", &n );

    for ( int i = 0; i < n; ++i ) {
        int num;
        fscanf( fh, "%d", &num );
        position1[num] = i;
    }
    memset(shift, 0, sizeof ( int ) * 2*n );
    for ( int i = 0; i < n; ++i ) {
        int num;
        fscanf( fh, "%d", &num );
        ++shift[n+position1[num]-i];
    }
    int max_cnt = -1;
    for ( int i = 0; i < 2*n; ++i )
        max_cnt = max ( max_cnt, shift[i] );

    fout << max_cnt << endl;
    fout.close();
    return 0;
}
