#include <cstdio>
#include <cmath>
#include <cstring>
#include <iostream>
#include <list>
#include <vector>

using namespace std;

typedef list<int> li;
typedef li::const_iterator clit;
typedef li::iterator lit;

int n;

void arc(const li &a, li &b ){
    b.clear();
    clit curr, next;
    curr = next = a.begin();
    ++next;
    while(curr != a.end()){
       // cout  << *curr << endl;
        if ( *curr != *next ) b.push_back(*curr);
        curr = next++;
    }
}
void del_single(const li &a, li &b){
    b.clear();
    static vector < int > cnt;
    cnt.resize(n, 0);
    for ( clit it = a.begin(); it != a.end(); ++it ){
            cnt[*it]++;
    }
    for ( clit it = a.begin(); it != a.end(); ++it ) {
        if ( cnt[*it] > 1 ){
            b.push_back(*it);
        }
    }
}
int min_cnt;
void r(li g, const int depth){
    if ( depth > min_cnt ) return;
    if ( g.empty() ){
        min_cnt = depth;
    }
    li a, b;
    for ( lit it = g.begin(); it != g.end(); ++it ){
        int val = *it;
        lit p = it;
        p--;
        g.erase(it);
        for ( lit it = g.begin(); it !=g.end(); ++it ){
            lit p = g.insert(it, val);
            a = g;
            arc(g,b);
            del_single(b,a);
            r(a, depth+1);
            g.erase(p);
        }
        g.insert(p, val);
    }
}
int main(){
    FILE *fh = fopen( "mutation.dat", "r" );
    fscanf( fh, "%d\n", &n );
    li g;
    int max_c = -1;
    for ( int i = 0; i < n; ++i ){
        int curr;
        fscanf(fh, "%d ", &curr);
        max_c = max ( max_c, curr );
        g.push_back(curr);
    }
    li a;
    arc(g, a);
    del_single(a, g);
    min_cnt = n;
    r(g,0);
    fh = fopen( "mutation.sol", "w" );
    fprintf ( fh, "%d\n", min_cnt );
    fclose ( fh );

    return 0;
}
