#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("set.dat");
ofstream fout("set.sol");
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}

const int MAXN = int(1e5)+42;

LL a[MAXN];

void out(int cnt ){
    fout << cnt << endl;
    fout.close();
    exit(0);
}

int main(){
    int n;
    fin >> n;
    for ( int i = 0; i < n; ++ i ){
        fin >> a[i];
    }
    sort(a, a+n);
    int max_cnt = 0;
    if ( n < 3 ){
        out(0);
    }
    if ( n == 3 ){
        if ( a[0]+a[1] < a[3] && a[1]+a[3] < a[2] && a[2]+a[3] < a[1] ) {
            out(3);
        }else {
            out(0);
        }
    }
    for ( int  i = 0; i < n; ++ i ){
        LL sum_length = a[i]+a[i+1]+a[i+2];
        for ( int j = i+3; j < n; ++j ){
            if ( sum_length < a[j] ){
                max_cnt = max ( max_cnt, j-i );
                break;
            }
            sum_length += a[j];
        }
    }
    fout << max_cnt << endl;
    return 0;
}
