#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("set.dat");
ofstream fout("set.sol");
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}

const int MAXN = int(1e5)+42;

LL a[MAXN];

void out(int cnt ){
    fout << cnt << endl;
    fout.close();
    exit(0);
}

int main(){
    int n;
    fin >> n;
    for ( int i = 0; i < n; ++ i ){
        fin >> a[i];
    }
    sort(a, a+n);
    if ( n < 3 ){
        out(0);
    }
    if ( n == 3 ){
        if ( a[0]+a[1] < a[3] && a[1]+a[3] < a[2] && a[2]+a[3] < a[1] ) {
            out(3);
        }else {
            out(0);
        }
    }
    int left = 0;
    int right = 2;
    LL sum_length = a[0]+a[1]+a[2];
    for ( right = 3; right < n; ++right ){
        if ( sum_length > a[right]+2 ){
            sum_length += a[right];
        }else {
            break;
        }
    }
    --right;
    int max_cnt = right-left+1;
    while ( right < n ){
        sum_length -= a[left];
        ++left;
        for(++right; right < n; ++ right){
            if ( sum_length > a[right]+2 ){
                sum_length += a[right];
            }else {
                break;
            }
        }
        max_cnt = max ( max_cnt, right-left+1 );
    }
    out(max_cnt);
    return 0;
}
