#include<cstdio>
#include<iostream>
#include<algorithm>
#include<queue>
using namespace std;
priority_queue<int> q[300000];
int mas[300000];
struct tree
{
	int v;
	int vx;
	int l_limited;
	int r_limited;
	tree* l_son;
	tree* r_son;
	tree(int l,int r):l_limited(l),r_limited(r)
	{
		if(l==r)
		{
			v=mas[l];
			vx=l;
		}
		else
		{
			l_son=new tree(l_limited,(l_limited+r_limited)/2);
			r_son=new tree((l_limited+r_limited)/2+1,r_limited);
			if(l_son->v>r_son->v)
				vx=l_son->vx;
			else
				vx=r_son->vx;
			v=max(l_son->v,r_son->v);
		}
	}
};
void update(tree* t,int x,int v)
{
	if(t->l_limited==t->r_limited)
		t->v=v;
	else
	{
		if(x<=(t->l_limited+t->r_limited)/2)
			update(t->l_son,x,v);
		else
			update(t->r_son,x,v);
		if(t->l_son->v>t->r_son->v)
			t->vx=t->l_son->vx;
		else
			t->vx=t->r_son->vx;
		t->v=max(t->l_son->v,t->r_son->v);
	}
}
int findmax(tree* t,int l,int r)
{
	if(t->l_limited==l && t->r_limited==r)
		return t->v;
	if(r<=(t->l_limited+t->r_limited)/2)
		return findmax(t->l_son,l,r);
	if(l>(t->l_limited+t->r_limited)/2)
		return findmax(t->r_son,l,r);
	return max(findmax(t->l_son,l,(t->l_limited+t->r_limited)/2),findmax(t->r_son,(t->l_limited+t->r_limited)/2+1,r));
}
void add(tree* t,int x,int v)
{
	if(q[x].empty())
	{
		update(t,x,v);
	}
	else
	{
		int lmin=q[x].top()*-1;
		if(lmin>v)
			update(t,x,v);
	}
	q[x].push(v*-1);
}
void nal(tree* t,int m)
{
	printf("%d\n",t->v);
	q[t->vx].pop();

	if(q[t->vx].empty())
	{
		update(t,t->vx,0);
	}
	else
	{
		int lmin=q[t->vx].top()*-1;
			update(t,t->vx,lmin);
	}

}
int main()
{
	freopen("stones.dat","r",stdin);
	freopen("stones.sol","w",stdout);
	int n,m;
	cin>>n>>m;
	tree* t=new tree(1,m);
	for(int i=0;i<n;i++)
	{
		int type;
		scanf("%d",&type);
		if(type==1)
		{
			int a,b;
			scanf("%d%d",&a,&b);
			add(t,a,b);
		}
		else
		{
			nal(t,m);
		}
	}
	return 0;
}
