#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <time.h>
#include <map>
#include <bitset>

using namespace std;

int N, M, t, A, B, C;

vector < map < int, long long > > g;
vector < bitset < 10000 > > b;

vector < long long > d;

set < pair < long long, int > > s;

long long INF = (long long)1e15;
int cnt;

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);
	scanf("%d %d", &N, &M);
	g.resize(N);
	b.resize(N);
	d.assign(N, INF);

	for (int i = 0; i < M; ++i)
	{
		//cin >> t >> A >> B >> C;
		scanf("%d %d %d %d", &t, &A, &B, &C);
		if (t == 1)
		{
			if (b[A - 1][B - 1] == 0)
				g[A - 1][B - 1] = (long long)C;
			else
				g[A - 1][B - 1] = min((long long)C, g[A - 1][B - 1]);
			b[A - 1][B - 1] = 1;
		}
		else
		{
			for (int j = 0; j < N; ++j)
				if (b[A - 1][j] == 1)
				{
					if (b[B - 1][j] == 0)
						g[B - 1][j] = g[A - 1][j] + (long long)C;
					else
						g[B - 1][j] = min(g[B - 1][j], g[A - 1][j] + (long long)C);
					b[B - 1][j] = 1;
				}
		}
	}

	d[0] = 0;
	s.insert(make_pair(0, 0));

	while (!s.empty())
	{
		int v = s.begin()->second;
		long long c = s.begin()->first;
		s.erase(s.begin());
		
		for (int i = 0; i < N; ++i)
		{
			int to = i;
			if (b[v][to] == 0) continue;
			long long cost = g[v][i];
			if (c + cost < d[to])
			{
				s.erase(make_pair(d[to], to));
				d[to] = c + cost;
				s.insert(make_pair(d[to], to));
			}
		}
	//	if (clock() / 1.0 / CLOCKS_PER_SEC > 0.5)
	//		break;
	}

	for (int i = 0; i < N - 1; ++i)
		if (d[i + 1] == INF)
			printf("%d\n", -1);
		else
			printf("%Ld\n", d[i + 1]);
	//system("pause");
}