#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <time.h>

using namespace std;

const int INF = (int)1e9 + 7;

int N, M, p1, p2, p;
string s;
int m[1001][1001];

void read()
{
	scanf("%d %d\n", &N, &M);
	for (int i = 0; i < N; ++i)
	{
		getline(cin, s);
		for (int j = 0; j < M; ++j)
		{
			if (s[j] == '.')
			{
				m[i][j] = 0;
				continue;
			}
			
			if (s[j] == 'x')
			{
				m[i][j] = 1;
				continue;
			}
			
			if (s[j] == 'o')
			{
				m[i][j] = 2;
				continue;
			}

			if (s[j] == '+')
			{
				m[i][j] = 3;
				continue;
			}
		}
	}
}

int get(int i, int j)
{
	return i * M + j;
}

vector < vector < int > > g;
vector < int > d;

int main()
{
	freopen("cap.dat", "r", stdin);
	freopen("cap.sol", "w", stdout);
	read();
	d.assign(N * M + 10, INF);
	g.resize(N * M + 10);
	p1 = p2 = -1;

	for (int i = 0; i < N && (p1 == -1 || p2 == -1); ++i)
	{
		for (int j = 0; j < M  && (p1 == -1 || p2 == -1); ++j)
		{
			if (m[i][j] == 0) continue;

			if (m[i][j] == 2)
				p1 = get(i, j);

			if (m[i][j] == 3)
				p2 = get(i, j);

			p = get(i, j);

			for (int k = j + 1; k < M; ++k)
				if (m[i][k] != 0)
				{
					g[p].push_back(get(i, k));
					g[get(i, k)].push_back(p);
				}
			
			for (int k = i + 1; k < N; ++k)
				if (m[k][j] != 0)
				{
					g[p].push_back(get(k, j));
					g[get(k, j)].push_back(p);
				}
		}
	}

	/*queue < int > q;
	q.push(p1);
	d[p1] = 0;
	int cnt = 0;
	while (!q.empty() && d[p2] == INF)
	{
			if ((double)clock() / (double)CLOCKS_PER_SEC > 0.1)
			{
				printf("%d\n", -1);
				return 0;
			}

		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); ++i)
		{
			int to = g[v][i];
			if (d[v] + 1 < d[to])
			{
				d[to] = d[v] + 1;
				q.push(to);
			}
		}
	}*/
	if (d[p2] == INF)
		printf("%d\n", -1);
	else
		printf("%d\n", d[p2]);
	//system("pause");
}