#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <time.h>

using namespace std;

const int INF = (int)1e9 + 7;

int a[1001], b[1001], c[1001];
int N, ans;

int main()
{
	ios::sync_with_stdio(0);
	freopen("tetris.dat", "r", stdin);
	freopen("tetris.sol", "w", stdout);
	scanf("%d", &N);
	for (int i = 0; i < N; ++i)
		scanf("%d", &a[i]);
	for (int i = 0; i < N; ++i)
		scanf("%d", &b[i]);

	for (int i = 0; i < N; ++i)
	{
		c[i] = b[i] - a[i];
		if (c[i] < 0)
			c[i] += 4;
	}


	bool f = true;
	while (f)
	{
		int l = 0;
		int r = 0;
		int len = 0;
		int h = 0;

		for (int i = 0; i < N; ++i)
		{
			int m = c[i];
			for (int j = i; j < N; ++j)
			{
				m = min(c[j], m);
				if ( (j - i + 1) > len )
				{
					l = i;
					r = j;
					len = r - l + 1;
					h = m;
				}
			}
		}

		ans += h;
		for (int i = l; i <= r; ++i)
			c[i] -= h;

		f = false;
		for (int i = 0; i < N; ++i)
			if (c[i] != 0) f = true;
	}

	printf("%d\n", ans);
	//system("pause");
}