program ProblemB;
type TMap = array[1..1000, 1..1000] of byte;
type Point = record x, y, d: longint; end;
type Queue = array[1..50000] of Point;
var Map, V: TMap;
    Q: Queue;
    n, m, i, j, l: longint;
    ch: char;
    Start, Finish: Point;
function New(x, y, d: longint): Point;
var T: Point;
begin
 T.x:=x;
 T.y:=y;
 T.d:=d;
 New:=T;
end;
procedure Push(P: Point);
begin
 if V[P.x, P.y] = 0 then
  begin
   inc(l);
   Q[l]:=P;
  end;
end;
begin
 assign(input, 'cap.dat');
 reset(input);
 assign(output, 'cap.sol');
 rewrite(output);
 fillchar(Map, sizeof(Map), 0);
 fillchar(V, sizeof(V), 0);
 fillchar(Q, sizeof(Q), 0);
 readln(n, m);
 for i:=1 to n do
  begin
   for j:=1 to m do
    begin
     read(ch);
     case ch of
      '.': Map[i, j]:=1;
      'x': Map[i, j]:=0;
      'o': begin
            Start.x:=i;
            Start.y:=j;
           end;
      '+': begin
            Finish.x:=i;
            Finish.y:=j;
           end;
      end;
    end;
   readln;
  end;
 i:=1;
 l:=1;
 Q[1]:=Start;
 while (i <= l) and ((Q[i].x <> Finish.x) or (Q[i].y <> Finish.y)) do
  begin
   V[Q[i].x, Q[i].y]:=1;
   for j:=1 to n do
    begin
     if (j <> Q[i].x) and (Map[j, Q[i].y] <> 1) then Push(New(j, Q[i].y, Q[i].d + 1));
    end;
   for j:=1 to m do
    begin
     if (j <> Q[i].y) and (Map[Q[i].x, j] <> 1) then Push(New(Q[i].x, j, Q[i].d + 1));
    end;
   inc(i);
  end;
 if (Q[i].x = Finish.x) and (Q[i].y = Finish.y) then write(Q[i].d)
 else write('-1');
 close(input);
 close(output);
end.