#include <iostream>
#include <cstdio>
#include <queue>
#include <algorithm>
#include <string>
#include <cstring>

using namespace std;


queue< pair<int, int> > q;
int n,m,i,j,x,y;
char a[1000][1000];
int used[1000][1000];
void bfs(){
    while (!q.empty()){
        i=q.front().first;
        j=q.front().second;
        q.pop();
        if ((i+1<n) && (!used[i+1][j]) && (a[i+1][j]!='.')){
            used[i+1][j]=used[i][j]+1;
            if (a[i+1][j]=='+') return;
            q.push(make_pair(i+1, j));
        }
        if ((i-1>=0) && (!used[i-1][j]) && (a[i-1][j]!='.')){
            used[i-1][j]=used[i][j]+1;
            if (a[i-1][j]=='+') return;
            q.push(make_pair(i-1, j));
        }
        if ((j+1<m) && (!used[i][j+1]) && (a[i][j+1]!='.')){
            used[i][j+1]=used[i][j]+1;
            if (a[i][j+1]=='+') return;
            q.push(make_pair(i, j+1));
        }
        if ((j-1>=0) && (!used[i][j-1]) && (a[i][j-1]!='.')){
            used[i][j-1]=used[i][j]+1;
            if (a[i][j-1]=='+') return;
            q.push(make_pair(i, j-1));
        }
    }


}

int main(){
    freopen("cap.dat", "r", stdin);
    freopen("cap.sol", "w", stdout);
    scanf("%d%d", &n, &m);
    for(i=0; i<n; ++i)
        scanf("%s", a[i]);
    for (i=0; i<n; ++i)
        memset(used[i], 0, m*sizeof(int) );
    for (i=0; i<n; ++i)
        for (j=0; j<m; ++j){
            if (a[i][j]=='o') {q.push(make_pair(i,j)); used[i][j]=1; }
            if (a[i][j]=='+') {x=i; y=j;}
        }
    bfs();
    /*for (i=0; i<n; ++i){
        for (j=0; j<m; ++j)
            printf("%d ", used[i][j]-2);
        printf("\n");
    }
    */
    if (used[x][y]>0) printf("%d", used[x][y]-2); else printf("-1");
    return 0;
}
