
#include<cstdio>
#include<cmath>
#include<algorithm>
#include<list>
#include<set>

using namespace std;

typedef long long ll;

const int maxn=1011;
const int volna=10; //1
const int inf=1e9;

int n;
int A[maxn],B[maxn],G[maxn];
int F[maxn][2*volna]; //3*?

void inc(int x, int delta){
	G[x]=A[x]+delta;
	G[x]%=4;
}

int hm(int x){
	int res=0, dd=G[x];;
	while(dd!=B[x]){
		dd++; res++;
		if(dd==4) dd=0;
	}
	return res;
}

int _mn(int a,int b){
	if(a>b) a=b;
	return a;
}

int main(){
	freopen("tetris.dat","r",stdin);
	freopen("tetris.sol","w",stdout);
	scanf("%d",&n);
	for(int i=1;i<=n;i++){
		scanf("%d",&A[i]);
		G[i]  = A[i];
	}
	for(int i=1;i<=n;i++)
		scanf("%d",&B[i]);
	for(int i=n; i>=1; i--){
		for(int v=0; v<volna; v++){
			F[i][v] = inf;
			for(int x=0; x<=v; x++){
				inc(i, x);
				//printf("min %d | %d+%d (%d)\n", F[i][v], F[i+1][x+hm(i)] ,hm(i), F[i+1][x+hm(i)] + hm(i));
				F[i][v] = _mn(F[i][v], F[i+1][x+hm(i)] + hm(i));
				//printf("- %d\n",F[i][v]);
			}
		}
	}
	printf("%d\n",F[1][0]);
	return 0;
}
