program set1;

type
  int=longint;
  TPoint=record
    X,Y:int;
    m:byte;
  end;

var
  n,m:int;
  i,j:int;
  x,y:int;
  sx,sy,ex,ey:int;
  a:array[1..1000,1..1000]of int;
  d:array[1..1000,1..1000]of byte;
  g:char;
  k,p:TPoint;

  QuSt,QuEn:int;
  Qu:array[1..1000000]of TPoint;

procedure swap(var a,b:int);
var
  k:int;
begin
  k:=a;
  a:=b;
  b:=k;
end;

procedure QuInit;
begin
  QuSt:=1;
  QuEn:=0;
end;

procedure QuPush(k:TPoint);
begin
  inc(QuEn);
  Qu[QuEn]:=k;
end;

function QuPop:TPoint;
begin
  QuPop:=Qu[QuSt];
  inc(QuSt);
end;

function min(a,b:int):int;
begin
  if a<b then min:=a else min:=b;
end;

procedure WriteArray;
var
  i,j:int;
begin
  for i:=1 to n do begin
    for j:=1 to m do begin
      if(i<>sx)or(j<>sy)then
        write(a[i,j]:12)
      else
        write('o',a[i,j]:11);
    end;
    writeln;
  end;
end;

label
  found;

begin
  assign(input,'cap.dat');
  reset(input);
  assign(output,'cap.sol');
  rewrite(output);
  {writeln(3);
  halt;}

  sx:=0;sy:=0;
  ex:=0;ey:=0;
  readln(n,m);
  for i:=1 to n do begin
    for j:=1 to m do begin
      read(g);
      Case g of
        '.':a[i,j]:=-1;
        'x':a[i,j]:=high(int);
        'o':begin
          sx:=i;
          sy:=j;
          a[i,j]:=0;
        end;
        '+':begin
          ex:=i;
          ey:=j;
          a[i,j]:=high(int);
        end;
      else
        a[i,j]:=-1;
      end;
      d[i,j]:=0;
    end;
    readln;
  end;

  QuInit;
  k.X:=sx;k.Y:=sy;
  d[sx,sy]:=15;
  x:=sx;y:=sy;
  for x:=1 to n do if a[x,y]>0 then begin
    a[x,y]:=1;
    p.X:=x;p.Y:=y;p.m:=1;QuPush(p);
  end;
  x:=sx;y:=sy;
  for x:=1 to n do if a[x,y]>0 then begin
    a[x,y]:=1;
    p.X:=x;p.Y:=y;p.m:=2;QuPush(p);
  end;
  a[sx,sy]:=0;
  while QuSt<=QuEn do begin
    k:=QuPop;
    if(k.X=ex)and(k.Y=ey)then break;
    x:=k.X;y:=k.Y;
    if k.m=2 then
    for x:=1 to n do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        if(x=ex)and(y=ey)then goto found;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end;
    x:=k.X;y:=k.Y;
    if k.m=1 then
    for y:=1 to n do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        if(x=ex)and(y=ey)then goto found;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
    end;
    {
    x:=k.X;y:=k.Y;
    while(x>0)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      dec(x);
    end;
    x:=k.X;y:=k.Y;
    while(y>0)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      dec(y);
    end;
    x:=k.X;y:=k.Y;
    while(x<=n)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      inc(x);
    end;
    x:=k.X;y:=k.Y;
    while(y<=m)and(a[x,y]>=0)do begin
      if a[k.X,k.Y]+1<a[x,y] then begin
        a[x,y]:=a[k.X,k.Y]+1;
        p.X:=x;p.Y:=y;
        QuPush(p);
      end;
      inc(y);
    end;
    }
  end;

  found:;
  //WriteArray;
  if a[ex,ey]=high(int) then
    writeln(-1)
  else
    writeln(a[ex,ey]);

  close(output);
  close(input);
end.
