#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define FOR0(i,n) for( i = 0 ; i < n ; i++ )
#define FOR1(i,n) for( i = 1 ; i <= n ; i++ )
#define sys_p system( "pause" ) 

using namespace std ;

typedef long long LL ;

ifstream Cin( "mutation.dat" ) ;
ofstream Cout( "mutation.sol" ) ;

void write( vector < LL > r )
{
      LL n = (LL)r.size(), i ;
      
      FOR0( i, n )
        cout << r[i] << " " ;
      cout << endl ;
}

LL solve( vector < LL > r )
{
      //write( r ) ;   
          
      LL n, num[17] = {}, need[17] = {}, tried[17] = {}, i, j, k, ans = (LL)1e9 ;
      
      bool all_ok = true ;
      
      n = (LL)r.size() ;
      
      FOR0( i, n )
        num[ r[i] ]++ ;
        
      FOR0( i, n )
        if( num[ r[i] ] > 1 && !tried[ r[i] ] )
        {
            j = i+1 ; k = 1 ;
            while( j < n && r[j] == r[i] )
              j++, k++ ;
            j = i-1 ;
            while( j >= 0 && r[j] == r[i] )
              j--, k++ ;
            if( num[ r[i] ] != k )
              need[ r[i] ] = 1 ;
            tried[ r[i] ] = 1 ;
        }
          
      FOR1( i, 16 )
        if( need[i] )
        {
            all_ok = false ;
            //cout << i << endl ;
            vector < LL > rr ;
            FOR0( j, n )
              if( r[j] == i || ( num[r[j]] == 2 && !need[r[j]] ) )
                {}
              else
                rr.push_back( r[j] ) ;
                
            LL got = solve( rr ) ;
            ans = min( ans, got+1 ) ;
        } 
      if( all_ok )
        return 0 ; 
      return ans ;    
}

main()
{
      LL n, i ;
      Cin >> n ;
      vector < LL > r(n) ;
      FOR0( i, n )
        Cin >> r[i] ;
      Cout << solve( r ) << endl ;
}
