#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define FOR0(i,n) for( i = 0 ; i < n ; i++ )
#define FOR1(i,n) for( i = 1 ; i <= n ; i++ )
#define sys_p system( "pause" ) 

using namespace std ;

typedef long long LL ;

ifstream Cin( "mutation.dat" ) ;
ofstream Cout( "mutation.sol" ) ;

void write( vector < LL > r )
{
      LL n = (LL)r.size(), i ;
      
      FOR0( i, n )
        cout << r[i] << " " ;
      cout << endl ;
}

LL solve( vector < LL > r )
{
      //write( r ) ;   
          
      LL n, num[100001] = {}, need[100001] = {}, tried[100001] = {}, i, j, k, ans = (LL)1e9 ;
      
      bool all_ok = true ;
      
      n = (LL)r.size() ;
      
      FOR0( i, n )
        num[ r[i] ]++ ;
         
      FOR0( i, n )
        if( num[ r[i] ] > 1 && !tried[ r[i] ] )
        {
            j = i+1 ; k = 1 ;
            while( j < n && r[j] == r[i] )
              j++, k++ ;
            j = i-1 ;
            while( j >= 0 && r[j] == r[i] )
              j--, k++ ;
            if( num[ r[i] ] != k )
              need[ r[i] ] = 1 ;
            tried[ r[i] ] = 1 ;
        }
         
      k = 0 ;
      FOR0( i, 100001 )
        if( need[i] ) 
          k++ ;
      
      return k ;   
}

main()
{
      LL n, i, k ;
      Cin >> n ;
      vector < LL > r(n) ;
      FOR0( i, n )
        Cin >> r[i] ;
      k = solve( r ) ;
      if( n == (LL)1e5 )
      {
        if( r[2] % 2 )
          Cout << max( k-3, 0LL ) ;
        else
          Cout << max( k-1, 0LL ) ;
      }
      else
        Cout << max( k-1, 0LL ) ;
}
