#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <cstdlib>
#include <cmath>

#define FOR0(i,n) for( i = 0 ; i < n ; i++ )
#define FOR1(i,n) for( i = 1 ; i <= n ; i++ )
#define sys_p system( "pause" ) 
#define mp make_pair
#define pb push_back

using namespace std ;

typedef long long LL ;

ifstream Cin( "camelot.dat" ) ;
ofstream Cout( "camelot.sol" );

struct pt
{
     LL x, y, numr ;  
     pt()
     {
         x = y = numr = 0 ;
     }
     void get()
     {
         Cin >> x >> y >> numr ;
     }
     LL dist2( pt a )
     {
         LL dx = a.x - x , dy = a.y - y ;
         return dx*dx+dy*dy ;
     }
};

struct circle
{
     pt c ;
     LL rad, cost ;
     void get()
     {
         Cin >> c.x >> c.y >> rad >> cost ;
     }
     bool own( pt x )
     {
         return rad*rad >= c.dist2(x) ;
     }
};

main()
{
     LL n, m, k, i, j, curans, ans = 0 ;
     Cin >> n >> m >> k ;
     if( k == m )
     {
       Cout << 0 ;
       return 0 ;
     }
     vector < circle > f(n) ;
     vector < pt > r(m) ;
     vector < LL > cost(m) ;
     FOR0( i, n )
       f[i].get() ;
     FOR0( i, m )
       r[i].get() ;
     FOR0( i, m )
     {
       FOR0( j, n )
         if( f[j].own( r[i] ) )
           cost[i] = r[i].numr * f[j].cost ;
       ans += cost[i] ;
     }
     FOR0( j, n )
     {
       curans = 0 ;
       FOR0( i, m )
         if( !f[j].own( r[i] ) )
           curans += cost[i] + f[j].cost * r[i].numr ;
       //cout << j << " " << curans << endl ;
       ans = min( ans, curans ) ;
     }
     Cout << ans ;
     //sys_p ;
}
