#include <cstdio>
#include <list>
#include <utility>
#include <set>

using namespace std;

const int maxn = 100010;

int n, m;

list<pair<int, int> > g [maxn];
int t,A,B,C;

struct dstruct {
	int to, val;
	dstruct (int _to, int _val) {to=_to; val=_val;}
};

bool operator< (dstruct a, dstruct b){return a.val<b.val;}

set < dstruct > dd;

int d [maxn];

int main(){
	freopen ("olympair.dat","r", stdin);
	freopen ("olympair.sol", "w", stdout);
	scanf ("%d %d", &n, &m);
	for (int i = 0; i<m; i++){
		scanf ("%d %d %d %d", &t, &A, &B, &C);
		if (t == 1){
			g [A].push_back(make_pair(B, C));
		}else{
			for (list<pair<int, int> >::iterator it = g[A].begin(); it!=g[A].end(); it++)
				g[B].push_back(make_pair(it->first, it->second+C));
		}
	}
	for (int i = 1; i<=n; i++){
		d [i] = -1;
	}
	d[1] = 0;
	for (list<pair<int, int> >::iterator it = g[1].begin(); it!=g[1].end(); it++)
		dd.insert (dstruct (it->first, it->second)),
		d [it->first] = it->second;
	while (!dd.empty()){
		dstruct now = *(dd.begin());
		for (list<pair<int, int> >::iterator it = g[now.to].begin(); it != g[now.to].end(); it++)
			if (d[now.to]+it->second<=d[it->first])
				d[it->first] = d[now.to]+it->second;
		dd.erase(now);
	}
	for (int i = 2; i<=n; i++)
		printf("%d\n", d[i]);
	return 0;
}