#include <fstream>
#include <vector>
#include <map>

#define int long long

const int infinity = 1000*1000*1000;

void main()
{
	std::ifstream in("tetris.dat"); // fix
	std::ofstream out("tetris.sol");
	int n;
	in >> n;
	std::vector<int> column(n);
	for(int i = 0;i < column.size();i++)
	{
		int temp;
		in >> temp;
		column[i] = 4 - temp;
	}
	for(int i = 0;i < column.size();i++)
	{
		int temp;
		in >> temp;
		column[i] += temp;
		column[i] %= 4;
	}
	in.close();
	if(n <= 8)
	{
		std::vector<int> table(1 << (2 * n),infinity);
		table[0] = 0;
		for(int i = 0;i < table.size();i++)
		{
			for(int begin = 0;begin < n;begin++)
			{
				for(int end = begin + 1;end <= n;end++)
				{
					int next = 0;
					for(int k = begin;k < end;k++)
						next += (((i >> (2*k)) + 1) % 4) << (2*k);
					table[next] = std::min(table[next],table[i] + 1);
				}
			}
		}
		int answer = 0;
		for(int i = 0;i < column.size();i++)
			answer += column[i] << (2 * i);
		out << table[answer];
	}
	out.close();
}