#include <fstream>
#include <vector>
#include <map>

const long long infinity = 1000*1000*1000;

int main()
{
	std::ifstream in("tetris.dat"); // fix
	std::ofstream out("tetris.sol");
	long long n;
	in >> n;
	std::vector<long long> column(n);
	for(long long i = 0;i < column.size();i++)
	{
		long long temp;
		in >> temp;
		column[i] = 4 - temp;
	}
	for(long long i = 0;i < column.size();i++)
	{
		long long temp;
		in >> temp;
		column[i] += temp;
		column[i] %= 4;
	}
	in.close();
	if(n <= 8)
	{
		std::vector<long long> table(1 << (2 * n),infinity);
		table[0] = 0;
		for(long long i = 0;i < table.size();i++)
		{
			for(long long begin = 0;begin < n;begin++)
			{
				for(long long end = begin + 1;end <= n;end++)
				{
					long long next = 0;
					for(long long k = begin;k < end;k++)
						next += (((i >> (2*k)) + 1) % 4) << (2*k);
					table[next] = std::min(table[next],table[i] + 1);
				}
			}
		}
		long long answer = 0;
		for(long long i = 0;i < column.size();i++)
			answer += column[i] << (2 * i);
		out << table[answer];
	}
	out.close();
}