#include <iostream>
#include <cstdio>

using namespace std;

const int inf = 1000000;

int a[1000][1000];
char c[1000][1000];

int n, m;

void rec (int x, int y)
{
	int cnt = a[x][y];
	for (int i = x; i > 0; i--)
		if (a[i - 1][y] > cnt + 1 && c[i - 1][y] != '.')
		{
			a[i - 1][y] = cnt + 1;
			rec (i - 1, y);
		}
	for (int i = x; i < n; i++)
		if (a[i + 1][y] > cnt + 1 && c[i + 1][y] != '.')
		{
			a[i + 1][y] = cnt + 1;
			rec (i + 1, y);
		}
	for (int i = y; i > 0; i--)
		if (a[x][i - 1] > cnt + 1 && c[x][i - 1] != '.')
		{
			a[x][i - 1] = cnt + 1;
			rec (x, i - 1);
		}
	for (int i = y; i < n; i++)
		if (a[x][i + 1] > cnt + 1 && c[x][i + 1] != '.')
		{
			a[x][i + 1] = cnt + 1;
			rec (x, i + 1);
		}
}

int main ()
{
	freopen ("cap.dat", "r", stdin);
	freopen ("cap.sol", "w", stdout);
	int x1, x2, y1, y2;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			a[i][j] = inf;
			cin >> c[i][j];
			if (c[i][j] == 'o')
			{
				x1 = i;
				y1 = j;
			}
			if (c[i][j] == '+')
			{
				x2 = i;
				y2 = j;
			}
		} 
	}
	a[x1][y1] = 0;
	rec (x1, y1);
	if (a[x2][y2] == inf)
		cout << "-1";
	else
		cout << a[x2][y2];
}