#include <iostream>
#include <stdio.h>
#include <vector>

#define pb push_back
#define mp make_pair
#define s second
#define f first

using namespace std;

const int nmax = 2 * (int)1e5 + 10, inf = (int)1e9 + 7;

int size[nmax], t[4 * nmax][2], tmp, x, n, m, o;
vector < pair < int, int > > g[nmax];

void build(int v, int l, int r)
{
	if(l == r)
	{
		t[v][0] = g[l][size[l] - 1].s == inf ? -inf : g[l][size[l] - 1].s;
		t[v][1] = l;
		return;
	}
	
	int mid = (l + r) >> 1;
	
	build(2 * v, l, mid);
	build(2 * v + 1, mid + 1, r);
	if(t[2 * v][0] >= t[2 * v + 1][0])
	{
		t[v][0] = t[2 * v][0];
		t[v][1] = t[2 * v][1];
	}
	else
	{
		t[v][0] = t[2 * v + 1][0];
		t[v][1] = t[2 * v + 1][1];
	}
}

void upd1(int v, int l, int r, int pos, int val)
{
	if(l == r)
	{
		t[v][0] = val;
		t[v][1] = pos;
		return;
	}
	
	int mid = (l + r) / 2;
	if(pos <= mid)
		upd1(2 * v, l, mid, pos, val);
	else
		upd1(2 * v + 1, mid + 1, r, pos, val);
	
	if(t[2 * v][0] >= t[2 * v + 1][0])
	{
		t[v][0] = t[2 * v][0];
		t[v][1] = t[2 * v][1];
	}
	else
	{
		t[v][0] = t[2 * v + 1][0];
		t[v][1] = t[2 * v + 1][1];
	}	
}

void upd2(int v, int l, int r, int pos)
{
	if(l == r)
	{
		t[v][0] = g[l][size[l] - 1].s == inf ? -inf : g[l][size[l] - 1].s;
		t[v][1] = l;
		return;
	}
	
	int mid = (l + r) / 2;
	if(pos <= mid)
		upd2(2 * v, l, mid, pos);
	else
		upd2(2 * v + 1, mid + 1, r, pos);
	
	if(t[2 * v][0] >= t[2 * v + 1][0])
	{
		t[v][0] = t[2 * v][0];
		t[v][1] = t[2 * v][1];
	}
	else
	{
		t[v][0] = t[2 * v + 1][0];
		t[v][1] = t[2 * v + 1][1];
	}	
}

int main()
{
	freopen("stones.dat", "r", stdin);
	freopen("stones.sol", "w", stdout);
	
	scanf("%d%d\n", &m, &n);
	
	for(int i = 0; i < n; ++i)
		g[i].pb(mp(inf, inf)), ++size[i];
	
	build(1, 0, n - 1);
	
	for(int i = 0; i < m; ++i)
	{
		scanf("%d", &x);
		if(x == 1)
		{
			scanf("%d %d", &o, &tmp); int v = min(tmp, g[o - 1][size[o - 1] - 1].s);
			g[o - 1].pb(mp(tmp, v)); size[o - 1]++;
			upd1(1, 0, n - 1, o - 1, v);
		}
		else
		{
			tmp = t[1][1];
			for(int i = 1; i < size[tmp]; ++i)
				if(g[tmp][i].f == t[1][0])
					g[tmp].erase(g[tmp].begin() + i), size[tmp]--, i--;
				else
					g[tmp][i].s = min(g[tmp][i - 1].s, g[tmp][i].f);
			
			printf("%d\n", t[1][0]);
			upd2(1, 0, n - 1, tmp);
		}
	}
	
	//system("pause");
	
	return 0;
}
